indexing
	description: 
	
		"Event to send a chat message"
		
	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_CHAT_MESSAGE

inherit

	EM_NET_2PC_EVENT_OBJECT
		redefine
			make_set_type
		end
	
	
create {BB_MP_OBJECT_TYPES}

	make_set_type

feature -- Initialization

	make_set_type (a_type_id: INTEGER) is
			-- Set `create_type_id' to `a_type_id'.
		do
			Precursor (a_type_id)
			create message.make_empty
			create nickname.make_empty
		end
		
feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_line (nickname)
			a_serializer.put_line (message)
						
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 4	+ nickname.count + 1 + message.count + 1
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			an_unserializer.read_line
			nickname := an_unserializer.last_string
			an_unserializer.read_line
			message := an_unserializer.last_string
			
		end

feature -- Element Change
	
	set_message (a_message: STRING) is
			-- set `message'
		do
			message := a_message
		ensure
			message_set: message = a_message
		end
		
	set_nickname (a_nickname: STRING) is
			-- set `a_nickname'
		do
			nickname := a_nickname
		ensure
			nickname_set: nickname = a_nickname
		end

feature -- Access

	message: STRING
		-- chat message
	
	nickname: STRING
		-- name of player who sent the massage

end
