indexing
	description: 
	
		"Message that a player went game over"
		
	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_GAME_OVER
		
inherit
	
	EM_NET_2PC_EVENT_OBJECT
	
		redefine
			make_set_type
		end
	
create {BB_MP_OBJECT_TYPES}

	make_set_type
		
feature {NONE} -- Initialization

	make_set_type (a_type_id: INTEGER) is
			-- Set `create_type_id' to `a_type_id'.
		do
			precursor (a_type_id)
			
			set_player_name ("")
			
		end

feature -- Status report

	player_name: STRING
			-- nickname
			
feature -- Status setting

	set_player_name (a_name: STRING) is
			-- set `player_name'
		require
			a_name /= Void
		do
			player_name := a_name.out
		ensure
			value_set: player_name.is_equal (a_name)
		end
		
feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_line (player_name)			
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 4 + player_name.count + 1
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			
			an_unserializer.read_line
			set_player_name (an_unserializer.last_string)		
		end


end

