indexing
	description: 
	
		"Message to tell player who received his item effect"
		
	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_ITEM_EFFECT_REPORT

inherit
	
	EM_NET_2PC_EVENT_OBJECT
		redefine
			make_set_type
		end
	
create {BB_MP_OBJECT_TYPES}

	make_set_type
	
feature -- Initialization

	make_set_type (a_type_id: INTEGER) is
			-- Set `create_type_id' to `a_type_id'.
		do
			receiver := ""
			Precursor (a_type_id)	
		end
		
feature -- Access

	set_item_type (an_item_type: INTEGER) is
			-- set the item effect type
		do
			item_type := an_item_type
		ensure
			item_type_set: item_type = an_item_type
		end
		
	set_receiver (a_receiver: STRING) is
			-- set `sender'
		require
			a_receiver /= Void
		do
			receiver := a_receiver.out
		ensure
			value_set: receiver.is_equal (a_receiver)
		end

feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_integer (item_type)
			a_serializer.put_line (receiver)			
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 8	+ receiver.count + 1	
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			an_unserializer.read_integer
			item_type := an_unserializer.last_integer
			an_unserializer.read_line
			set_receiver (an_unserializer.last_string)
			
		end

feature -- Status report
	
	item_type: INTEGER
	
	receiver: STRING
		-- name of player who received this item

invariant
	
	receiver /= Void

end
