indexing
	description: 
	
		"Message to force client to load a level"
		
	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_LOAD_LEVEL

inherit
	
	EM_NET_2PC_EVENT_OBJECT
		redefine
			make_set_type
		end
	
create {BB_MP_OBJECT_TYPES}

	make_set_type
		
feature {NONE} -- Initialization

	make_set_type (a_type_id: INTEGER) is
			-- Set `create_type_id' to `a_type_id'.
		do
			precursor (a_type_id)
			
			set_level ("")
			
		end

feature -- Status report

	level: STRING
			-- nickname
			
feature -- Status setting

	set_level (a_level: STRING) is
			-- set `player_name'
		require
			a_level /= Void
		do
			level := a_level.out
		ensure
			value_set: level.is_equal (a_level)
		end
		
feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_line (level)			
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 4	+ level.count + 1	
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			
			an_unserializer.read_line
			set_level (an_unserializer.last_string)
			
		end

end
