indexing
	description:
	
		 "Message containing player list"

	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_PLAYERLIST

inherit
	
	EM_NET_2PC_EVENT_OBJECT
		redefine
			make_set_type
		end
	
create {BB_MP_OBJECT_TYPES}

	make_set_type

feature {NONE} -- Initialisation

	make_set_type (a_type_id: INTEGER) is
			-- Set `create_type_id' to `a_type_id'.
		do
			Precursor (a_type_id)
			create players.make
		end
		
feature -- Access

	add_player (a_playername: STRING) is
			-- Add player to playerlist
		do
			players.put_last (a_playername)
		end
		
feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_integer (players.count)
			from
				players.start
			until
				players.after
			loop
				a_serializer.put_line (players.item_for_iteration)
				players.forth
			end
			
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 8
			from
				players.start
			until
				players.after
			loop
				Result := Result + players.item_for_iteration.count + 1
				players.forth
			end			
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		local
			i: INTEGER
			count: INTEGER
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			an_unserializer.read_integer
			count := an_unserializer.last_integer
			from
				i := 0
			until
				i >= count 
			loop
				an_unserializer.read_line
				players.put_last (an_unserializer.last_string)
				i := i + 1
			end		
		end


feature -- Status report

	players: DS_LINKED_LIST [STRING]

end
