indexing
	description: 
	
		"Message to server, containing ranking data"
		
	date: "$Date: 2006-03-01 15:30:10 +0100 (Wed, 01 Mar 2006) $"
	revision: "$Revision: 1914 $"

class BB_MP_SCORE_REPORT

inherit
	
	EM_NET_2PC_EVENT_OBJECT
	
create {BB_MP_OBJECT_TYPES}

	make_set_type
	
feature -- Access

	score: INTEGER
		-- score to report
		
	set_score (a_score: INTEGER) is
			-- set `score'
		do
			score := a_score
		ensure
			score_set: score = a_score
		end
		
	remaining_blocks: INTEGER 
		-- remaining destroyable blocks
	
	set_remaining_blocks (an_integer: INTEGER) is	
			-- set `remaining_blocks'
		do
			remaining_blocks := an_integer
		ensure
			value_set: remaining_blocks = an_integer
		end
		
	lifes: INTEGER
		-- remaining lifes
		
	set_lifes (a_lifes: INTEGER) is
			-- set `lifes'
		do
			lifes := a_lifes
		ensure
			lifes_set: lifes = a_lifes
		end		
		
feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'
		do
			a_serializer.put_integer (id)
			a_serializer.put_integer (score)
			a_serializer.put_integer (remaining_blocks)	
			a_serializer.put_integer (lifes)		
		end
		
	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 16
		end
		
	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			an_unserializer.read_integer
			score := an_unserializer.last_integer
			an_unserializer.read_integer
			remaining_blocks := an_unserializer.last_integer
			an_unserializer.read_integer
			lifes := an_unserializer.last_integer
		end

end

