indexing
	description: "A Simple Interface for the elfractal application"
	author: "Lars Krapf"
	date: "$Date: 2007-03-13 23:38:24 +0100 (Tue, 13 Mar 2007) $"
	revision: "$Revision: 2555 $"

class
	EF_SIMPLE_PANEL

inherit
	EM_PANEL
	EM_SHARED_THEME
		export {NONE} all end

create
	make

feature -- Initialization

	make(a_display: EF_3D_DISPLAY; a_history: EF_HISTORY) is
		require
			a_display: a_display /= Void
		do
			-- Initialize Panel
			panel_view := a_display
			panel_history := a_history
			make_from_dimension(200,570)
			set_background_color(create {EM_COLOR}.make_with_rgb(225,225,225))

			--- ### Hier Programmcode fr zustzliche Widgets einfgen (1.4 - 1.8)

		ensure
			panel_s_not_void: panel_view /= Void and panel_history /= Void
		end

feature -- Widgets

	-- A reference to the 3d panel
	panel_view: EF_3D_DISPLAY

	-- A reference to the history panel
	panel_history: EF_HISTORY

	-- Ein Textbox Widget
	textbox_system: EM_TEXTBOX

	-- ### Hier zustzliche Widgets deklarieren... (1.4 - 1.8)

feature {NONE} -- Implementation

	compile_event(an_event: EM_MOUSEBUTTON_EVENT) is
			-- Compile Button has been clicked
		do
			compile
		end

	compile is
			-- Compile the Script and redraw
		do
			panel_view.set_system_string(create {STRING}.make_from_string(textbox_system.text))
			panel_view.set_iterations(0)
			panel_view.create_script

			-- Add a screenshot to the history
			panel_history.add_screenshot(create {STRING}.make_from_string(textbox_system.text))
		end

	change_example(example_string: STRING) is
			-- Change the Example and redraw
		require
			example_string: example_string /= Void
		do
			-- Hier Programmcode fr den selection_changed_event der
			-- Combobox ergnzen (1.8)
		end

end
