indexing
	description: "Objects that save coordinate, color and angle information"
	author: "Lars Krapf"
	date: "$Date: 2007-03-13 23:38:24 +0100 (Tue, 13 Mar 2007) $"
	revision: "$Revision: 2555 $"

class
	EF_STATE

create
	make

feature {NONE} -- Initialization

	make is
			-- Initialize `Current'.
		do
			x := 0.0
			y := 0.0
			z := 0.0
			r := 0.5
			g := 0.5
			b := 0.5
			phi := 0.0
			rho := 0.0
		end


feature -- Element Change

	set_colors(a_r, a_g, a_b: DOUBLE) is
			-- Update colors
		do
			r := a_r
			g := a_g
			b := a_b
		end

	set_coordinates(a_x,a_y,a_z: DOUBLE) is
			-- Update coordinates
		do
			x := a_x
			y := a_y
			z := a_z
		end

	set_angles(a_phi, a_rho: DOUBLE) is
			-- Update angles
		do
			phi := a_phi
			rho := a_rho
		end

feature -- Access

	-- coordinates
	x,y,z: DOUBLE

	-- color
	r,g,b: DOUBLE

	-- angles
	phi,rho: DOUBLE

end
