indexing

	description: "[

		L-Type Fractals in 3D using OpenGL

	]"
	date: "$Date: 2007-03-13 23:38:24 +0100 (Tue, 13 Mar 2007) $"
	revision: "$Revision: 2555 $"

class ROOT_CLASS

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

create

	make

feature {NONE} -- Initialisation

	make is
			-- Start main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- *** Enable required subsystems *** --

			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (800)
			Video_subsystem.set_video_surface_height (600)
			Video_subsystem.set_opengl (true)
			Video_subsystem.enable
			initialize_screen

			-- Check subsystem initialisation
			if
				Video_subsystem.is_enabled
			then

				-- Set global options
				set_window_title ("el Fractal!")
				set_application_id ("elFrac")
				-- set_window_icon ("icon.png")

				create keyboard.make_snapshot
				keyboard.enable_unicode_characters
				keyboard.enable_repeating_key_down_events (200, 100)

				load_eclipse_theme

				-- Set first scene and launch it
				set_scene (create {EF_SCENE}.make)

				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				if not Video_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise video subsystem.%N")
				end
			end
		end

feature {NONE} -- Implementation


end
