indexing

	description: "[

		EiffelMedia Joystick application. Demonstration of the Joystick_Subsystem.

	]"
	date: "$Date: 2006-10-03 10:47:09 +0200 (Tue, 03 Oct 2006) $"
	revision: "$Revision: 2295 $"

class JOYSTICK

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

	EM_SHARED_WIDGET_OPTIONS
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- Initialise screen
			set_window_height (380)
			set_window_width (650)
			set_screen_resolution (32)
			joystick_subsystem.enable
			initialize_screen

			-- Enable unicode characters and repeating keyboard events
			create keyboard.make_snapshot
			keyboard.enable_unicode_characters
			keyboard.enable_repeating_key_down_events (200, 100)

			set_window_title ("Eiffel Media Joystick Subsystem example")
			set_window_icon ("./icon.png")
			set_application_id ("joystick_example")

			-- Set widget theme and options
			widget_options.disable_transparency_refresh
			load_eclipse_theme

			set_scene (create {JOYSTICK_SCENE}.make)
			launch

			-- disable everything we have enabled
			-- this prevent some possible memory leakes by the OS
			joystick_subsystem.disable
			video_subsystem.disable
		end

end
