indexing
	description: "3D font example using OpenGL"
	date: "$Date: 2007-07-11 16:03:30 +0200 (Wed, 11 Jul 2007) $"
	revision: "$Revision: 2609 $"

class
	MAIN_SCENE

inherit

	EM3D_ORTHO_SCENE

	EMGL_BASIC_RENDERER
		export
			{NONE} all
		end

	EMGL_SETTINGS
		export
			{NONE} all
		end

	EM_SHARED_STANDARD_FONTS

	EM3D_SHARED_FONT_FACTORY

	EM_ALIGNMENT_CONSTANTS

	DOUBLE_MATH

create

	make

feature {NONE} -- Initialization

	formats3d: ARRAY [EM3D_FONT_FORMAT]

	strings3d: ARRAY [EM3D_STRING]

	ticks: INTEGER

	make
			-- create the scene
		do
			create formats3d.make (1, 4)
			create strings3d.make (1, 4)

			Em3d_font_factory.create_from_ttf (Standard_ttf_fonts.bitstream_vera_sans_mono (8))
			formats3d[1] := create {EM3D_FONT_FORMAT}.make (Em3d_font_factory.last_font)
			formats3d[1].set_color ([255, 0, 0])
			strings3d[1] := create {EM3D_STRING}.make_with_format (
				"Vera sans Mono 8: The quick brown fox jumps over the lazy dog. ",
				formats3d[1]
			)

			Em3d_font_factory.create_from_ttf (Standard_ttf_fonts.bitstream_vera_sans (12))
			formats3d[2] := create {EM3D_FONT_FORMAT}.make (Em3d_font_factory.last_font)
			formats3d[2].set_color ([0, 255, 0])
			strings3d[2] := create {EM3D_STRING}.make_with_format (
				"Vera sans 12: Franz jagt im total verwahrlosten Taxi quer durch Bayern.",
				formats3d[2]
			)
			Em3d_font_factory.create_from_ttf (Standard_ttf_fonts.bitstream_vera_sans_bold (16))
			formats3d[3] := create {EM3D_FONT_FORMAT}.make (Em3d_font_factory.last_font)
			formats3d[3].set_color ([0, 0, 255])
			strings3d[3] := create {EM3D_STRING}.make_with_format (
				"Vera sans Bold 16: Servez  ce monsieur une bire et des kiwis.",
				formats3d[3]
			)
			Em3d_font_factory.create_from_ttf (Standard_ttf_fonts.bitstream_vera_sans_bold_italic (20))
			formats3d[4] := create {EM3D_FONT_FORMAT}.make (Em3d_font_factory.last_font)
			formats3d[4].set_color ([255, 255, 255])
			strings3d[4] := create {EM3D_STRING}.make_with_format (
				"Vera sans Bold Italic 20: Flygande beckasiner ska hwila p mjuka tufvor.",
				formats3d[4]
			)

			ticks := 0

			make_scene
			-- create camera.make
		end

feature -- Drawing


	draw2d (w, h: DOUBLE) is
			-- do the drawing
		local
			i, k: INTEGER
			y: DOUBLE
			p1, p2, p3, p4: EM_VECTOR3D
			s3d: EM3D_STRING
			f3d: EM3D_FONT_FORMAT
		do
			from i := 1; y := 0 until i > strings3d.count loop
				from k := 4 until k > 24 loop
					formats3d[i].override_point_size (k)
					formats3d[i].enable_point_snapping
					y := y + strings3d[i].height
					strings3d[i].render ([0.0, y, 0.0])
					k := k + 4
				end
				i := i + 1
			end

			p1 := [w / 4.0, h -  4*h/8, 0.0]
			p2 := [w / 4.0, h -  3*h/8, 0.0]
			p3 := [w / 4.0, h -  2*h/8, 0.0]
			p4 := [w / 4.0, h -  1*h/8, 0.0]

			emgl_point_size (2.0)
			emgl_begin (em_gl_points)
			emgl_color3ub (255, 255, 0)
			emgl_vertex3dv (p1.to_pointer)
			emgl_vertex3dv (p2.to_pointer)
			emgl_vertex3dv (p3.to_pointer)
			emgl_vertex3dv (p4.to_pointer)
			emgl_end

			create f3d.make (formats3d[2].font)
			f3d.set_color ([255, 0, 0])
			f3d.enable_point_snapping
			create s3d.make_with_format ("", f3d)
			s3d.set_value ("Left,Top")
			s3d.render_rotated_and_aligned (p1, 0+ticks, [Align_left, Align_top])
			s3d.set_value ("Center,Center")
			s3d.render_rotated_and_aligned (p2, 45+ticks, [Align_center, Align_center])
			s3d.set_value ("Right,Bottom")
			s3d.render_rotated_and_aligned (p3, 90+ticks, [Align_right, Align_bottom])
			s3d.set_value ("User,User=Baseline,Left")
			s3d.render_rotated_and_aligned (p4, 135+ticks, [Align_user_specified, Align_user_specified])

			f3d.make (formats3d[4].font)
			f3d.override_point_size (40)
			s3d.set_value ("Uhu, getting dizzy...")
			emgl_translated (w * 0.75, y, 0.0)
			from
				i := 0
			until
				i > 32
			loop
				f3d.set_color ([
					(cosine (ticks*0.3)*127 + 128).rounded,
					(cosine (ticks*0.4)*127 + 128).rounded,
					(cosine (ticks*0.5)*127 + 128).rounded,
					128
				])
				emgl_push_matrix
					emgl_rotated ((i + ticks) * 3.0, 0, 1, 0)
					emgl_rotated ((i + ticks) * 4.0, 1, 0, 0)
					emgl_rotated ((i + ticks) * 5.0, 0 , 0, 1)
					s3d.render_aligned ([0, 0, 0], [Align_center, Align_center])
				emgl_pop_matrix
				emgl_translated (0, 10, 0)
				i := i + 1
			end

			ticks := ticks + 1
		end

end -- class MAIN_SCENE
