indexing

	description: "[

		Template Project

	]"
	date: "$Date: 2007-04-18 06:49:59 +0200 (Wed, 18 Apr 2007) $"
	revision: "$Revision: 2571 $"

class TEMPLATE

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

create

	make

feature {NONE} -- Initialisation

	make is
			-- Start main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- *** Enable required subsystems *** --

			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (1024)
			Video_subsystem.set_video_surface_height (768)
			Video_subsystem.set_video_bpp (32)
			Video_subsystem.set_fullscreen (false)
			Video_subsystem.set_opengl (true)
			Video_subsystem.enable
			Audio_subsystem.enable
			Network_subsystem.enable
			Joystick_subsystem.enable
			Cdrom_subsystem.enable

			initialize_screen

			-- Check subsystem initialisation
			if
				Video_subsystem.is_enabled and
				Audio_subsystem.is_enabled and
				Network_subsystem.is_enabled and
				Joystick_subsystem.is_enabled and
				Cdrom_subsystem.is_enabled
			then

				-- Set global options
				set_window_title ("EiffelMedia: EM3D Tutorial")
				set_application_id ("EM3D_Tutorial")
				set_window_icon ("icon.png")

				create keyboard.make_snapshot
				keyboard.enable_unicode_characters
				keyboard.enable_repeating_key_down_events (200, 100)

				load_eclipse_theme

				-- *** Set your application's first scene *** --

				-- In our case we chose the tutorial-selection (main) screen
				set_scene (create {MAIN_SCENE}.make)

				launch

				-- Disable subsystems
				Video_subsystem.disable
				Audio_subsystem.disable
				Network_subsystem.disable
				Joystick_subsystem.disable
				Cdrom_subsystem.disable
			else
				if not Video_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise video subsystem.%N")
				end
				if not Audio_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise audio subsystem.%N")
				end
				if not Network_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise network subsystem.%N")
				end
				if not Joystick_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise joystick subsystem.%N")
				end
				if not Cdrom_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise cdrom subsystem.%N")
				end
			end
		end

end
