indexing
	description: "this is a view of a puzzle."
	author: "Stefan Hildenbrand and Team UC"
	date: "$Date: 2007-04-13 15:52:10 +0200 (Fri, 13 Apr 2007) $"
	revision: "$Revision: 2562 $"

class
	UC_PUZZLE_VIEW

inherit
	EM_DRAWABLE_CONTAINER[EM_DRAWABLE]
create
	make_from_puzzle, make_from_other, make

feature -- Initialization
	make_from_other(other: UC_PUZZLE_VIEW) is
			-- initialize this puzzle_view
			-- copy the parts-list from given puzzle_view
			require
				other_not_void: other /= void
			do
				make_from_linear (other)
				image_width := other.image_width
				image_height := other.image_height
				part_height := other.part_height
				part_width := other.part_width
				parts_in_row := other.parts_in_row
			end


	make_from_puzzle(a_puzzle: UC_PUZZLE) is
			-- initialize this puzzle_view with given puzzle
			require
				a_puzzle_is_not_void: a_puzzle /= void
			local
				puzz_cursor: DS_LINKED_LIST_CURSOR[EM_DRAWABLE]
				ppv: UC_PUZZLE_PART_VIEW
				pp: UC_PUZZLE_PART
				k: INTEGER
			do
				make
				create puzz_cursor.make (a_puzzle.part_list)
				image_width := a_puzzle.image_width
				image_height := a_puzzle.image_height
				part_width := a_puzzle.part_width
				part_height := a_puzzle.part_height
				parts_in_row := 5
				k := 0
				from
					puzz_cursor.start
				until
					puzz_cursor.after
				loop
					pp ?= puzz_cursor.item
					if pp /= void then
						create ppv.make_from_puzzle_part (pp)
						ppv.set_x_y ((k\\parts_in_row)*(a_puzzle.part_width+10), (k//parts_in_row)*(a_puzzle.part_height+10))
					end
					extend(ppv)
					puzz_cursor.forth
					k := k+1
				end
			end

feature -- Status
	parts_in_row : INTEGER
		-- how many parts are drawn in a row ?

	copy_parameter_from(other: UC_PUZZLE_VIEW) is
			-- set the parameters according to other
			do
				image_width := other.image_width
				image_height := other.image_height
				part_height := other.part_height
				part_width := other.part_width
				parts_in_row := other.parts_in_row
			end


feature -- Element change

	set_parts_in_row (i: INTEGER) is
			-- set parts_in_row to i
			require
				i_useful : i > 0
			do
				parts_in_row := i
			ensure
				value_set: parts_in_row = i
			end

feature -- puzzle attributes

	image_width : INTEGER
	image_height: INTEGER
		-- size of the image this view was made of

	part_width: INTEGER
	part_height: INTEGER
		-- size of the parts this puzzle was made of



end -- class UC_PUZZLE_VIEW

