indexing
	description: " Shared access to functions used by UC, extends the class ESDL_SHARED_BITMAP_FACTORY"
	author: "Markus Neidhart, nemarkus@student.ethz.ch"
	date: "$Date: 2007-04-13 15:52:10 +0200 (Fri, 13 Apr 2007) $"
	revision: "$Revision: 2562 $"

class
	UC_SHARED_ITEMS

inherit
	EM_SHARED_BITMAP_FACTORY
		export
			{NONE} all
		undefine
			default_create
		end

	SHARED_QUAD_CUTTER
		export
			{NONE} all
		end

feature  -- Singleton Access

	player: MUSIC_PLAYER is
		-- Sound object which plays sound
	once
		create Result.make
	ensure
    		sound_not_void: Result /= Void
	end

feature -- Colors

		uc_background_color: EM_COLOR is
				-- background color
			once
				Result := create {EM_COLOR}.make_with_rgb (255,204,0)
			end

		uc_light_color: EM_COLOR is
				-- light color
			once
				Result := create {EM_COLOR}.make_with_rgb (255,239,186)
			end

		uc_default_button_active_color: EM_COLOR is
				-- default active button color
			once
				Result := create {EM_COLOR}.make_with_rgb (194,40,0)
			end

		uc_default_button_normal_color: EM_COLOR is
				-- default normal button color
			once
				Result := create {EM_COLOR}.make_with_rgb (255,204,0)
			end

		uc_default_button_prelight_color: EM_COLOR is
				-- default prelight button color
			once
				Result := create {EM_COLOR}.make_with_rgb (255,53,0)
			end

		uc_default_button_highlight_color: EM_COLOR is
				-- default highlight button color
			once
				Result := create {EM_COLOR}.make_with_rgb (255,239,186)
			end

		uc_default_button_border_color: EM_COLOR is
				-- default button-border color
			once
				Result := create {EM_COLOR}.make_black
			end

feature -- font
		uc_gui_elements_default_font : EM_FONT is
				-- default font for the gui_elements
			once
				bitmap_factory.create_bitmap_from_image ("./image/default_font.png")
				check
					todo_proper_error_handling: bitmap_factory.last_bitmap /= Void
				end
				Result := create {EM_BMP_FONT}.make (bitmap_factory.last_bitmap)
			end

feature -- Constants

		width: INTEGER is 1024
			-- The width of the screen

		height: INTEGER is 768
			-- The height of the screen

		resolution: INTEGER is 32
			-- The resolution of the scene			
end

