indexing

	description: "[

		This class represents the widget where the SDL surface are drawn.
		Handle this class exactly like if it were inherited from EM_APPLICATION.
		Demonstration of the EiffelMedia Vision2 Widget (EM_EV_WIDGET) Capabilities.

	]"
	date: "$Date: 2006-10-03 10:47:09 +0200 (Tue, 03 Oct 2006) $"
	revision: "$Revision: 2295 $"

class VISION_WIDGET

inherit

	EM_EV_WIDGET_SCROLLABLE
		redefine
			make_em_application
		end

	EM_SHARED_WIDGET_OPTIONS
		export {NONE} all
		undefine
			default_create,
			copy
		end

create

	make

feature {NONE} -- Initialization

	make_em_application is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- Initialise screen
			set_window_width(600)
			set_window_height(630)
			set_opengl (true)
			initialize_screen

			-- Enable unicode characters and repeating keyboard events
			create keyboard.make_snapshot
			keyboard.enable_unicode_characters
			keyboard.enable_repeating_key_down_events (200, 100)

			set_window_title ("EiffelMedia Vision2 Widget Example Project")
			set_window_icon ("icon.png")
			set_application_id ("vision2_example")

			-- set first scene to be shown
			set_scene (create {SIMPLE_SCENE}.make)
			launch

			-- disable everything we have enabled
			-- this prevent some possible memory leakes by the OS
			video_subsystem.disable
		end
end
