indexing

	description: "[

		my_project_description

	]"
	date: "$Date: 2007-02-08 12:05:33 +0100 (Thu, 08 Feb 2007) $"
	revision: "$Revision: 2493 $"

class VIZUALIZE

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

create

	make

feature {NONE} -- Initialisation

	make is
			-- Start main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- *** Enable required subsystems *** --

			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (800)
			Video_subsystem.set_video_surface_height (600)
			Video_subsystem.set_video_bpp (32)
			Video_subsystem.set_fullscreen (false)
			Video_subsystem.set_opengl (true)
			Video_subsystem.enable
			Audio_subsystem.enable
			Network_subsystem.enable
			Joystick_subsystem.enable
			Cdrom_subsystem.enable

			initialize_screen

			-- Check subsystem initialisation
			if
				Video_subsystem.is_enabled and
				Audio_subsystem.is_enabled and
				Network_subsystem.is_enabled and
				Joystick_subsystem.is_enabled and
				Cdrom_subsystem.is_enabled
			then

				-- Set global options
				set_window_title ("EiffelMedia: em3d test")
				set_application_id ("em3d_test")
				set_window_icon ("icon.png")

				create keyboard.make_snapshot
				keyboard.enable_unicode_characters
				keyboard.enable_repeating_key_down_events (200, 100)

				load_eclipse_theme

				-- *** Set your application's first scene *** --

				-- Set first scene and launch it
				set_scene (create {BOX_SCENE}.make)

				launch

				-- Disable subsystems
				Video_subsystem.disable
				Audio_subsystem.disable
				Network_subsystem.disable
				Joystick_subsystem.disable
				Cdrom_subsystem.disable
			else
				if not Video_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise video subsystem.%N")
				end
				if not Audio_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise audio subsystem.%N")
				end
				if not Network_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise network subsystem.%N")
				end
				if not Joystick_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise joystick subsystem.%N")
				end
				if not Cdrom_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise cdrom subsystem.%N")
				end
			end
		end

feature {NONE} -- Implementation

-- *** Set your application's default options *** --

--	Window_width: INTEGER is 640
			-- Window width

--	Window_height: INTEGER is 480
			-- Window height

--	Screen_resolution: INTEGER is 32
			-- Screen resolution

--	Is_fullscreen_enabled: BOOLEAN is false
			-- Is fullscreen enabled?

--	Is_opengl_enabled: BOOLEAN is true
			-- Is OpenGL enabled?

end
