indexing
	description: "Change Setting Action"
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"
	
class
	CHANGE_SETTING
inherit
	ACTION
redefine
	perform
end
	
create
	make

feature {NONE} -- Initialization

	make(psetting: SETTING) is
			-- Initialize `Current'.
		do
			init_condition_lists
			setting := psetting
		end
		
feature -- Access

	perform(e: EVENT; g: GAME) is
			-- perform action on given game Object
		do
			-- change settings in registry
			g.registry.set(setting)
			
			-- visibility of items might have changed, force redraw of scene
			g.items_have_been_changed
			
			-- debug output
			-- io.put_string("action performed: change setting -> ")
			-- io.put_string(setting.to_string)
			-- io.put_new_line
		end

	setting: SETTING

feature {NONE} -- Implementation

end -- class CHANGE_SETTING
