indexing
	description: "Show Scene Action"
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class
	SHOW_SCENE
inherit
	ACTION	
redefine
	perform
end
	
create
	make

feature {NONE} -- Initialization

	make(pscene: SCENE) is
			-- Initialize `Current'.
		do
			init_condition_lists
			scene := pscene
		end
		
feature -- Access

	set_transition(ptransition: STRING) is
			-- set type of transition used when loading the scene
		do
			transition := ptransition
		end
		
	set_angle(pangle: INTEGER) is
			-- set initial view angle for scene
		require
			angle_not_too_small: pangle >= 0
			angle_not_too_big: pangle < 360
		do
			angle := pangle
		end

	perform(e: EVENT; g: GAME) is
			-- perform action on given game Object
		do
			-- update transition and angle:
			scene.set_transition(transition)
			scene.set_angle(angle)
		
			-- redraw of scene forced automatically, no need for g.scene_has_changed
			g.set_current_scene(scene)
			
			-- debug output
			-- io.put_string("action performed: show scene")
			-- io.put_new_line
		end

feature {NONE} -- Implementation

	scene: SCENE
	angle: INTEGER
	transition: STRING

end -- class SHOW_SCENE
