indexing
	description: "[
					Classes that inherit from this abtract class represent conditioned items.
					Actions are conditioned in the sense of performability.
					Items are also conditioned in the sense of visibility.
					
					See ACTION and ITEM for further information.

					This class is part of the XAE Extended Adventure Engine Project.
				  ]"
				  
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

deferred class
	CONDITIONED

feature {NONE} -- Initialization

	init_condition_lists is
			-- Initialize `Current'.
		local
			k: KNF
			d: DNF
		do
			create k.make
			knf := k
			
			create d.make
			dnf := d
		end

feature -- Access

	check_conditions(context: CONTEXT): BOOLEAN is
			-- check conditions (KNF and DNF) for this object
		do
			result := knf.satisfied(context) and dnf.satisfied(context)
		end
		
	knf: CONDITION_LIST
	dnf: CONDITION_LIST

feature {NONE} -- Implementation

end -- class CONDITIONED
