indexing
	description: "[
					This interface class contains all features that are used for communication
					with the GUI. In particular all the state checkers (scene_changed...) and
					features to get current scene or event_occured to pass an Event Object
					to the Engine.

					This class is part of the XAE Extended Adventure Engine Project.
				  ]"
				  
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"
	
deferred class
	ENGINE_INTERFACE

feature -- Access

	event_occured(event: EVENT) is
			-- used by GUI to inform Model about changes
		deferred
		end
		
	get_current_scene:SCENE is
			-- Returns current scene in game context
		deferred
		end
		
	get_closeup: CLOSEUP is
			-- Returns current closeup, otherwise: void
		deferred
		end
		
	get_repository: LIST[ITEM] is
			-- Get list of current repository items
		deferred
		end
		
	scene_changed: BOOLEAN is
			-- checks if scene has changed since last event
		deferred
		end
		
	items_picked_up: BOOLEAN is
			-- checks if scene has changed since last event
		deferred
		end
	
	repository_changed: BOOLEAN is
			-- checks if repositorz has changed since last event
		deferred
		end
		
	set_game(game: GAME) is
			-- load a GAME object into the model
		deferred
		end
	
	get_game: GAME is
			-- get game (for serialization)
		deferred
		end
		
	get_message: STRING is
			-- message (displayed in GUI)
		deferred
		end

end -- class MODEL_INTERFACE
