indexing
	description: "[
					The registry contans most of the game state.
					It is implemented as a hash with string keys and boolean values.
					Checking a setting=true that is not contained in the registry results ind false
					while checking a setting=false that is not conatined in the regsitry
					results in true.

					This class is part of the XAE Extended Adventure Engine Project.
				  ]"
				  
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class
	REGISTRY
create
	make

feature {NONE} -- Initialization

	make(size: INTEGER) is
			-- Initialize `Current'.
		do
			create hash.make(size)
		end
		
feature -- Access
	
	set(setting: SETTING) is
			-- Type your comment here
		do
			-- remove old entry
			hash.remove(setting.key)
			
			-- insert new entry
			hash.put(setting, setting.key)
		end
		
	contains(setting:SETTING): BOOLEAN is
			-- test if setting is set in registry
		local
			s: SETTING
		do
			s := hash.item(setting.key)
			
			Result := false
			if s /= void then
				-- compare value of setting with setting in hash
				Result := (s.value = setting.value)
			else
				Result := not setting.value
			end
		end
		
	debug_output is
			-- print content
		do	
			io.put_string("Registry dump:")
			io.put_new_line
			
			if hash.is_empty then
				io.put_string("empty")
			end

			from
				hash.start
			until
				hash.after
			loop
				io.put_string(hash.item_for_iteration.to_string)
				io.put_new_line
				
				hash.forth
			end
			
			io.put_new_line
		end
	
feature {NONE} -- Implementation

	hash: HASH_TABLE[SETTING, STRING]

end -- class REGISTRY
