indexing
	description: "[
					Repository is used as a container for items.
					Either for items that have been picked up but also
					for used items (trash).

					This class is part of the XAE Extended Adventure Engine Project.
				  ]"
				  
	author: "Adrian Rabenseifner, radrian@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class
	REPOSITORY
create
	make

feature {NONE} -- Initialization

	make(plimit: INTEGER) is
			-- Initialize `Current'.
		do
			create list.make
			limit := plimit
		end

feature -- Access
	
	add_item(item: ITEM) is
			-- add item
		require
			not_full: not full
		do
			list.extend(item)
			changed := true
		end
		
	remove_item(item: ITEM) is
			-- remove item
		do
			from
				list.start
			until
				list.after
			loop
				if equal(item, list.item) then
					list.remove
					changed := true
				else						-- Bugfix 2005/06/26 RW
					list.forth
				end
			end
		end

	dump: LIST[ITEM] is
			-- dump content of registry
		do
			Result := list
		end
	
	contains(item: ITEM): BOOLEAN is
			-- test if registry contains item
		do
			Result := false
			
			from
				list.start
			until
				list.after
			loop
				Result := Result or equal(item, list.item)
				
				list.forth
			end
		end
	
	has_changed: BOOLEAN is
			-- returns if repository has changed since last call of "has_changed"
			do
				Result := changed
				changed := false
			end
	
	debug_output is
			-- print content
		do	
			io.put_string("Reposioty content:")
			io.put_new_line
			
			if list.is_empty then
				io.put_string("empty")
			end
			
			from
				list.start
			until
				list.after
			loop
				io.put_string(list.item.name)
				io.put_new_line
				
				list.forth
			end
			
			io.put_new_line
		end
		
	full: BOOLEAN is
			-- check if repository is full
		do
			Result := (list.count = limit) or (limit = 0)
		end
		
	
feature {NONE} -- Implementation

	list: LINKED_LIST[ITEM]
	changed: BOOLEAN
	
	limit: INTEGER

end -- class REPOSITORY
