indexing
	description: "Serializer class that can handle file operations"
	author: "Philipp Wolfensperger"
	date: "$2005/6/16$"
	revision: "$Revision: 2485 $"

class
	SERIALIZER

create
	make

feature -- Initialization

	make (an_engine: ENGINE_INTERFACE) is
			-- set up engine for serializing
		do
			engine := an_engine
		end
		

feature -- Status setting

	load_game (path: STRING) is
			-- load a savegame file
		local
			game: GAME
		do
			game ?= (create {STORABLE}).retrieve_by_name (path)
			engine.set_game (game)
		end
		
	save_game (path: STRING) is
			-- save current game
		do
			engine.get_game.store_by_name (path)
		end
			
feature {NONE} -- Attributes

	engine: ENGINE_INTERFACE

end -- class SERIALIZER
