indexing
	description: "[
					GUI_DEFAULT_SCENE creates an initial scene which is displayed when
					the xae adventure engine is started.
					
					This class is part of the XAE Extended Adventure Engine Project.
				  ]"

	author: "Ralph Wiedemeier, ralphw@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"


class
	GUI_DEFAULT_SCENE

inherit
	GUI_GAME_SCENE
	export {NONE}
		make_from_game_scene
	redefine
		initialize_scene
	end

create
	make_default_scene


feature -- Initialization

	make_default_scene is
			-- Create default scene
		do
			default_create
			first_background_image := gui_constants.path_panorama_default_1
			second_background_image := gui_constants.path_panorama_default_2

			create clickables.make
			create timers.make

			angle := 45
		end

	initialize_scene is
			-- Additional scene initialization
		do
			Precursor
			game_skin.main_menu.button_save_game.set_disabled

		end

end -- class GUI_DEFAULT_SCENE
