indexing
	description: "[
					Inherit from this class to create drawable objects.
					Drawables must implment 'draw' to draw themselves using
					OpenGL commands. They have a visibility state.

					This class is part of the XAE Extended Adventure Engine Project.
				  ]"

	author: "Ralph Wiedemeier, ralphw@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

deferred class
	GUI_DRAWABLE

inherit
	OPEN_GL_LIBRARY
		export {NONE} all end

feature -- Status

	set_visible is
			-- Set current visible
		do
			is_visible := True
		end

	set_invisible is
			-- Set current invisible
		do
			is_visible := False
		end

	is_visible: BOOLEAN
		-- Is current visible?

feature -- Operations

	draw (a_surface: EM_VIDEO_SURFACE) is
			-- Draws 'current' using OpenGL commands
		require
			valid_surface: a_surface /= Void
		deferred
		end

end -- class GUI_DRAWABLE
