indexing
	description: "[
					GUI_ERROR_DIALOG provides a dialog element of type GUI_CLOSEUP
					for displaying (non recoverable) error messages. 
					
					This class is part of the XAE Extended Adventure Engine Project.
				  ]"
				  
	author: "Ralph Wiedemeier, ralphw@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class
	GUI_ERROR_DIALOG
	
inherit
	GUI_CLOSEUP
	redefine
	end
	
create
	make_with_error_message,
	make_file_not_found
	

feature -- Initialization

	make_with_error_message (a_message: STRING) is
			-- Create new error dialog displaying the specified error message
		local
			error_head: STRING
		do
			error_head := "A non-recoverable error occured. We truly apologize for any inconvenience."
			
			create_frame
			create_image ("images/alert.jpg")
			create_head (error_head)
			create_option (a_message, Void)
			create_option ("Emergency exit", Void)
		end
		
	make_file_not_found (a_path: STRING) is
			-- Create new error dialog displaying a file not found message
		local
			message: STRING
		do
			message := "File not found error: " + a_path
			make_with_error_message (message)
		end
		
feature {NONE} -- Implementation


end -- class GUI_ERROR_DIALOG
