indexing
	description: "[
					GUI_SHARED allows access to the singleton objects
					(globally unique objects) GUI and GUI_CONSTANTS.
					
					This class is part of the XAE Extended Adventure Engine Project.
				  ]"

	author: "Ralph Wiedemeier, ralphw@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"


class
	GUI_SHARED

inherit
	EM_SHARED_BITMAP_FACTORY
	export {NONE} all end


feature  -- Singleton Access

	gui: GUI is
			-- singleton instance of the graphical user interface
		once
			create Result.make
		ensure
			gui_created: Result /= Void
		end

	gui_constants: GUI_CONSTANTS is
			-- singleton instance providing some global constants
		once
			create Result
		ensure
			gui_constants_created: Result /= Void
		end

	gui_timing: GUI_TIMING is
			-- singleton instance providing some timing courve algorithms
		once
			create Result
		ensure
			gui_timing_created: Result /= Void
		end

	game_skin: GUI_GAME_SKIN is
			-- singleton instance of the game skin
		once
			create Result.make
		ensure
			skin_created: Result /= Void
		end

--	fx_texture_1: INTEGER is
	fx_texture_1: EM3D_TEXTURE_2D[ EMGL_FORMAT_RGBA ] is
			-- ID of first texture map used for screenshots
		once
			bitmap_factory.create_empty_open_gl_bitmap (1024, 512)

			-- CHANGES
			-- result := bitmap_factory.last_bitmap.gl_texture
			-- bitmap_factory.last_bitmap.texture.do_not_free_texture
--			bitmap_factory.last_bitmap.texture.save
			create result.make_mipmap_from_surface ( bitmap_factory.last_bitmap )
		end

--	fx_texture_2: INTEGER is
	fx_texture_2: EM3D_TEXTURE_2D[ EMGL_FORMAT_RGBA ] is
			-- ID of second texture map used for screenshots
		once
			bitmap_factory.create_empty_open_gl_bitmap (1024, 512)

			-- CHANGES
			-- result := bitmap_factory.last_bitmap.gl_texture
			-- bitmap_factory.last_bitmap.texture.do_not_free_texture
--			bitmap_factory.last_bitmap.texture.save
--			result := bitmap_factory.last_bitmap.texture.id
			create result.make_mipmap_from_surface ( bitmap_factory.last_bitmap )
		end

end -- class GUI_SHARED
