indexing
	description: "[
					Transition effect.
					Source and destination images appear to be the adjacent
					sides of a rotating cube.
					
					This class is part of the XAE Extended Adventure Engine Project.
				  ]"

	author: "Ralph Wiedemeier, ralphw@student.ethz.ch"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"


class
	GUI_TRANSITION_CUBE

inherit
	GUI_TRANSITION

feature -- Operation

	do_transition (source: GUI_SCENE; destination: GUI_SCENE; surface: EM_VIDEO_SURFACE) is
			-- Scene transition using a rotating cube
		local
			rel_time: INTEGER
			start_time: INTEGER
			angle: DOUBLE
			texture: EM3D_TEXTURE_2D[EMGL_FORMAT_RGBA]
		do
			initialization
			make_snapshots (source, destination)

			emgl_matrix_mode (EM_gl_modelview)
			macro_enable_depth_test
			macro_disable_alpha_blending

			from
				start_time := gui_constants.ticks
				rel_time := 0
			until
				rel_time > duration
			loop
				angle := 90 * gui_timing.smooth (rel_time / duration)
				emgl_load_identity
				emgl_translatef (0, 52, -700-512)
				emgl_rotatef (angle, 0, 1, 0)
				emgl_translatef (0, 0, 512)

				emgl_clear (EM_gl_color_buffer_bit | EM_gl_depth_buffer_bit)
				emgl_enable (EM_gl_polygon_smooth)

				texture := fx_texture_1
				macro_bind_texture_antialiased_replace (texture)
				emgl_begin (EM_gl_quads)
					emgl_tex_coord2d (0.0, 0.0)
					emgl_vertex3d (-512, -256, 0)
					emgl_tex_coord2d (1.0, 0.0)
					emgl_vertex3d ( 512, -256, 0)
					emgl_tex_coord2d (1.0, 1.0)
					emgl_vertex3d ( 512,  256, 0)
					emgl_tex_coord2d (0.0, 1.0)
					emgl_vertex3d (-512,  256, 0)
				emgl_end
				texture.unbind
				texture := fx_texture_2
				macro_bind_texture_antialiased_replace (texture)
				emgl_begin (EM_gl_quads)
					emgl_tex_coord2d (0.0, 0.0)
					emgl_vertex3d (-512, -256, -1024)
					emgl_tex_coord2d (1.0, 0.0)
					emgl_vertex3d (-512, -256, 0)
					emgl_tex_coord2d (1.0, 1.0)
					emgl_vertex3d (-512,  256, 0)
					emgl_tex_coord2d (0.0, 1.0)
					emgl_vertex3d (-512,  256, -1024)
				emgl_end
				texture.unbind

			emgl_disable (EM_gl_polygon_smooth)


			-- CHANGES
			surface.enable_opengl_blitting
			game_skin.draw (surface)
			surface.disable_opengl_blitting
			surface.redraw


				rel_time := gui_constants.ticks - start_time
			end
			destination.reset_scene_time
		end

feature {NONE} -- Implementation

	default_duration: INTEGER is 1500


end -- class GUI_TRANSITION_CUBE
