indexing
	description: 
		"[
			processor for item_node nodes
		 ]"
		
	author: "Steiner Fabrizio"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class ITEM_NODE_PROCESSOR

inherit
	DIMENSIONED_PROCESSOR [ITEM]
	redefine
		Mandatory_attributes
	end
	
create
	make
	
feature -- Access
	name: STRING is "item"
	
	Mandatory_attributes: ARRAY [STRING] is
			-- Table of mandatory attributes
		once
			Result := << "name","default_image","repos_image" >>
			Result.fill (Precursor)
			Result.compare_objects
		end

feature -- Basic operations
	
	create_item():ITEM is
			-- create area item and add it to scene
	local
		scene: SCENE
	do
		scene ?= target
		when_void_set_parent_node_error (scene)
			
		if not has_error then
			result := pool.get_item (attribute("name")) 
			result.set_default_path (pool.get_directory + attribute("default_image")) 
			result.set_repository_path (pool.get_directory + attribute("repos_image")) 
			if has_attribute("description") then
				result.set_description (attribute("description"))
			end
			scene.add_item (result)
		end
	end
		
end