indexing
	description: 
		"[
			processor for keyframe nodes of animation
		 ]"
		
	author: "Steiner Fabrizio"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class KEYFRAME_NODE_PROCESSOR

inherit
	NODE_PROCESSOR
	
create
	make

feature -- Access
	name: STRING is "keyframe"

	Mandatory_attributes: ARRAY [STRING] is
			-- Table of mandatory attributes
		once
			Result := << "time","x","y","base","count","interval" >>
			Result.compare_objects
		end
		
feature -- Basic operations

	process is
			-- Process node.
		local
			animation: ANIMATION
			keyframe: KEYFRAME
		do
			animation ?= target
			when_void_set_parent_node_error (animation)
			
			if not has_error then
				create keyframe.make_with_time (attribute_integer("time"))
				keyframe.set_position (attribute_integer("x"),attribute_integer("y"))
				keyframe.set_cycle_base_image (attribute_integer("base"))
				keyframe.set_cycle_image_count (attribute_integer("count"))
				keyframe.set_cycle_phase_interval (attribute_integer("interval")) 
				
				animation.extend (keyframe) 
			end
		end		
end