indexing
	description: 
		"[
			processor for scene node
		 ]"

	author: "Steiner Fabrizio"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class SCENE_NODE_PROCESSOR 

inherit
	NODE_PROCESSOR
	
create
	make
	
feature -- Access

	Name: STRING is "scene"
			-- Name of node to process

	Mandatory_attributes: ARRAY [STRING] is
			-- Table of mandatory attributes
		once
			Result := << "name","bg1_image" >>
			Result.compare_objects
		end

feature -- Basic operations

	process is
			-- Process node.
		local
			game:GAME
			scene:SCENE
		do
			game ?= target

			when_void_set_parent_node_error (game)
			
			if not has_error then
				scene := pool.get_scene(attribute("name"))
			
				scene.set_background_path (pool.get_directory + attribute("bg1_image"))
				if has_attribute("bg2_image") then
					scene.set_background_path_2(pool.get_directory + attribute("bg2_image"))
				end
				if has_attribute("transition") then
					scene.set_transition (attribute("transition")) 
				end
				if has_attribute("description") then
					scene.set_description(attribute("description"))
				end
				game.add_scene(scene)
				set_target (scene)
			
				if has_subnodes then
					process_subnodes
				end	
			end
		end		
		
end