indexing
	description: 
		"[
			processor for timer nodes
		 ]"
		
	author: "Steiner Fabrizio"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class TIMER_NODE_PROCESSOR

inherit
	NODE_PROCESSOR

create
	make
	
feature -- Access
	
	name: STRING is "timer"

	Mandatory_attributes: ARRAY [STRING] is
			-- Table of mandatory attributes
		once
			Result := << "timeout" >>
			Result.compare_objects
		end

feature -- Basic operations

	process is
			-- Process node.
		local
			scene: SCENE
			timer: TIMER
		do
			scene ?= target
			
			when_void_set_parent_node_error (scene)
			
			if not has_error then
				create timer.make (attribute_integer("timeout"))
			
				if has_attribute("name")  then
					timer.set_name (attribute("name")) 
				end
				scene.add_timer (timer) 
				set_target(timer)
				
				if has_subnodes then
					process_subnodes
				end
			end
		end		
end