indexing
	description:
		"[
			Error constants used for XML parsing.
		 ]"

	status:	"See notice at end of class"
	author: "Patrick Schoenbach, Michela Pedroni"
	date: "$Date: 2007-02-05 18:24:28 +0100 (Mon, 05 Feb 2007) $"
	revision: "$Revision: 2485 $"

class PARSE_ERROR_CONSTANTS inherit

	ERROR_CONSTANTS

feature {NONE} -- Access

	error_text (a_code: INTEGER): STRING is
			-- Raw error text for error `a_code'
		do
			inspect
				a_code
			when Unknown_subnode then
				Result := "Unknown subnode <$>"
			when Mandatory_attribute_missing then
				Result := "Mandatory attribute <$> missing"
			when Unknown_node_processor then
				Result := "Unknown node processor '$'"
			when Wrong_attribute_type then
				Result := "Wrong attribute type <$>"
			when Wrong_property_value then
				Result := "Wrong property value '$'"
			when File_not_readable then
				Result := "File '$' not readable"
			when Incorrect_property then
				Result := "Incorrect property <$>"
			when Invalid_parent_node then
				Result := "Invalid parent node <$>"
			else
				Result := "Unknown error"
			end
		end

feature {NONE} -- Constants

	Unknown_subnode: INTEGER is 1

	Mandatory_attribute_missing: INTEGER is 2
	
	Unknown_node_processor: INTEGER is 3

	Wrong_attribute_type: INTEGER is 4

	Wrong_property_value: INTEGER is 5
	
	Incorrect_property: INTEGER is 6
	
	File_not_readable: INTEGER is 7
	
	Invalid_parent_node: INTEGER is 8
	
end
