indexing

	description: "[

		This class holds all audio constants.
		
		Use this constants for setting up mixer environment.
		Some values are specified by SDL and should not be changed
		for compatibility reasons.

	]"
	date: "$Date: 2005-10-22 15:22:42 +0200 (Sat, 22 Oct 2005) $"
	revision: "$Revision: 1084 $"

class EM_AUDIO_CONSTANTS

feature -- Default constants

	Em_max_volume: INTEGER is 128
			-- Maximum value for any volume setting.

	Em_default_frequency: INTEGER is 22050
			-- Default frequency for mixer.

	Em_default_chunk_size: INTEGER is 4096
			-- Default chunk size for mixer.

	Em_channel_postmix: INTEGER is -2
			-- Postmix processing channel.

feature -- Fading music

	Em_fading_out: INTEGER is 1
			-- Fade out value.

	Em_fading_in: INTEGER is 2
			-- Fade in value.

feature -- Output channels

	Em_mono: INTEGER is 1
			-- Value for mono output.

	Em_stereo: INTEGER is 2
			-- Value for stereo output.

feature -- Audio types

	Em_music_none: INTEGER is 0
			-- No music.

	Em_music_command: INTEGER is 1
			-- Music using external command.

	Em_music_wave: INTEGER is 2
			-- WAVE/RIFF music.

	Em_music_mod: INTEGER is 3
			-- MOD music.

	Em_music_midi: INTEGER is 4
			-- MIDI music.

	Em_music_ogg: INTEGER is 5
			-- OGG music.

	Em_music_mp3: INTEGER is 6
			-- MP3 music.

feature -- Audio formats

	Em_audio_format_u8: INTEGER is
			-- Unsigned 8-bit samples
		external
			"C macro use <em.h>"
		alias
			"AUDIO_U8"
		end

	Em_audio_format_s8: INTEGER is
			-- Signed 8-bit samples
		external
			"C macro use <em.h>"
		alias
			"AUDIO_S8"
		end

	Em_audio_format_u16lsb: INTEGER is
			-- Unsigned 16-bit samples little-endian byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_U16LSB"
		end

	Em_audio_format_s16lsb: INTEGER is
			-- Signed 16-bit samples little-endian byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_S16LSB"
		end

	Em_audio_format_u16msb: INTEGER is
			-- Unsigned 16-bit samples big-endian byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_U16MSB"
		end

	Em_audio_format_s16msb: INTEGER is
			-- Signed 16-bit samples big-endian byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_S16MSB"
		end

	Em_audio_format_u16: INTEGER is
			-- Unsigned 16-bit samples
		external
			"C macro use <em.h>"
		alias
			"AUDIO_U16"
		end

	Em_audio_format_s16: INTEGER is
			-- Signed 16-bit samples
		external
			"C macro use <em.h>"
		alias
			"AUDIO_S16"
		end

	Em_audio_format_u16sys: INTEGER is
			-- Unsigned 16-bit samples with system byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_U16SYS"
		end

	Em_audio_format_s16sys: INTEGER is
			-- Signed 16-bit samples with system byte order
		external
			"C macro use <em.h>"
		alias
			"AUDIO_S16SYS"
		end

end