indexing

	description: "[

		Deferred class for audio streaming.
		
		Inherit from this class if you're implementing another stream.
		The hook_music_function will be called whenever the player needs
		sound data.

	]"
	date: "$Date: 2006-08-22 17:30:04 +0200 (Tue, 22 Aug 2006) $"
	revision: "$Revision: 2200 $"

deferred class

	EM_AUDIO_STREAM

inherit

	SDL_MIXER_FUNCTIONS
		export {NONE} all end

	EM_VOID_VOIDP_UINT8P_INT_CALLBACK
		rename on_callback as hook_music_function
		export {NONE} all end

feature -- Callback

	hook_music_function (a_userdata: POINTER; a_stream: POINTER; a_length: INTEGER) is
			-- Function called when player need sound data.
			--
			-- Fill `a_stream' with up to `a_length' bytes of sound.
			--
			-- `a_userdata' may hold additional data passed in by the user
			-- when stream was created.
			--
			-- Note: `a_stream' has to be filled corresponding to the mixer settings.
			--		 Otherwise, music may and will sound funny.
		deferred
		end

	music_hook_data: POINTER is
			-- Actual stream data from player
		do
			Result := mix_get_music_hook_data_external
		end

end