indexing

	description: "[

		Implements callback for finished channels.
		
		Create a new object of this class if you want to receive
		channel finished callbacks.
		
		You have to subscribe to the channel_finished event.

	]"
	date: "$Date: 2006-08-22 16:36:46 +0200 (Tue, 22 Aug 2006) $"
	revision: "$Revision: 2198 $"

class EM_CHANNEL_FINISHED

inherit

	EM_VOID_INT_CALLBACK_CALLBACK
		export {NONE} all end

	SDL_MIXER_FUNCTIONS_EXTERNAL
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Initialize new channel finished object.
		local
			d: EM_VOID_INT_CALLBACK_DISPATCHER
		do
			create d.make (Current)
			mix_channel_finished_external (d.c_dispatcher)
			create channel_finished
		end

feature {NONE} -- Callback

	on_callback (a_channel: INTEGER) is
			-- Feature is called whenever a channel finishes playback.
			-- We publish the event to all subscribers.
		do
			channel_finished.publish ([a_channel + 1])
		end

feature -- Event

	channel_finished: EM_EVENT_CHANNEL [TUPLE [INTEGER]]
			-- Event fired when channel finishes playback.

end