indexing

	description: "[

		Implements callback for finished music.
		
		Create a new object of this class if you want to receive
		music finished callbacks.
		
		You have to subscribe to the music_finished event.

	]"
	date: "$Date: 2006-08-22 16:36:46 +0200 (Tue, 22 Aug 2006) $"
	revision: "$Revision: 2198 $"

class EM_MUSIC_FINISHED

inherit

	EM_VOID_VOID_CALLBACK_CALLBACK
		export {NONE} all end

	SDL_MIXER_FUNCTIONS_EXTERNAL
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Initialize new music finished object
		local
			d: EM_VOID_VOID_CALLBACK_DISPATCHER
		do
			create d.make (Current)
			mix_hook_music_finished_external (d.c_dispatcher)
			create music_finished
		end

feature {NONE} -- Callback

	on_callback is
			-- This feature is called when music stops playing.
			-- All subscribers will be notified about the event.
		do
			music_finished.publish ([])
		end

feature -- Events

	music_finished: EM_EVENT_CHANNEL [TUPLE []]
			-- Event is fired when music finishes playing.

end