indexing
	description: "A generic parent class for all interpolators"
	date: "$Date: Jan 6, 2007 9:36:36 AM$"
	revision: "$Revision: 1.0$"

deferred class EM_GENERIC_INTERPOLATOR[ G ]

inherit
	ANY

feature

	sequence: ARRAY[G]
	set_sequence (a_sequence: like sequence) is
			-- Set `sequence' to `a_sequence'.
		require
			a_sequence_not_void: a_sequence /= Void
		do
			sequence := a_sequence
		ensure
			definition_of_set_sequence: sequence = a_sequence
			sequence_not_void: sequence /= Void
		end

	is_valid_animation_position( t: DOUBLE ):BOOLEAN is
			-- Is t a valid animation step? That means
			-- is t defined by sequence
		do
			result := 0 <= t and t <= sequence.count-1
		end

	interpolate( a_position: DOUBLE ): G is
			-- Interpolate at 'a_potision'
		require
			valid_position: is_valid_animation_position( a_position )
		deferred
		end

end -- class EM_INTERPOLATOR
