indexing
	description: "[
			A spherical linear interpolator.
			Eg (interpolation between a and b; c: angle between a and b )
				r = t*b+(1-t)*a
		]"
	date: "$Date: Jan 6, 2007 9:55:51 AM$"
	revision: "$Revision: 1.0$"

class EM_QUATERNION_SLERP

inherit
	EM_QUATERNION_INTERPOLATOR
		redefine
			interpolate
		end
	DOUBLE_MATH
		export {NONE} all end

feature -- Implementation
	interpolate( t: DOUBLE ): EM_QUATERNION is
			-- Interpolate linear
		local
			a, tt, sa: DOUBLE
			q: EM_QUATERNION
		do
			tt := t-t.floor
			result := sequence.item(t.floor + sequence.lower)
			q := sequence.item(t.ceiling + sequence.lower)
			a := result.cutting_angle( q ).abs()
			if a > pi/2 then
				a := pi-a
				q := -q
			end
			sa := sine(a)
			if sa<0.05 then
				result.scale( 1-tt )
				q.scale( tt )
			else
				sa := 1 / sa
				result.scale( sine((1-tt)*a)*sa )
				q.scale( sine(tt*a)*sa )
			end
			result := result + q
		end

end -- class EM_QUATERNION_SLERP
