indexing
	description: "Objects that ..."
	author: ""
	date: "$Date: 2007-05-26 09:11:23 +0200 (Sat, 26 May 2007) $"
	revision: "$Revision: 2593 $"

deferred class
	EM3D_RESOURCE_FACTORY[ G->EM3D_RESOURCE ]

inherit
	EM_SHARED_ERROR_HANDLER
		export {NONE} all
		end
	KL_SHARED_FILE_SYSTEM

feature {NONE} -- Initialization
	make( a_scene_manager: like scene_manager ) is
			-- Create a new MATERIAL_FACTORY object loading only 'a_filename'
		do
			create resources.make_default
			create loaded_files.make_default
			scene_manager := a_scene_manager
		end

feature -- Object creation
	new_resource ( a_resource_name: STRING ) : G is
			-- Get a new mesh
		do
			if resources.has ( a_resource_name ) then
				result := resources.item ( a_resource_name )
			end
		end
feature {NONE} -- load mesh
	scene_manager: EM3D_SCENE_MANAGER
	resources: DS_HASH_TABLE[ G, STRING ]
	loaded_files: DS_HASH_SET[ STRING ]
	add_resource( a_resource: G; a_name: STRING ) is
			-- Add a new resource
		do
			if resources.has ( a_name ) then
				error_handler.raise_warning ( error_codes.em_error_em3d_resource_factory, ["More than one resource called '"+a_name+"'"] )
			end
			resources.force ( a_resource, a_name )
		end
	load_resource_internal( a_filename: STRING ) is
			-- Load a material from a file
		require
			valid_file_name: a_filename /= void
			file_exists: file_system.file_exists( a_filename )
		deferred
		end

feature -- Object creation
	load_resource( a_filename: STRING ) is
			-- Load a material from a file
		require
			valid_file_name: a_filename /= void
			file_exists: file_system.file_exists( a_filename )
		do
			if not loaded_files.has( a_filename ) then
				loaded_files.force( a_filename )
				load_resource_internal( a_filename )
			end
		end


end
