indexing
	description: "[
			A face is a triangle of an object. It consists of 3 Points
			Note: This implementation of face is not very fast (unable to use CVA)
			      The implementation might change in the future
		]"
	date: "$Date$"
	revision: "$Revision$"
class
	EM3D_FACE_REF

create
	make
feature -- Initialization
	make( a_mesh: EM3D_MESH ) is
			-- Create a EM3D_FACE for 'a_mesh'
		require
			a_valid_mesh: a_mesh /= void
		do
			mesh := a_mesh
		end

feature -- Status
	plane: EM_PLANE
		-- A plange equation descibing the face
	index1, index2, index3: INTEGER
		-- Three indices describing the three corners of the face
	visible: BOOLEAN
		-- Is the face visible?
	neighbor_faces: EM_VECTOR3I
		-- We want to know who our neighbors are
	mesh: EM3D_MESH

feature -- Status setting
	compute_plane is
			-- Compute the plane decribed by this face
		do
			plane := [mesh.vertices[index1],
					  mesh.vertices[index2],
					  mesh.vertices[index3]]
		end
	set_plane (a_plane: EM_PLANE) is
				-- Set `plane' to `a_plane'.
		require
			a_plane_not_void: a_plane /= Void
		do
			plane := a_plane
		ensure
			definition_of_set_plane: plane = a_plane
			plane_not_void: plane /= Void
		end
	set_indices ( i1, i2, i3: like index1) is
				-- Set `indices' to `a_indices'.
		do
			index1 := i1
			index2 := i2
			index3 := i3
		end
	set_visible (a_visible: like visible) is
				-- Set `visible' to `a_visible'.
		do
			visible := a_visible
		ensure
			definition_of_set_visible: visible = a_visible
		end
	set_neighbor_faces (a_neighbor_faces: like neighbor_faces) is
				-- Set `neighbor_faces' to `a_neighbor_faces'.
		do
			neighbor_faces := a_neighbor_faces
		ensure
			definition_of_set_neighbor_faces: neighbor_faces = a_neighbor_faces
		end


end
