indexing
	description: "[

		Implements support routines for classes of objects which have a position.

	]"
	date: "$Date: Oct 15, 2006 11:52:02 PM$"
	revision: "$Revision: 1.0$"

class EM3D_POSITIONABLE

inherit
	EM3D_TRANSFORMABLE

feature -- Status


	position: EM_VECTOR3D is
		do
			result := transformation.row (4)
		end

		-- Describes the local postition, relative to the parent entity
	set_position (a_position: EM_VECTOR3D) is
				-- Set `position' to `a_position'.
		local
			tmp: EM_VECTOR4D
		do
			tmp := a_position
			tmp.w := 1
			transformation.set_row ( tmp, 4)
		ensure
			definition_of_set_position: position = a_position
		end

	translate(a_translation: EM_VECTOR3D) is
				-- Move the object with a vector.
		do
			set_position( a_translation + position )
		end

end -- class EM3D_POSITIONABLE
