indexing
	description: "[
			A basic camera object
		]"
	date: "$Date: Jul 12, 2006 10:38:01 AM$"
	revision: "$Revision: 1.0$"

-- TODO: Automatically set the correct aspect...
class EM3D_CAMERA

inherit

	EM3D_FRUSTUM
		redefine
			default_name,
			type
		end
	EMGL_VIEW
		export {NONE} all
		undefine copy, is_equal end
	EMGLU_VIEW
		export {NONE} all
		undefine copy, is_equal end

create
	make

feature -- Status
	up: EM_VECTOR3D
	is_local_up: BOOLEAN
	target: EM3D_TARGET

feature {NONE}
	default_name: STRING is
		once
			result := "CAMERA"
		end
	type: INTEGER is
		once
			result := em3d_camera_identified
		end


feature -- Commands
	set_up( value: like up ) is
			-- Specify the up vector
		do
			up := value
		end
	set_is_local_up( value: like is_local_up ) is
			-- Specify if up vector is in local or global coorinates
		do
			is_local_up := value
		end
	set_target( value: like target ) is
			-- Specify the target to look at
		do
			target := value
		end

feature --OpenGL
	set_opengl is
			-- Set the camera to the actual Matrix
		local
			c,u,p: EM_VECTOR3D
		do
			p := world_position
			if target = void then
				c := p + [0,0,-1]
			else
				c := target.position
			end
			if is_local_up then
				u := world_transformation.mult ( up )
			else
				u := up
			end

			emgl_matrix_mode( em_gl_projection )
			emgl_load_identity
			if projection_type = em3d_perspective then
				emglu_perspective( fovy, aspect, near_dist, far_dist )
			else
				emgl_ortho( left, right, bottom, top, near_dist, far_dist )
			end
			emgl_matrix_mode( em_gl_modelview )
			emgl_load_identity
			emglu_look_at ( p.x, p.y, p.z,
							c.x, c.y, c.z,
							u.x, u.y, u.z)
		end

end -- class EM3D_CAMERA
