indexing

	description: "[

		An EM_GOOF_FORCE that pulls in a specified 'force_direction' witch is
		the same for all points in the level.

	]"
	date: "$Date: 2005-10-23 11:39:25 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1116 $"

deferred class

	EM_GOOF_DIRECTIONAL_FORCE

inherit

	EM_GOOF_GENERAL_FORCE

feature {EM_GOOF_FORCE, EM_GOOF_PHYSICS} -- Properties

	force_direction: EM_VECTOR_2D
		-- Direction in with the directional force pulls

	set_force_direction(a_force_direction: EM_VECTOR_2D) is
			-- Set force direction
		require
			a_force_direction_not_void: a_force_direction /= void
		do
			force_direction := a_force_direction
		ensure
			force_direction_set: force_direction = a_force_direction
		end

feature {EM_GOOF_FORCE, EM_GOOF_PHYSICS} -- Processing

	process_object(object: EM_GOOF_PHYSICABLE) is
			-- Apply force to this object
		local
			force_vector: EM_VECTOR_2D
		do
			force_vector := force_direction.twin
			force_vector.stretch (object_dependant_factor(object),object_dependant_factor(object))
			object.force.add(force_vector)
		end

	object_dependant_factor(object: EM_GOOF_PHYSICABLE): DOUBLE is
			-- 	Object dependant factor in the force equasion (mass in case of gravity)
		require
			is_object: object /= void
		deferred
		end

invariant
	force_direction_not_void: force_direction /= void
end