indexing

	description: "[

		An EM_GOOF_LOADER_NODE_PROCESSOR to load the EM_GOOF_XY_TRANSPORT from xml file.

	]"
	date: "$Date: 2005-10-23 12:31:22 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1124 $"

class
	EM_GOOF_LOADER_OBJECT_XY_TRANSPORT_NODE_PROCESSOR

inherit

	EM_GOOF_LOADER_OBJECT_XY_VEHICLE_NODE_PROCESSOR
	undefine
		make,
		process,
		Name,
		Mandatory_attributes
	end

create

	make

feature -- Initialization

	make is
			-- Make 'Current'
		do
			Precursor
			Current.register_allowed_subnode ("xy", name)
		end

feature -- Access

	Name: STRING is
			-- Name of element to process
		do
			Result := "transport"
		end

	Mandatory_attributes: ARRAY [STRING] is
			-- Table of mandatory attributes
		once
			Result := << "image" >>
			Result := << "x" >>
			Result := << "y" >>
			Result.compare_objects
		end

feature -- Basic operations

	process is
			-- Process node.
		local
			transport: EM_GOOF_XY_TRANSPORT
		do
			if not has_attribute ("image") then
				set_error (Mandatory_attribute_missing, << "image" >>)
			elseif not has_attribute ("x") then
				set_error (Mandatory_attribute_missing, << "x" >>)
			elseif not has_attribute ("y") then
				set_error (Mandatory_attribute_missing, << "y" >>)
			elseif not attribute("x").is_double then
				set_error (Non_numeric_argument, << "x" >>)
			elseif not attribute("y").is_double then
				set_error (Non_numeric_argument, << "y" >>)
			else
				create transport.premake
				load_images(transport)

				if parent.container /= void then
					parent.container.add_item(transport)
				else
					level.add_object(transport)
				end
				container := transport

				load_vehicle(transport)
				load_physicable(transport)
				load_name(transport)
				load_collidable(transport)
			end
		end

end