indexing

	description: "[

		This class represents the status of a hat of a joystick

	]"
	date: "$Date: 2005-10-23 11:58:45 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1117 $"

class EM_JOYSTICK_HAT

inherit

	EM_CONSTANTS

feature -- Queries

	is_hat_leftup: BOOLEAN is
			-- is hat in state `leftup'?
		do
			result := value = em_joystick_hat_leftup
		end

	is_hat_up: BOOLEAN is
			-- is hat in state `up'?
		do
			result := value = em_joystick_hat_up
		end

	is_hat_rightup: BOOLEAN is
			-- is hat in state `rightup'?
		do
			result := value = em_joystick_hat_rightup
		end

	is_hat_left: BOOLEAN is
			-- is hat in state `left'?
		do
			result := value = em_joystick_hat_left
		end

	is_hat_centered: BOOLEAN is
			-- is hat in state `centered'?
		do
			result := value = em_joystick_hat_centered
		end

	is_hat_right: BOOLEAN is
			-- is hat in state `right'?
		do
			result := value = em_joystick_hat_right
		end

	is_hat_leftdown: BOOLEAN is
			-- is hat in state `leftdown'?
		do
			result := value = em_joystick_hat_leftdown
		end

	is_hat_down: BOOLEAN is
			-- is hat in state `down'?
		do
			result := value = em_joystick_hat_down
		end

	is_hat_rightdown: BOOLEAN is
			-- is hat in state `rightdown'?
		do
			result := value = em_joystick_hat_rightdown
		end

	value: INTEGER is
			-- return the current value of the respective hat
			-- in this event
			-- The value range is a INTEGER representing the hat's direction
		do
			result := internal_value
		end

feature {EM_JOYSTICK} -- Seters

	set_value (a_value: like value) is
			-- set `value' to `a_value'
		do
			internal_value := a_value
		ensure
			value_set: internal_value = a_value
		end

feature {NONE} -- Implementation

	internal_value: INTEGER
			-- value of `value'

end