#ifndef __EM_AUDIO__
#define __EM_AUDIO__

#include <macro_definitions.h>
#ifdef __INCLUDE_EM_AUDIO__

#include <SDL.h>
#include <SDL_mixer.h>

#include <stdlib.h>

#ifndef __AUDIO_MOVIE_DATA_STRUCT__
#define __AUDIO_MOVIE_DATA_STRUCT__
typedef struct {
	int playing;
	char* buffer;
	int size;
	int* start;
	int* end;
	char* empty;
} audio_movie_data_struct;

void add_audio_movie_stream_callback (audio_movie_data_struct *userdata);
#endif

/* audio event types */
#ifndef __AUDIO_FUNCTIONS__
#define __AUDIO_FUNCTIONS__

enum {

    AUDIO_CHANNELFINISHEDEVENT = 20,          // Fired on channel finished callback
    AUDIO_MUSICFINISHEDEVENT = 21,            // Fired on music finished callback
};

/* audio callback and event functions */
void audio_channel_finished_callback (int chan);
void add_audio_channel_finished_callback ();

void audio_music_finished_callback ();
void add_audio_music_finished_callback ();

int get_sdl_user_event_type (SDL_Event *e);
int get_audio_channel (SDL_Event *e);

#endif // __AUDIO_FUNCTIONS__

#endif // __INCLUDE_EM_AUDIO__
#endif // __EM_AUDIO__

