#include <em_audio.h>
#ifdef __INCLUDE_EM_AUDIO__

#include <string.h>

void audio_movie_stream_callback (audio_movie_data_struct *userdata, char* stream, int length) {
	int nb;
	while (!(userdata->playing)) { SDL_Delay (100); }
	nb = (*(userdata->end) - *(userdata->start) + userdata->size) % userdata->size;
	if (nb >= length) nb = length;
	else {
		memcpy (stream + nb, userdata->empty, length - nb);
	}
	if (*(userdata->start) + nb < userdata->size) {
		memcpy (stream, userdata->buffer + *(userdata->start), nb);
	} else {
		memcpy (stream, userdata->buffer + *(userdata->start), userdata->size - *(userdata->start));
		memcpy (stream + userdata->size - *(userdata->start), userdata->buffer, nb - userdata->size + *(userdata->start));
	}
	*(userdata->start) = (*(userdata->start) + nb ) % userdata->size;
}

void add_audio_movie_stream_callback (audio_movie_data_struct *userdata)
{
	Mix_HookMusic ((void (*)(void*, Uint8*, int)) &audio_movie_stream_callback, userdata);
}


// audio: channel finished callback, raises SDL user event
void audio_channel_finished_callback (int chan)
{
	SDL_Event event;
	event.type = SDL_USEREVENT;
	event.user.code = AUDIO_CHANNELFINISHEDEVENT;
	event.user.data1 = chan;
	event.user.data2 = 0;
	SDL_PushEvent(&event);
}

// audio: register channel finished callback
void add_audio_channel_finished_callback ()
{
	Mix_ChannelFinished (audio_channel_finished_callback);
}

// audio: music finished callback, raises SDL user event
void audio_music_finished_callback ()
{
	SDL_Event event;
	event.type = SDL_USEREVENT;
	event.user.code = AUDIO_MUSICFINISHEDEVENT;
	event.user.data1 = 0;
	event.user.data2 = 0;
	SDL_PushEvent(&event);
}

// audio: register music finished callback
void add_audio_music_finished_callback ()
{
	Mix_HookMusicFinished (audio_music_finished_callback);
}

// get audio channel from channel finished event
int get_audio_channel (SDL_Event *e)
{
  return (int)e->user.data1;
}

#endif // __INCLUDE_EM_AUDIO__
