#include <em_video.h>
#include <png.h>


#ifdef __INCLUDE_EM_VIDEO__

#ifndef _WIN32
 #include <gdk/gdkx.h>
#endif // _WIN32

#ifndef _WIN32
int get_gdk_window_xwindow (GdkDrawable* a_pointer)
{
  int x = GDK_WINDOW_XWINDOW(a_pointer);
  fprintf(stdout,"WINDOW_ID= %d\n",x);
  return x;
}

#endif // _WIN32
#include <stdio.h>

// Copied from an example and moddified for SDL_surface
int save_surface_as_png( SDL_Surface * surface, char * filename ){
	png_structp png_ptr;
	png_infop info_ptr;
	png_uint_32 i, rowbytes;
	png_bytepp row_pointers;
	png_color_16 bg_color;

	unsigned char *image_data = surface->pixels;
	
	int color_type;
	int bit_depth;
	
	// Open PNG file for writting
	FILE *fp = fopen(filename, "wb");
	if (!fp) return 4;
	
	// Allocate basic libpng structures
	png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, 0, 0, 0);
	if (!png_ptr) { fclose(fp); return 1; }
	
	info_ptr = png_create_info_struct(png_ptr);
	if (!info_ptr)
	{
		png_destroy_write_struct(&png_ptr, 0);
		fclose(fp); return 1;
	}
	
	// setjmp() must be called in every function
	// that calls a PNG-reading libpng function
	if (setjmp(png_ptr->jmpbuf)) {
		png_destroy_write_struct(&png_ptr, &info_ptr);
		fclose(fp); return 3;
	}
	
	png_init_io(png_ptr, fp);
	
	// set the zlib compression level
	png_set_compression_level(png_ptr, Z_BEST_COMPRESSION);
	
	switch ( surface->format->BitsPerPixel ){
	case 32:
		color_type = PNG_COLOR_TYPE_RGBA;
		bit_depth = 8;
		break;
	case 24:
		color_type = PNG_COLOR_TYPE_RGB;
		bit_depth = 8;
		break;
	case 16:
		color_type = PNG_COLOR_TYPE_RGBA;
		bit_depth = 4;
		break;
	case 8:
		// Not supported
		return 1;	
	}
	
	// write PNG info to structure
	png_set_IHDR(png_ptr, info_ptr, surface->w, surface->h, bit_depth,
		color_type, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
	
	bg_color.red   = (surface->format->colorkey & 0x0000ff);
	bg_color.green = (surface->format->colorkey & 0x00ff00) >> 8;
	bg_color.blue  = (surface->format->colorkey & 0xff0000) >> 16;
	
// 	png_set_background(png_ptr, &bg_color, PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
	png_set_bKGD(png_ptr, info_ptr, &bg_color);
	
	png_write_info(png_ptr, info_ptr);
	
	// setjmp() must be called in every function
	// that calls a PNG-writing libpng function
	if (setjmp(png_ptr->jmpbuf)) {
		png_destroy_write_struct(&png_ptr, &info_ptr);
		fclose(fp); return 3;
	}
	
	// If color is BGR change to RGB
	// png_set_bgr(png_ptr);
	
	// Allocate pointers for each line
	row_pointers = malloc(surface->h * sizeof(png_bytep));
	if (!row_pointers) {
		png_destroy_write_struct(&png_ptr, &info_ptr);
		fclose(fp); return 1;
	}
	
	// how many bytes in each row
	rowbytes = png_get_rowbytes(png_ptr, info_ptr);
	
	// set the individual row_pointers to point at the correct offsets
	for (i = 0; i < surface->h; ++i) {
		row_pointers[i] = image_data + i * rowbytes;
	}
	
	// now we can go ahead and just write the whole image
	png_write_image(png_ptr, row_pointers);
	png_write_end(png_ptr, 0);
	png_destroy_write_struct(&png_ptr, &info_ptr);
	
	free(row_pointers); fclose(fp); return 0;
}



#endif // __INCLUDE_EM_VIDEO__

