indexing

	description: "[

		A network socket.

	]"
	date: "$Date: 2005-10-23 12:31:22 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1124 $"

deferred class EM_SOCKET

inherit

	ANY

	EM_SHARED_SUBSYSTEMS
		export
			{NONE} all
			{ANY} Network_subsystem
		end

	EM_SHARED_ERROR_HANDLER
		export {NONE} all end

feature -- Access

	port: INTEGER
			-- Local socket port

feature -- Status

	is_open: BOOLEAN
			-- Is socket open?

feature -- Status setting

	open is
			-- Open socket.
		require
			network_enabled: Network_subsystem.is_enabled
			closed: not is_open
			port_set: 1024 < port and port < 65536
		deferred
		end

	close is
			-- Close socket.
		require
			network_enabled: Network_subsystem.is_enabled
			open: is_open
		deferred
		ensure
			closed: not is_open
		end

feature -- Element change

	set_port (a_port: INTEGER) is
			-- Set `port' to `a_port'.
		require
			a_port_in_range: 1024 < a_port and a_port < 65536
		do
			port := a_port
		ensure
			port_set: port = a_port
		end

feature {EM_SOCKETS} -- Implementation

	handle_data_received is
			-- Handle data received event.
		deferred
		end

feature {EM_SOCKETS} -- Implementation

	net2_socket_id: INTEGER
			-- Socket id of Net2

end