indexing

	description: "[

		Constants for EiffelMedia Network

	]"
	date: "$Date: 2005-10-24 12:52:51 +0200 (Mon, 24 Oct 2005) $"
	revision: "$Revision: 1212 $"

class 	EM_NETWORK_CONSTANTS

feature -- Access

	set_max_serialization_byte_count (a_count: INTEGER) is
			-- Set `max_serialization_count' to `a_count'.
			-- If UDP is used this value should be *less* than `Max_udp_packet_size'.
		do
			max_serialization_byte_count.set_item (a_count)
		ensure
			max_serialization_byte_count_set: max_serialization_byte_count.item = a_count
		end

	max_serialization_byte_count: INTEGER_REF is
			-- max serialization count
		once
			create Result
			Result.set_item (0)
		end

	In_addr_any: INTEGER is 0
			-- Used for listening on all network interfaces

	In_addr_unresolved: INTEGER is 1
			-- Used for listening on all network interfaces

	In_addr_broadcast: INTEGER is -1
			-- Used as destination when sending a message to all clients
			-- on a subnet that allows broadcasts

	Max_udp_packet_size: INTEGER is 982
			-- Maximum size of a UDP packet

	Min_port_number: INTEGER is 0
			-- Lowest valid value for a socket port

	Max_port_number: INTEGER is 65535
			-- Highest valid value for a socket port

	Cr: INTEGER is 13
			-- Carriage return character code

	Lf: INTEGER is 10
			-- Line feed character code

end