indexing

	description: "[

		An acknowledgement event for a two phase commit event.
		
		This event is the response that will automatically be sent to the sender of a
		two phase commit event.
		
		This event is created and handled in the background, so there is
		usually no need to mess around with it.

	]"
	date: "$Date: 2005-10-26 16:05:23 +0200 (Wed, 26 Oct 2005) $"
	revision: "$Revision: 1295 $"

class EM_NET_2PC_ACK

inherit

	EM_NET_EVENT_OBJECT

create {EM_NET_OBJECT_TYPES}

	make_set_type

feature -- Element change

	set_event_id (an_id: INTEGER) is
			-- Set `event_id' to `an_id'.
		do
			event_id := an_id
		end

feature -- Access

	event_id: INTEGER
			-- ID of the event that is acknowledged

feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'.
		require else
			a_serializer_not_void: a_serializer /= Void
			event_id_valid: event_id > 0
		do
			a_serializer.put_integer (event_id)
		end

	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
			-- This might be a constant and *could* be a dynamic value.
			-- {EM_NET_WORK_CONSTANTS}.Max_udp_packet_size is the limit!
			-- The standard EM_NET_PROTOCOL uses at least 13 bytes...
		do
			Result := 4
		end

	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize `data' using `an_unserializer'.
		do
			an_unserializer.read_integer
			event_id := an_unserializer.last_integer
		ensure then
			event_id_valid: event_id > 0
		end

end
