indexing

	description: "[

		Event that notifies the client if its join request was accepted.
		
		This is used in the Client/Server implementation of the multiplayer framework.
		
		This is a secured two phase commit event.

	]"
	date: "$Date: 2005-10-23 12:09:37 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1119 $"

class EM_NET_JOIN_RESPONSE

inherit

	EM_NET_2PC_EVENT_OBJECT

create {EM_NET_OBJECT_TYPES}

	make_set_type

feature -- Serialization

	serialize (a_serializer: EM_NET_SERIALIZER) is
			-- Serialize to the given stream using `a_serializer'.
		do
			a_serializer.put_integer (id)
			if is_accepted then
				a_serializer.put_integer_8 (1)
			else
				a_serializer.put_integer_8 (0)
			end
		end

	serialization_byte_count: INTEGER is
			-- Count of bytes needed for a successful serialization
		do
			Result := 5
		end

	unserialize (an_unserializer: EM_NET_UNSERIALIZER) is
			-- Unserialize from a given stream using `an_unserializer'.
		do
			an_unserializer.read_integer
			id := an_unserializer.last_integer
			an_unserializer.read_integer_8
			if an_unserializer.last_integer = 0 then
				is_accepted := False
			else
				is_accepted := True
			end
		end

feature -- Element change

	accept_join is
			-- Accept the join request.
		do
			is_accepted := True
		end

	deny_join is
			-- Deny the join request.
		do
			is_accepted := False
		end

feature -- Status information

	is_accepted: BOOLEAN

end