indexing
	description: "Objects that ..."
	author: ""
	date: "$Date: 2006-08-28 13:01:46 +0200 (Mon, 28 Aug 2006) $"
	revision: "$Revision: 2214 $"

class
	EM_2D_PROC_BITMAP_GENERATOR
inherit
	EM_2D_PROC_FIELD_GENERATOR
	rename
		set_field_dimension as set_bitmap_dimension,
		generate_field as generate_bitmap,
		start_generating_field as start_generating_bitmap,
		continue_generating_field as continue_generating_bitmap,
		last_field as last_bitmap,
		field_internal as bitmap_internal,
		store_field_value as store_bitmap_value,
		field_dimension as bitmap_dimension
	redefine
		last_bitmap,
		bitmap_internal,
		on_start,
		on_finish
	end

	EM_SHARED_BITMAP_FACTORY
		export {NONE} all end

create
	make

feature -- Access

	last_bitmap: EM_BITMAP is
			-- return the last created bitmap
		do
			Result := bitmap_internal
		end


feature {NONE}
	store_bitmap_value(pos: EM_VECTOR2I; value: DOUBLE) is
			-- store 'value' at (x, y) in the bitmap using the color mapper
		do
			color_mapper.compute_color (value)
			if (color_mapper.is_last_color_grayscale) then
				bitmap_internal.set_pixel_value (pos.x, pos.y, color_mapper.last_grayscale)
			else
				bitmap_internal.set_pixel(pos.x, pos.y, color_mapper.last_color)
			end
		end

	on_start is
		do
			bitmap_factory.create_empty_bitmap (bitmap_dimension.x, bitmap_dimension.y)
			bitmap_internal := bitmap_factory.last_bitmap
			bitmap_internal.lock
		end

	on_finish is
		do
			bitmap_internal.unlock
		end

	bitmap_internal: EM_BITMAP

end

