indexing
	description: "[
	
		Expanded objects that describe the alignment of two bounded objects
		(point / line-segment / rectangle) in 2D.
	
	]"
	author: ""
	date: "$Date: 2006-11-13 11:41:40 +0100 (Mon, 13 Nov 2006) $"
	revision: "$Revision: 2364 $"

expanded class EM_ALIGNMENT_2D

create

 	default_create,
 	make_from_tuple

convert

	make_from_tuple ({TUPLE [INTEGER, INTEGER]})

feature -- Initialization

	make_from_tuple (t: TUPLE [INTEGER, INTEGER]) is
			-- Make 2d alignment from tuple `t' of integers
		do
			x := t.integer_item (1)
			y := t.integer_item (2)
		end

feature -- Element change

	set (x_alignment: like x; y_alignment: like y) is
			-- Make new combined 2d-alignment from 2 separate alignments
		do
			set_x (x_alignment)
			set_y (y_alignment)
		end

	set_x (alignment: like x) is
			-- Set `alignment' for x-Axis
		do
			x := alignment
		ensure
			set: x = alignment
		end

	set_y (alignment: like y) is
			-- Set `aligment' for y-Axis
		do
			y := alignment
		ensure
			set: y = alignment
		end

feature -- Access

	x: EM_ALIGNMENT
			-- Alignment for x-Axis

	y: EM_ALIGNMENT
			-- Alignment for y-Axis

end
