indexing
	description: "[
	
		Expanded objects that describe the alignment of two bounded objects
		(point / line-segment / rectangle / box) in 3D.

	]"
	author: ""
	date: "$Date: 2007-02-01 04:49:58 +0100 (Thu, 01 Feb 2007) $"
	revision: "$Revision: 2468 $"

expanded class EM_ALIGNMENT_3D

create

 	default_create,
 	make_from_tuple

convert

	make_from_tuple ({TUPLE [INTEGER, INTEGER, INTEGER]}),
	to_2d: {EM_ALIGNMENT_2D}

feature -- Initialization

	make_from_tuple (t: TUPLE [INTEGER, INTEGER, INTEGER]) is
			-- Make 2d alignment from tuple `t' of integers
		do
			x := t.integer_item (1)
			y := t.integer_item (2)
			z := t.integer_item (3)
		end

feature -- Conversion

	to_2d: EM_ALIGNMENT_2D is
			-- Discard z alignment
		do
			Result.set (x, y)
		end

feature -- Element change

	set (x_alignment: like x; y_alignment: like y; z_alignment: like z) is
			-- Make new combined 2d-alignment from 2 separate alignments
		do
			set_x (x_alignment)
			set_y (y_alignment)
			set_z (z_alignment)
		end

	set_x (alignment: like x) is
			-- Set `alignment' for x-Axis
		do
			x := alignment
		ensure
			set: x = alignment
		end

	set_y (alignment: like y) is
			-- Set `aligment' for y-Axis
		do
			y := alignment
		ensure
			set: y = alignment
		end

	set_z (alignment: like z) is
			-- Set `alignment' for z-Axis
		do
			z := alignment
		ensure
			set: z = alignment
		end

feature -- Access

	x: EM_ALIGNMENT
			-- Alignment for x-Axis

	y: EM_ALIGNMENT
			-- Alignment for y-Axis

	z: EM_ALIGNMENT
			-- Alignment for z-Axis

end
