indexing
	description: "[
		This class is used the create objects that automatically detect if
		they are used only by the system, or if there is an external reference to
		the object.
		]"
	date: "$Date: Jul 20, 2006 5:53:01 AM$"
	revision: "$Revision: 1.0$"

deferred class EM_AUTO_PURGE_OBJECT

inherit
	MEMORY
		export
			{NONE} all
		end


feature {NONE} -- status
	is_dead_internal: BOOLEAN

feature -- Status
	auto_purge_enabled: BOOLEAN

	ref_count: INTEGER is
			-- returns the number of references to this object
		do
			result := referers ( current ).count
		end

	system_ref_count: INTEGER
			-- Returns the number of system references to that object

	is_dead: BOOLEAN is
			-- Was the object killed?
		do
			if auto_purge_enabled then
				if not is_dead_internal then
					is_dead_internal := ref_count<=10--manager_count
				end
				result := is_dead_internal
			else
				result := false
			end
		end

feature -- Command
	kill is
			-- Kill the object, that means mark it as dead
		do
			enable_auto_purge
			is_dead_internal := true
		end

	enable_auto_purge is
			-- Enable the auto purge
		do
			auto_purge_enabled := true
		end

	disable_auto_purge is
			-- Disable the auto purge
		do
			auto_purge_enabled := false
		end

	inc_system_ref_count is
			-- Increase the system reference count
		do
			system_ref_count := system_ref_count + 1
		end

	dec_system_ref_count is
			-- Decrease the system reference count
		do
			system_ref_count := system_ref_count - 1
		end

end -- class EM_AUTO_PURGE_OBJECT
