indexing

	description: "[

		Constants used in the Em library.

	]"
	date: "$Date: 2007-01-01 19:39:57 +0100 (Mon, 01 Jan 2007) $"
	revision: "$Revision: 2378 $"

class EM_CONSTANTS

inherit

	EM_GLU_CONSTANTS

	GL_CONSTANTS

feature -- Subsystem initialization constants

	Em_init_timer: INTEGER is 0x00000001
		-- Initialize timer subsystem

	Em_init_audio: INTEGER is 0x00000010
		-- Initialize timer subsystem

	Em_init_video: INTEGER is 0x00000020
		-- Initialize video subsystem

	Em_init_cdrom: INTEGER is 0x00000100
		-- Initialize cdrom subsystem

	Em_init_joystick: INTEGER is 0x00000200
		-- Initialize joystick subsystem

	Em_init_noparachute: INTEGER is 0x00100000
		-- Initialize noparachute subsystem - does not catch any fatal signals

	Em_init_everything: INTEGER is 0x0000FFFF
		-- Initialize all subsystems

feature -- Video subsystem Constants

	Em_software_surface: INTEGER is 0x00000000
		-- Video software surface constant

	Em_hardware_surface: INTEGER is 0x00000001
		-- Video hardware surface constant

	Em_async_blit: INTEGER is 0x00000004
		-- Video async_blit constant

	Em_anyformat: INTEGER is 0x10000000
		-- Video anyformat constant

	Em_hwpalette: INTEGER is 0x20000000
		-- Video hwpalette constant

	Em_doublebuffered: INTEGER is 0x40000000
		-- Video doublebuffered constant

	Em_video_fullscreen: INTEGER is 0x80000000
		-- Video full screen constant

	Em_opengl: INTEGER is 0x00000002
		-- Video opengl constant

	Em_opengl_blit: INTEGER is 0x0000000A
		-- Video opengl_blit constant

	Em_resizeable: INTEGER is 0x00000010
		-- Video resizeable constant

	Em_noframe: INTEGER is 0x00000020
		-- Video noframe constant

	Em_colorkey: INTEGER is 0x00001000
		-- Enable transparent color key constant

	Em_enable: INTEGER is 1
		-- Enable constant

	Em_disable: INTEGER is 0
		-- Disable constant

	Em_query: INTEGER is -1
		-- Query constant

	Em_srcalpha: INTEGER is 0x00010000
		-- Blit uses source alpha blending

	Em_rleaccelok: INTEGER is 0x00002000
		-- Private flag

feature -- Audio subsystem Constants

	Em_audio_u8: INTEGER is 0x0008
		-- Unsigned 8-bit samples

	Em_audio_s8: INTEGER is 0x8008
		-- Signed 8-bit samples

	Em_audio_u16: INTEGER is 0x0010
		-- Unsigned 16-bit little-endian samples

	Em_audio_u16lsb: INTEGER is 0x0010
		-- Unsigned 16-bit little-endian samples
		-- equivalent to `Em_audio_u16'

	Em_audio_s16: INTEGER is 0x8010
		-- Signed 16-bit little-endian samples

	Em_audio_s16lsb: INTEGER is 0x8010
		-- Signed 16-bit little-endian samples
		-- equivalent to `Em_audio_s16'

	Em_audio_u16msb: INTEGER is 0x1010
		-- Unsigned 16-bit big-endian samples

	Em_audio_s16msb: INTEGER is 0x9010
		-- Signed 16-bit big-endian samples

feature -- CDRom subsystem Constans

	Em_cdrom_fps: INTEGER is 75
		-- Number of audio frames per second

	Em_cdrom_max_tracks: INTEGER is 99
		-- maximum number of CDRom tracks on a disk

	Em_cdrom_audio_track: INTEGER is 0x00
		-- Identifier for audio track

	Em_cdrom_data_track: INTEGER is 0x04
		-- Identifier for data track

feature -- The possible states which a CDRom drive can be in.

	Em_cdrom_empty: INTEGER is 0x00
		-- Identifier for empty state

	Em_cdrom_stopped: INTEGER is 0x01
		-- Identifier for stopped state

	Em_cdrom_playing: INTEGER is 0x02
		-- Identifier for playing state

	Em_cdrom_paused: INTEGER is 0x03
		-- Identifier for paused state

	Em_cdrom_error: INTEGER is -1
		-- Identifier for error state

feature -- Joystick subsystem Constans (hat states)

	Em_joystick_hat_centered: INTEGER is 0x00
		-- Identifier for hat state

	Em_joystick_hat_up: INTEGER is 0x01
		-- Identifier for hat state

	Em_joystick_hat_right: INTEGER is 0x02
		-- Identifier for hat state

	Em_joystick_hat_down: INTEGER is 0x04
		-- Identifier for hat state

	Em_joystick_hat_left: INTEGER is 0x08
		-- Identifier for hat state

	Em_joystick_hat_rightup: INTEGER is 0x03
		-- Identifier for hat state

	Em_joystick_hat_rightdown: INTEGER is 0x06
		-- Identifier for hat state

	Em_joystick_hat_leftup: INTEGER is 0x09
		-- Identifier for hat state

	Em_joystick_hat_leftdown: INTEGER is 0x0c
		-- Identifier for hat state

feature -- Event constants

	Em_default_time_for_eventprocessing: INTEGER is 30
		-- Default maximal time used for eventprocessing in EM_EVENT_LOOP

	Em_active_event: INTEGER is 1
		-- Active event

	Em_key_down_event: INTEGER is 2
		-- Key down event

	Em_key_up_event: INTEGER is 3
		-- Keyboard event

	Em_mousemotion_event: INTEGER is 4
		-- Mouse motion event

	Em_mouse_button_down_event: INTEGER is 5
		-- Mouse button down event

	Em_mouse_button_up_event: INTEGER is 6
		-- Mouse button up event

	Em_joystick_axis_event: INTEGER is 7
		-- Joystick axis event

	Em_joystick_ball_event: INTEGER is 8
		-- Joystick ball event

	Em_joystick_hat_event: INTEGER is 9
		-- Joystick hat event

	Em_joystick_button_down_event: INTEGER is 10
		-- Joystick button down event

	Em_joystick_button_up_event: INTEGER is 11
		-- Joystick button up event

	Em_quit_event: INTEGER is 12
		-- Quit event

	Em_window_manager_event: INTEGER is 13
		-- Window manager event

	Em_resize_event: INTEGER is 16
		-- Resize event

	Em_expose_event: INTEGER is 17
		-- Expose event

	Em_user_event: INTEGER is 24
		-- User event

feature -- Net2 event constants - synchornize changes with $EM/library/manual_wrapper/c/net2/net2.h

	Em_net_error_event: INTEGER is 0
			-- Net error event

	Em_tcp_accept_event: INTEGER is 1
			-- TCP accept event

	Em_tcp_receive_event: INTEGER is 2
			-- TCP receive event

	Em_tcp_close_event: INTEGER is 3
			-- TCP close event

	Em_tcp_connect_event: INTEGER is 4
			-- TCP connect event

	Em_tcp_connect_failed_event: INTEGER is 5
			-- TCP connect failed event

	Em_udp_receive_event: INTEGER is 6
			-- UDP receive event

	Em_udp_send_event: INTEGER is 7
			-- UDP send event

	Em_resolve_finished_event: INTEGER is 8
			-- Resolve finished

feature -- Audio event constants - synchornize changes with $EM/library/manual_wrapper/c/include/em.h

	Em_audio_channel_finished_event: INTEGER is 20
			-- channel finished

	Em_audio_music_finished_event: INTEGER is 21
			-- music finished

feature -- Event state constants

	Em_appmousefocus: INTEGER is 1
		-- Application has received a mouse focus activation event

	Em_appinputfocus: INTEGER is 2
		-- Application has received a keyboard activation event

	Em_appactive: INTEGER is 4
		-- Application has received a maximisation activation event

feature -- Computational constants

	Em_eps: DOUBLE is 0.0001

end
