indexing

	description: "[

		Constants uesed for Errorhandling

	]"
	date: "$Date: 2007-05-18 12:07:46 +0200 (Fri, 18 May 2007) $"
	revision: "$Revision: 2584 $"

class EM_ERROR_CODES

feature -- Default error

	Em_error_default: INTEGER is 0

feature -- Initialisation error

	Em_error_init_sdl: INTEGER is 100
			-- Error initialising SDL

	Em_error_init_fastevents: INTEGER is 102
			-- Error initialising fastevents library

	Em_error_init_sdlnet: INTEGER is 103
			-- Error initialising SDL Net

	Em_error_init_net2: INTEGER is 103
			-- Error initialising Net2

feature -- Audio error messages

	Em_error_initializing_audio_subsystem: INTEGER is 1001
			-- Error initializing audio subsystem.

	Em_error_using_audio_player: INTEGER is 1002
			-- Error using audio player.

	Em_error_loading_audio_file: INTEGER is 1003
			-- Error loading audio file.

	Em_error_playing_channel: INTEGER is 1004
			-- Error playing channel.

	Em_error_playing_channel_timed: INTEGER is 1005
			-- Error playing channel timed.

	Em_error_grouping_channels: INTEGER is 1006
			-- Error grouping channels.

	Em_error_opening_mixer: INTEGER is 1007
			-- Error opening mixer.

	Em_error_playing_music: INTEGER is 1008
			-- Error playing music.

	Em_error_fading_music_in: INTEGER is 1009
			-- Error fading music in.

	Em_error_fading_music_in_positioned: INTEGER is 1010
			-- Error fading music in positioned.

	Em_error_fading_music_out: INTEGER is 1011
			-- Error fading music out.

	Em_error_setting_music_position: INTEGER is 1011
			-- Error setting music position.

	Em_error_fading_channel_in_timed: INTEGER is 1012
			-- Error fading channel in timed.

	Em_error_allocating_channels: INTEGER is 1013
			-- Error allocating channels

	Em_error_registring_effect: INTEGER is 1014
			-- Error registring effect

	Em_error_unregistring_effect: INTEGER is 1015
			-- Error unregistring effect

feature -- Video error messages

	Em_error_video_mode_not_supported: INTEGER is 2081
			-- Error because video mode is not supported

	Em_error_initializing_screen: INTEGER is 2082
			-- Error initializing screen

	Em_error_set_video_mode: INTEGER is 2083
			-- Error setting the video mode

	Em_error_toggle_fullscreen: INTEGER is 2000
			-- Error toggling fullscreen.

	Em_error_toggle_fullscreen_not_supported: INTEGER is 2001
			-- Error toggling fullscreen is not supported on current operating system.

	Em_error_redraw_surface: INTEGER is 2002
			-- Error redrawing surface.

	Em_error_put_rectangle: INTEGER is 2003
			-- Error blitting rectangle.

	Em_error_put_rectangle_filled: INTEGER is 2004
			-- Error blitting filled rectangle.

	Em_error_put_polygon: INTEGER is 2005
			-- Error blitting polygon.

	Em_error_put_polygon_filled: INTEGER is 2006
			-- Error blitting filled polygon.

	Em_error_blit_surface: INTEGER is 2007
			-- Error blitting surface.

	Em_error_locking_surface: INTEGER is 2008
			-- Error locking surface.

	Em_error_put_pixel: INTEGER is 2009
			-- Error blitting pixel.

	Em_error_put_line_segment: INTEGER is 2010
			-- Error blitting line segment.

	Em_error_put_circle: INTEGER is 2011
			-- Error blitting circle.

	Em_error_put_circle_filled: INTEGER is 2012
			-- Error blitting filled circle.

	Em_error_set_alpha_value: INTEGER is 2013
			-- Error setting surface alpha value

	Em_error_enable_alpha_transparency: INTEGER is 2014
			-- Error enabling alpha transparency

	Em_error_disable_alpha_transparency: INTEGER is 2015
			-- Error disabling alpha transparency

	Em_error_enable_per_pixel_alpha: INTEGER is 2016
			-- Error enabling per pixel alpha

	Em_error_disable_transparent_colorkey: INTEGER is 2017
			-- Error disabling transparent colorkey

	Em_error_set_transparent_colorkey: INTEGER is 2018
			-- Error setting transparent colorkey

	Em_error_apply_rotozoom: INTEGER is 2019
			-- Error applying rotozoom of surface

	Em_error_blit_surface_part: INTEGER is 2020
			-- Error blitting surface.

	Em_error_create_cursor: INTEGER is 2021
			-- Error creating cursor

	Em_error_save_surface: INTEGER is 2022
			-- Error in SDL_SaveBMP

feature -- Bitmap factory error

	Em_error_create_empty_bitmap: INTEGER is 2201
			-- Error creating empty bitmap

	Em_error_create_empty_alpha_bitmap: INTEGER is 2202
			-- Error creating empty bitmap

	Em_error_create_empty_opengl_bitmap: INTEGER is 2203
			-- Error creating empty bitmap

	Em_error_create_bitmap_from_surface_part: INTEGER is 2204
			-- Error creating empty bitmap

	Em_error_create_zoomed_bitmap: INTEGER is 2205
			-- Error creating zoomed bitmap

	Em_error_create_stretched_bitmap: INTEGER is 2206
			-- Error creating zoomed bitmap

	Em_error_create_rotated_bitmap: INTEGER is 2207
			-- Error creating rotated bitmap

	Em_error_create_transformed_bitmap: INTEGER is 2208
			-- Error creating zoomed bitmap

	Em_error_create_empty_surface: INTEGER is 2209
			-- Error creating empty surface

	Em_error_create_empty_alpha_surface: INTEGER is 2210
			-- Error creating empty alpha surface

	Em_error_loading_image_format_not_supported: INTEGER is 2211
			-- Error loading image is no image file

	Em_error_loading_image_does_not_exist: INTEGER is 2212
			-- Error loading image doesn't exist

	Em_error_loading_image: INTEGER is 22222
			-- Error loading image

feature -- Texture error

	Em_error_generate_mipmap: INTEGER is 2401
			-- Error during generaton of mipmap texture

	Em_error_generate_texture: INTEGER is 2402
			-- Error during generation of texture

feature -- Network error messages

	Em_error_generating_socket: INTEGER	is 3010
			-- Error during socket creation

	Em_error_udp_open : INTEGER is 3020
			-- Error opening a udp socket

	Em_error_udp_send : INTEGER is 3030
			-- Error sending a UDP packet

	Em_error_udp_recv : INTEGER is 3040
			-- Error receiving a UDP packet

	Em_error_resolve_ip: INTEGER is 3050 -- Changes have to be synchronized with $EM/library/manual_wrapper/net2/net2.h
			-- Error resolving host

	Em_error_connection_failed: INTEGER is 3051 -- Changes have to be synchronized with $EM/library/manual_wrapper/net2/net2.h
			-- Error connection failed

	Em_error_send_failed: INTEGER is 3052 -- Changes have to be synchronized with $EM/library/manual_wrapper/net2/net2.h
			-- Error connection failed

	Em_error_reverse_resolve_hostname: INTEGER is 3060 -- Changes have to be synchronized with $EM/library/manual_wrapper/net2/net2.h
			-- Error resolving host

	Em_error_net2_error: INTEGER is 3100
			-- Error in Net2 library occured

	Em_error_tcp_open: INTEGER is 3101
			-- Error trying to obtain port (probably is port alredy in use by another application)

	Em_error_tcp_send: INTEGER is 3102
			-- Error sending data over tcp socket

	Em_error_net_object_missed: INTEGER is 3200
			-- Error updating a net object

feature -- CDRom Subsystem error

	Em_error_cdrom_play_track: INTEGER is 5001
			-- Error while trying to play an audio track

	Em_error_cdrom_pause: INTEGER is 5002
			-- Error while trying to pause

	Em_error_cdrom_resume: INTEGER is 5003
			-- Error while trying to resume

	Em_error_cdrom_stop: INTEGER is 5004
			-- Error while trying to stop

	Em_error_cdrom_eject: INTEGER is 5005
			-- Error while trying to eject cdrom

feature -- Font error

	Em_error_initialising_ttf: INTEGER is 6000
			-- Error while initialising ttf system

	Em_error_loading_ttf_font: INTEGER is 6001
			-- Error while loading a ttf font

	Em_error_load_bitmapfont: INTEGER is 6002

feature -- Keyboard error

	Em_error_enable_unicode: INTEGER is 6500
			-- Error while enabling unicode characters

	Em_error_disable_unicode: INTEGER is 6501
			-- Error while disabling unicode characters

	Em_error_enable_repeating_keyboard_events: INTEGER is 6502
			-- Error while enabling repeating keyboard events

	Em_error_disable_repeating_keyboard_events: INTEGER is 6503
			-- Error while disabling repeating keyboard events

feature -- Widget errors

	Em_error_show_combobox_list_scene_void: INTEGER is 7001
			-- Error while showing combobox list selection because running scene is void

	Em_error_show_combobox_list_scene_invalid: INTEGER is 7002
			-- Error while showing combobox list selection because running scene is no EM_COMPONENT_SCENE

	Em_error_hide_combobox_list_scene_void: INTEGER is 7003
			-- Error while hiding combobox list selection because running scene is void

	Em_error_hide_combobox_list_scene_invalid: INTEGER is 7004
			-- Error while hiding combobox list selection because running scene is no EM_COMPONENT_SCENE

	Em_error_show_window_scene_void: INTEGER is 7005
			-- Error while showing a window because running scene is void

	Em_error_show_window_scene_invalid: INTEGER is 7006
			-- Error while showing a window because running scene is no EM_COMPONENT_SCENE

feature -- Video Decoder error

	Em_error_create_video_decoder_from_file: INTEGER is 8001
			-- Error loading video decoder is no movie file

	Em_error_create_video_decoder_from_file_not_valid: INTEGER is 8002
			-- Error loading video decoder is not valid movie file

	Em_error_create_video_decoder_from_file_does_not_exist: INTEGER is 8003
			-- Error loading movie doesn't exist

feature -- Miscellaneous error

	Em_error_unknown_event_type: INTEGER is 9000
			-- Unknown event type occured in event loop

	Em_error_user_event_code_used_by_network: INTEGER is 9001
			-- User event code in network range

	Em_error_user_event_code_used_by_audio: INTEGER is 9002
			-- User event code in audio range

	Em_error_this_should_never_happen: INTEGER is 9003
			-- An error in a code section which shouldn't have been executed

	Em_error_not_yet_implemented: INTEGER is 9004
			-- An error because a feature is not yet implemented

feature -- Fileloader

	Em_error_plain_text_file_does_not_exist: INTEGER is 10001
			-- Error loading plain_text_file does not exist

	Em_error_plain_text_file_not_readable: INTEGER is 10002
			-- Error loading plain_text_file is not readable

feature -- OpenGL
	Em_error_opengl_init_glew: INTEGER is 11001
			-- Unable to initialize GLEW
	Em_error_opengl_glsl_init: INTEGER is 11011
			-- Unable to initialize GLSL Shaders
	Em_error_opengl_glsl_compile: INTEGER is 11012
			-- Unable to compile a GLSL Shader
	Em_error_opengl_glsl_link: INTEGER is 11013
			-- Unable to link a GLSL Shader
	Em_error_opengl_fbo_init: INTEGER is 11021
			-- Unable to initialize GLSL the framebuffer object
	Em_error_opengl_vbo_init: INTEGER is 11031
			-- Unable to initialize GLSL the vertexbuffer object
feature -- EM3D
	Em_error_em3d: INTEGER is 12000
			-- Standard em3d error
	Em_error_em3d_light: INTEGER is 12010
			-- Em3d light error
	Em_error_em3d_identified: INTEGER is 12020
			-- Em3d identified error

	Em_error_em3d_resource_factory: INTEGER is 12030
			-- Em3d resource factory error
	Em_error_em3d_mesh_factory: INTEGER is 12031
			-- Em3d mesh factory error
	Em_error_em3d_material_factory: INTEGER is 12032
			-- Em3d material factory error

	Em_error_em3d_resource: INTEGER is 12040
			-- Em3d resource factory error
	Em_error_em3d_texture: INTEGER is 12041
			-- Em3d texture error

end
