indexing

	description: "[

		In a EM_TILE_PATTERN a EM_DRAWABLE is glued together `times' times either
		in horizontal or vertical direction.
		
		See the tile_pattern example for a demonstration.

	]"
	date: "$Date: 2005-10-23 13:02:12 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1129 $"

deferred class EM_TILE_PATTERN

inherit

	EM_DRAWABLE

feature -- Status

	times: INTEGER
			-- The `img' is glued `times' times together

	set_times (an_integer: INTEGER) is
			-- Sets `times' to `an_integer'
		require
			an_integer_greater_zero: an_integer > 0
		do
			times := an_integer
		ensure
			set: times = an_integer
		end

feature {NONE} -- implementation

	img: EM_DRAWABLE
			-- The EM_DRAWABLE that is glued together.

	min (a: INTEGER; b: INTEGER): INTEGER is
			-- Return the smaller number of `a' and `b'
		do
			if a<b then
				result := a
			else
				result := b
			end
		end

end