indexing

	description: "[

		Objects of type EM_3D_SKYBOX_COLLIDABLE implement a collision detection for a skybox.
		using infinite, axis aligned planes.
		Objects of this type can only collide with objects of type EM_3D_SPHERE_COLLIDABLE

	]"
	date: "$Date: 2005-10-23 13:02:12 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1129 $"

deferred class

	EM_3D_SKYBOX_COLLIDABLE

inherit

	EM_COLLIDABLE_3D

	EM_COLLIDE_3D_SPHERE

feature -- Status report

	does_collide (other: EM_COLLIDABLE_3D): BOOLEAN is
			-- Does `current' collide with `other'?
		local
			skybox_collide: EM_COLLIDE_3D_SKYBOX
		do
			skybox_collide ?= other
			if
				skybox_collide /= void
			then
				result := skybox_collide.does_collide_skybox (current)
			else
				result := false
			end
		end

	does_collide_sphere (other: EM_3D_SPHERE_COLLIDABLE): BOOLEAN is
			-- do we collide with a sphere?
		do
			-- This is the same as collision in a sphere with a skybox, so we call this implementation
			result := other.does_collide_skybox (current)
		end

	min_x: DOUBLE is
			-- Min x of the skybox
		deferred
		end
	max_x: DOUBLE is
			-- Max x of the skybox
		deferred
		end
	min_y: DOUBLE is
			-- Min y of the skybox
		deferred
		end
	max_y: DOUBLE is
			-- Max y of the skybox
		deferred
		end
	min_z: DOUBLE is
			-- Min z of the skybox
		deferred
		end
	max_z: DOUBLE is
			-- Max z of the skybox
		deferred
		end
end