indexing
	description: "Description of class"
	documentation: "Documentation of class"
	date: "$Date: 2007-05-30 00:57:25 +0200 (Wed, 30 May 2007) $"
	revision: "$Revision: 2599 $"

class EMGL_ARRAY_RENDERER

inherit
	ANY

	EMGL_FUNCTIONS
		export {NONE} all end

	EM_CONSTANTS
		export {NONE} all end


feature --general function wrapper
	emgl_array_element ( i:INTEGER ) is
			--Wrap the OpenGL function `gl_array_element`
		do
			gl_array_element_external( i )
		end
	emgl_color_pointer ( size:INTEGER; type:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_color_pointer`
		do
			gl_color_pointer_external( size, type, stride, a_pointer )
		end
	emgl_color_vector3d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR3D ] ) is
			--Wrap the OpenGL function `gl_color_pointer`
		do
			gl_color_pointer_external( 3, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_color_vector3f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR3F ] ) is
			--Wrap the OpenGL function `gl_color_pointer`
		do
			gl_color_pointer_external( 3, em_gl_float, 0, an_array.to_c_pointer )
		end
	emgl_color_vector4d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR4D ] ) is
			--Wrap the OpenGL function `gl_color_pointer`
		do
			gl_color_pointer_external( 4, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_color_vector4f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR4F ] ) is
			--Wrap the OpenGL function `gl_color_pointer`
 		do
			gl_color_pointer_external( 4, em_gl_float, 0, an_array.to_c_pointer )
		end

	emgl_disable_client_state ( array:INTEGER ) is
			--Wrap the OpenGL function `gl_disable_client_state`
		do
			gl_disable_client_state_external( array )
		end
	emgl_draw_arrays ( mode:INTEGER; first:INTEGER; count:INTEGER ) is
			--Wrap the OpenGL function `gl_draw_arrays`
		do
			gl_draw_arrays_external( mode, first, count )
		end
	emgl_draw_elements ( mode:INTEGER; count:INTEGER; type:INTEGER; indices:POINTER ) is
			--Wrap the OpenGL function `gl_draw_elements`
		do
			gl_draw_elements_external( mode, count, type, indices )
		end
	emgl_draw_elements_array ( mode:INTEGER; indices:ARRAY[INTEGER] ) is
			--Wrap the OpenGL function `gl_draw_elements`
		local
			tmp: ANY
		do
			tmp:=indices.to_c
			gl_draw_elements_external( mode, indices.count, em_gl_unsigned_int, $tmp )
		end
	emgl_edge_flag_pointer ( stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_edge_flag_pointer`
		do
			gl_edge_flag_pointer_external( stride, a_pointer )
		end
	emgl_enable_client_state ( array:INTEGER ) is
			--Wrap the OpenGL function `gl_enable_client_state`
		do
			gl_enable_client_state_external( array )
		end
	emgl_index_pointer ( type:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_index_pointer`
		do
			gl_index_pointer_external( type, stride, a_pointer )
		end
	emgl_index_array ( a_pointer:ARRAY[INTEGER] ) is
			--Wrap the OpenGL function `gl_index_pointer`
		local
			tmp: ANY
		do
			tmp:=a_pointer.to_c
			gl_index_pointer_external( em_gl_int, 0, $tmp )
		end
	emgl_interleaved_arrays ( format:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_interleaved_arrays`
		do
			gl_interleaved_arrays_external( format, stride, a_pointer )
		end
	emgl_normal_pointer ( type:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_normal_pointer`
		do
			gl_normal_pointer_external( type, stride, a_pointer )
		end
	emgl_normal_vector3d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR3D ] ) is
			--Wrap the OpenGL function `gl_normal_pointer`
		do
			gl_normal_pointer_external( em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_normal_vector3f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR3F ] ) is
			--Wrap the OpenGL function `gl_normal_pointer`
		do
			gl_normal_pointer_external( em_gl_float, 0, an_array.to_c_pointer )
		end


	emgl_tex_coord_pointer ( size:INTEGER; type:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( size, type, stride, a_pointer )
		end
	emgl_tex_coord_vector1d_array ( an_array:ARRAY[DOUBLE] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		local
			tmp:ANY
		do
			tmp:=an_array.to_c
			gl_tex_coord_pointer_external( 1, em_gl_double, 0, $tmp )
		end
	emgl_tex_coord_vector1f_array ( an_array:ARRAY[DOUBLE] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		local
			tmp:ANY
		do
			tmp:=an_array.to_c
			gl_tex_coord_pointer_external( 1, em_gl_float, 0, $tmp )
		end
	emgl_tex_coord_vector2d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR2D ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 2, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_tex_coord_vector2f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR2F ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 2, em_gl_float, 0, an_array.to_c_pointer )
		end
	emgl_tex_coord_vector3d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR3D ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 3, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_tex_coord_vector3f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR3F ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 3, em_gl_float, 0, an_array.to_c_pointer )
		end
	emgl_tex_coord_vector4d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR4D ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 4, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_tex_coord_vector4f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR4F ] ) is
			--Wrap the OpenGL function `gl_tex_coord_pointer`
		do
			gl_tex_coord_pointer_external( 4, em_gl_float, 0, an_array.to_c_pointer )
		end

	emgl_vertex_pointer ( size:INTEGER; type:INTEGER; stride:INTEGER; a_pointer:POINTER ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( size, type, stride, a_pointer )
		end
	emgl_vertex_vector2d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR2D ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 2, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_vertex_vector2f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR2F ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 2, em_gl_float, 0, an_array.to_c_pointer )
		end
	emgl_vertex_vector3d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR3D ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 3, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_vertex_vector3f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR3F ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 3, em_gl_float, 0, an_array.to_c_pointer )
		end
	emgl_vertex_vector4d_array ( an_array:EM_VECTOR_ARRAY_D[ EM_VECTOR4D ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 4, em_gl_double, 0, an_array.to_c_pointer )
		end
	emgl_vertex_vector4f_array ( an_array:EM_VECTOR_ARRAY_F[ EM_VECTOR4F ] ) is
			--Wrap the OpenGL function `gl_vertex_pointer`
		do
			gl_vertex_pointer_external( 4, em_gl_float, 0, an_array.to_c_pointer )
		end

feature -- Status
	emgl_enable_color_array is
		do
			gl_enable_client_state_external ( em_gl_color_array )
		end
	emgl_is_color_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_color_array )
		end
	emgl_disable_color_array is
		do
			gl_disable_client_state_external ( em_gl_color_array )
		end

	emgl_enable_edge_flag_array is
		do
			gl_enable_client_state_external ( em_gl_edge_flag_array )
		end
	emgl_is_edge_flag_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_edge_flag_array )
		end
	emgl_disable_edge_flag_array is
		do
			gl_disable_client_state_external ( em_gl_edge_flag_array )
		end

	emgl_enable_index_array is
		do
			gl_enable_client_state_external ( em_gl_index_array )
		end
	emgl_is_index_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_index_array )
		end
	emgl_disable_index_array is
		do
			gl_disable_client_state_external ( em_gl_index_array )
		end

	emgl_enable_normal_array is
		do
			gl_enable_client_state_external ( em_gl_normal_array )
		end
	emgl_is_normal_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_normal_array )
		end
	emgl_disable_normal_array is
		do
			gl_disable_client_state_external ( em_gl_normal_array )
		end

	emgl_enable_texture_coord_array is
		do
			gl_enable_client_state_external ( em_gl_texture_coord_array )
		end
	emgl_is_texture_coord_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_texture_coord_array )
		end
	emgl_disable_texture_coord_array is
		do
			gl_disable_client_state_external ( em_gl_texture_coord_array )
		end

	emgl_enable_vertex_array is
		do
			gl_enable_client_state_external ( em_gl_vertex_array )
		end
	emgl_is_vertex_array_enabled:BOOLEAN is
		do
			result := emgl_get_boolean ( em_gl_vertex_array )
		end
	emgl_disable_vertex_array is
		do
			gl_disable_client_state_external ( em_gl_vertex_array )
		end

end -- class EMGL_ARRAY_RENDERER
