indexing
	description: "Includes basic rendering functions, using these functions is slower than using those from EMGL_ARRAY_RENDERER"
	documentation: "Documentation of class"
	date: "$Date: 2007-01-24 15:38:10 +0100 (Wed, 24 Jan 2007) $"
	revision: "$Revision: 2423 $"

class EMGL_BASIC_RENDERER

inherit
	ANY
	EMGL_FUNCTIONS
		export {NONE} all end

feature --general function wrapper
	emgl_begin ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_begin`
		do
			gl_begin_external( mode )
		end
	emgl_end is
			--Wrap the OpenGL function `gl_end`
		do
			gl_end_external
		end
	emgl_normal3b ( nx:INTEGER; ny:INTEGER; nz:INTEGER ) is
			--Wrap the OpenGL function `gl_normal3b`
		do
			gl_normal3b_external( nx, ny, nz )
		end
	emgl_normal3bv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_normal3bv`
		do
			gl_normal3bv_external( v )
		end
	emgl_normal3d ( nx:DOUBLE; ny:DOUBLE; nz:DOUBLE ) is
			--Wrap the OpenGL function `gl_normal3d`
		do
			gl_normal3d_external( nx, ny, nz )
		end
	emgl_normal3dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_normal3dv`
		do
			gl_normal3dv_external( v )
		end
	emgl_normal3f ( nx:REAL; ny:REAL; nz:REAL ) is
			--Wrap the OpenGL function `gl_normal3f`
		do
			gl_normal3f_external( nx, ny, nz )
		end
	emgl_normal3fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_normal3fv`
		do
			gl_normal3fv_external( v )
		end
	emgl_normal3i ( nx:INTEGER; ny:INTEGER; nz:INTEGER ) is
			--Wrap the OpenGL function `gl_normal3i`
		do
			gl_normal3i_external( nx, ny, nz )
		end
	emgl_normal3iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_normal3iv`
		do
			gl_normal3iv_external( v )
		end
	emgl_normal3s ( nx:INTEGER; ny:INTEGER; nz:INTEGER ) is
			--Wrap the OpenGL function `gl_normal3s`
		do
			gl_normal3s_external( nx, ny, nz )
		end
	emgl_normal3sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_normal3sv`
		do
			gl_normal3sv_external( v )
		end
	emgl_rectd ( x1:DOUBLE; y1:DOUBLE; x2:DOUBLE; y2:DOUBLE ) is
			--Wrap the OpenGL function `gl_rectd`
		do
			gl_rectd_external( x1, y1, x2, y2 )
		end
	emgl_rectdv ( v1:POINTER; v2:POINTER ) is
			--Wrap the OpenGL function `gl_rectdv`
		do
			gl_rectdv_external( v1, v2 )
		end
	emgl_rectf ( x1:REAL; y1:REAL; x2:REAL; y2:REAL ) is
			--Wrap the OpenGL function `gl_rectf`
		do
			gl_rectf_external( x1, y1, x2, y2 )
		end
	emgl_rectfv ( v1:POINTER; v2:POINTER ) is
			--Wrap the OpenGL function `gl_rectfv`
		do
			gl_rectfv_external( v1, v2 )
		end
	emgl_recti ( x1:INTEGER; y1:INTEGER; x2:INTEGER; y2:INTEGER ) is
			--Wrap the OpenGL function `gl_recti`
		do
			gl_recti_external( x1, y1, x2, y2 )
		end
	emgl_rectiv ( v1:POINTER; v2:POINTER ) is
			--Wrap the OpenGL function `gl_rectiv`
		do
			gl_rectiv_external( v1, v2 )
		end
	emgl_rects ( x1:INTEGER; y1:INTEGER; x2:INTEGER; y2:INTEGER ) is
			--Wrap the OpenGL function `gl_rects`
		do
			gl_rects_external( x1, y1, x2, y2 )
		end
	emgl_rectsv ( v1:POINTER; v2:POINTER ) is
			--Wrap the OpenGL function `gl_rectsv`
		do
			gl_rectsv_external( v1, v2 )
		end
	emgl_tex_coord1d ( s:DOUBLE ) is
			--Wrap the OpenGL function `gl_tex_coord1d`
		do
			gl_tex_coord1d_external( s )
		end
	emgl_tex_coord1dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord1dv`
		do
			gl_tex_coord1dv_external( v )
		end
	emgl_tex_coord1f ( s:REAL ) is
			--Wrap the OpenGL function `gl_tex_coord1f`
		do
			gl_tex_coord1f_external( s )
		end
	emgl_tex_coord1fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord1fv`
		do
			gl_tex_coord1fv_external( v )
		end
	emgl_tex_coord1i ( s:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord1i`
		do
			gl_tex_coord1i_external( s )
		end
	emgl_tex_coord1iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord1iv`
		do
			gl_tex_coord1iv_external( v )
		end
	emgl_tex_coord1s ( s:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord1s`
		do
			gl_tex_coord1s_external( s )
		end
	emgl_tex_coord1sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord1sv`
		do
			gl_tex_coord1sv_external( v )
		end
	emgl_tex_coord2d ( s:DOUBLE; t:DOUBLE ) is
			--Wrap the OpenGL function `gl_tex_coord2d`
		do
			gl_tex_coord2d_external( s, t )
		end
	emgl_tex_coord2dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord2dv`
		do
			gl_tex_coord2dv_external( v )
		end
	emgl_tex_coord2f ( s:REAL; t:REAL ) is
			--Wrap the OpenGL function `gl_tex_coord2f`
		do
			gl_tex_coord2f_external( s, t )
		end
	emgl_tex_coord2fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord2fv`
		do
			gl_tex_coord2fv_external( v )
		end
	emgl_tex_coord2i ( s:INTEGER; t:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord2i`
		do
			gl_tex_coord2i_external( s, t )
		end
	emgl_tex_coord2iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord2iv`
		do
			gl_tex_coord2iv_external( v )
		end
	emgl_tex_coord2s ( s:INTEGER; t:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord2s`
		do
			gl_tex_coord2s_external( s, t )
		end
	emgl_tex_coord2sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord2sv`
		do
			gl_tex_coord2sv_external( v )
		end
	emgl_tex_coord3d ( s:DOUBLE; t:DOUBLE; r:DOUBLE ) is
			--Wrap the OpenGL function `gl_tex_coord3d`
		do
			gl_tex_coord3d_external( s, t, r )
		end
	emgl_tex_coord3dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord3dv`
		do
			gl_tex_coord3dv_external( v )
		end
	emgl_tex_coord3f ( s:REAL; t:REAL; r:REAL ) is
			--Wrap the OpenGL function `gl_tex_coord3f`
		do
			gl_tex_coord3f_external( s, t, r )
		end
	emgl_tex_coord3fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord3fv`
		do
			gl_tex_coord3fv_external( v )
		end
	emgl_tex_coord3i ( s:INTEGER; t:INTEGER; r:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord3i`
		do
			gl_tex_coord3i_external( s, t, r )
		end
	emgl_tex_coord3iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord3iv`
		do
			gl_tex_coord3iv_external( v )
		end
	emgl_tex_coord3s ( s:INTEGER; t:INTEGER; r:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord3s`
		do
			gl_tex_coord3s_external( s, t, r )
		end
	emgl_tex_coord3sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord3sv`
		do
			gl_tex_coord3sv_external( v )
		end
	emgl_tex_coord4d ( s:DOUBLE; t:DOUBLE; r:DOUBLE; q:DOUBLE ) is
			--Wrap the OpenGL function `gl_tex_coord4d`
		do
			gl_tex_coord4d_external( s, t, r, q )
		end
	emgl_tex_coord4dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord4dv`
		do
			gl_tex_coord4dv_external( v )
		end
	emgl_tex_coord4f ( s:REAL; t:REAL; r:REAL; q:REAL ) is
			--Wrap the OpenGL function `gl_tex_coord4f`
		do
			gl_tex_coord4f_external( s, t, r, q )
		end
	emgl_tex_coord4fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord4fv`
		do
			gl_tex_coord4fv_external( v )
		end
	emgl_tex_coord4i ( s:INTEGER; t:INTEGER; r:INTEGER; q:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord4i`
		do
			gl_tex_coord4i_external( s, t, r, q )
		end
	emgl_tex_coord4iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord4iv`
		do
			gl_tex_coord4iv_external( v )
		end
	emgl_tex_coord4s ( s:INTEGER; t:INTEGER; r:INTEGER; q:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_coord4s`
		do
			gl_tex_coord4s_external( s, t, r, q )
		end
	emgl_tex_coord4sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_tex_coord4sv`
		do
			gl_tex_coord4sv_external( v )
		end
	emgl_vertex2d ( x:DOUBLE; y:DOUBLE ) is
			--Wrap the OpenGL function `gl_vertex2d`
		do
			gl_vertex2d_external( x, y )
		end
	emgl_vertex2dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex2dv`
		do
			gl_vertex2dv_external( v )
		end
	emgl_vertex2f ( x:REAL; y:REAL ) is
			--Wrap the OpenGL function `gl_vertex2f`
		do
			gl_vertex2f_external( x, y )
		end
	emgl_vertex2fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex2fv`
		do
			gl_vertex2fv_external( v )
		end
	emgl_vertex2i ( x:INTEGER; y:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex2i`
		do
			gl_vertex2i_external( x, y )
		end
	emgl_vertex2iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex2iv`
		do
			gl_vertex2iv_external( v )
		end
	emgl_vertex2s ( x:INTEGER; y:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex2s`
		do
			gl_vertex2s_external( x, y )
		end
	emgl_vertex2sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex2sv`
		do
			gl_vertex2sv_external( v )
		end
	emgl_vertex3d ( x:DOUBLE; y:DOUBLE; z:DOUBLE ) is
			--Wrap the OpenGL function `gl_vertex3d`
		do
			gl_vertex3d_external( x, y, z )
		end
	emgl_vertex3dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex3dv`
		do
			gl_vertex3dv_external( v )
		end
	emgl_vertex3f ( x:REAL; y:REAL; z:REAL ) is
			--Wrap the OpenGL function `gl_vertex3f`
		do
			gl_vertex3f_external( x, y, z )
		end
	emgl_vertex3fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex3fv`
		do
			gl_vertex3fv_external( v )
		end
	emgl_vertex3i ( x:INTEGER; y:INTEGER; z:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex3i`
		do
			gl_vertex3i_external( x, y, z )
		end
	emgl_vertex3iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex3iv`
		do
			gl_vertex3iv_external( v )
		end
	emgl_vertex3s ( x:INTEGER; y:INTEGER; z:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex3s`
		do
			gl_vertex3s_external( x, y, z )
		end
	emgl_vertex3sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex3sv`
		do
			gl_vertex3sv_external( v )
		end
	emgl_vertex4d ( x:DOUBLE; y:DOUBLE; z:DOUBLE; w:DOUBLE ) is
			--Wrap the OpenGL function `gl_vertex4d`
		do
			gl_vertex4d_external( x, y, z, w )
		end
	emgl_vertex4dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex4dv`
		do
			gl_vertex4dv_external( v )
		end
	emgl_vertex4f ( x:REAL; y:REAL; z:REAL; w:REAL ) is
			--Wrap the OpenGL function `gl_vertex4f`
		do
			gl_vertex4f_external( x, y, z, w )
		end
	emgl_vertex4fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex4fv`
		do
			gl_vertex4fv_external( v )
		end
	emgl_vertex4i ( x:INTEGER; y:INTEGER; z:INTEGER; w:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex4i`
		do
			gl_vertex4i_external( x, y, z, w )
		end
	emgl_vertex4iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex4iv`
		do
			gl_vertex4iv_external( v )
		end
	emgl_vertex4s ( x:INTEGER; y:INTEGER; z:INTEGER; w:INTEGER ) is
			--Wrap the OpenGL function `gl_vertex4s`
		do
			gl_vertex4s_external( x, y, z, w )
		end
	emgl_vertex4sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_vertex4sv`
		do
			gl_vertex4sv_external( v )
		end
	emgl_color3b ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3b`
		do
			gl_color3b_external( red, green, blue )
		end
	emgl_color3bv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3bv`
		do
			gl_color3bv_external( v )
		end
	emgl_color3d ( red:DOUBLE; green:DOUBLE; blue:DOUBLE ) is
			--Wrap the OpenGL function `gl_color3d`
		do
			gl_color3d_external( red, green, blue )
		end
	emgl_color3dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3dv`
		do
			gl_color3dv_external( v )
		end
	emgl_color3f ( red:REAL; green:REAL; blue:REAL ) is
			--Wrap the OpenGL function `gl_color3f`
		do
			gl_color3f_external( red, green, blue )
		end
	emgl_color3fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3fv`
		do
			gl_color3fv_external( v )
		end
	emgl_color3i ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3i`
		do
			gl_color3i_external( red, green, blue )
		end
	emgl_color3iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3iv`
		do
			gl_color3iv_external( v )
		end
	emgl_color3s ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3s`
		do
			gl_color3s_external( red, green, blue )
		end
	emgl_color3sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3sv`
		do
			gl_color3sv_external( v )
		end
	emgl_color3ub ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3ub`
		do
			gl_color3ub_external( red, green, blue )
		end
	emgl_color3ubv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3ubv`
		do
			gl_color3ubv_external( v )
		end
	emgl_color3ui ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3ui`
		do
			gl_color3ui_external( red, green, blue )
		end
	emgl_color3uiv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3uiv`
		do
			gl_color3uiv_external( v )
		end
	emgl_color3us ( red:INTEGER; green:INTEGER; blue:INTEGER ) is
			--Wrap the OpenGL function `gl_color3us`
		do
			gl_color3us_external( red, green, blue )
		end
	emgl_color3usv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color3usv`
		do
			gl_color3usv_external( v )
		end
	emgl_color4b ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4b`
		do
			gl_color4b_external( red, green, blue, alpha )
		end
	emgl_color4bv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4bv`
		do
			gl_color4bv_external( v )
		end
	emgl_color4d ( red:DOUBLE; green:DOUBLE; blue:DOUBLE; alpha:DOUBLE ) is
			--Wrap the OpenGL function `gl_color4d`
		do
			gl_color4d_external( red, green, blue, alpha )
		end
	emgl_color4dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4dv`
		do
			gl_color4dv_external( v )
		end
	emgl_color4f ( red:REAL; green:REAL; blue:REAL; alpha:REAL ) is
			--Wrap the OpenGL function `gl_color4f`
		do
			gl_color4f_external( red, green, blue, alpha )
		end
	emgl_color4fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4fv`
		do
			gl_color4fv_external( v )
		end
	emgl_color4i ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4i`
		do
			gl_color4i_external( red, green, blue, alpha )
		end
	emgl_color4iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4iv`
		do
			gl_color4iv_external( v )
		end
	emgl_color4s ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4s`
		do
			gl_color4s_external( red, green, blue, alpha )
		end
	emgl_color4sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4sv`
		do
			gl_color4sv_external( v )
		end
	emgl_color4ub ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4ub`
		do
			gl_color4ub_external( red, green, blue, alpha )
		end
	emgl_color4ubv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4ubv`
		do
			gl_color4ubv_external( v )
		end
	emgl_color4ui ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4ui`
		do
			gl_color4ui_external( red, green, blue, alpha )
		end
	emgl_color4uiv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4uiv`
		do
			gl_color4uiv_external( v )
		end
	emgl_color4us ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color4us`
		do
			gl_color4us_external( red, green, blue, alpha )
		end
	emgl_color4usv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_color4usv`
		do
			gl_color4usv_external( v )
		end
	emgl_edge_flag ( flag:INTEGER ) is
			--Wrap the OpenGL function `gl_edge_flag`
		do
			gl_edge_flag_external( flag )
		end
	emgl_edge_flagv ( flag:POINTER ) is
			--Wrap the OpenGL function `gl_edge_flagv`
		do
			gl_edge_flagv_external( flag )
		end
	emgl_normal_vector3d ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_normal3dv`
		do
			gl_normal3dv_external( $v )
		end
	emgl_normal_vector3f ( v:EM_VECTOR3F ) is
			--Wrap the OpenGL function `gl_normal3fv`
		do
			gl_normal3fv_external( $v )
		end
	emgl_tex_coord_vector2d ( v:EM_VECTOR2D ) is
			--Wrap the OpenGL function `gl_tex_coord2dv`
		do
			gl_tex_coord2dv_external( $v )
		end
	emgl_tex_coord_vector2f ( v:EM_VECTOR2F ) is
			--Wrap the OpenGL function `gl_tex_coord2fv`
		do
			gl_tex_coord2fv_external( $v )
		end
	emgl_tex_coord_vector3d ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_tex_coord3dv`
		do
			gl_tex_coord3dv_external( $v )
		end
	emgl_tex_coord_vector3f ( v:EM_VECTOR3F ) is
			--Wrap the OpenGL function `gl_tex_coord3fv`
		do
			gl_tex_coord3fv_external( $v )
		end
	emgl_tex_coord_vector4d ( v:EM_VECTOR4D ) is
			--Wrap the OpenGL function `gl_tex_coord4dv`
		do
			gl_tex_coord4dv_external( $v )
		end
	emgl_tex_coord_vector4f ( v:EM_VECTOR4F ) is
			--Wrap the OpenGL function `gl_tex_coord4fv`
		do
			gl_tex_coord4fv_external( $v )
		end
	emgl_vertex_vector2d ( v:EM_VECTOR2D ) is
			--Wrap the OpenGL function `gl_vertex2dv`
		do
			gl_vertex2dv_external( $v )
		end
	emgl_vertex_vector2f ( v:EM_VECTOR2F ) is
			--Wrap the OpenGL function `gl_vertex2fv`
		do
			gl_vertex2fv_external( $v )
		end
	emgl_vertex_vector3d ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_vertex3dv`
		do
			gl_vertex3dv_external( $v )
		end
	emgl_vertex_vector3f ( v:EM_VECTOR3F ) is
			--Wrap the OpenGL function `gl_vertex3fv`
		do
			gl_vertex3fv_external( $v )
		end
	emgl_vertex_vector4d ( v:EM_VECTOR4D ) is
			--Wrap the OpenGL function `gl_vertex4dv`
		do
			gl_vertex4dv_external( $v )
		end
	emgl_vertex_vector4f ( v:EM_VECTOR4F ) is
			--Wrap the OpenGL function `gl_vertex4fv`
		do
			gl_vertex4fv_external( $v )
		end
	emgl_color_vector3d ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_color3dv`
		do
			gl_color3dv_external( $v )
		end
	emgl_color_vector3f ( v:EM_VECTOR3F ) is
			--Wrap the OpenGL function `gl_color3fv`
		do
			gl_color3fv_external( $v )
		end
	emgl_color_vector4d ( v:EM_VECTOR4D ) is
			--Wrap the OpenGL function `gl_color4dv`
		do
			gl_color4dv_external( $v )
		end
	emgl_color_vector4f ( v:EM_VECTOR4F ) is
			--Wrap the OpenGL function `gl_color4fv`
		do
			gl_color4fv_external( $v )
		end
	emgl_bitmap ( width:INTEGER; height:INTEGER; xorig:REAL; yorig:REAL; xmove:REAL; ymove:REAL; pbitmap:POINTER ) is
			--Wrap the OpenGL function `gl_bitmap`
		do
			gl_bitmap_external( width, height, xorig, yorig, xmove, ymove, pbitmap )
		end
	emgl_draw_pixels ( width:INTEGER; height:INTEGER; format:INTEGER; type:INTEGER; pixels:POINTER ) is
			--Wrap the OpenGL function `gl_draw_pixels`
		do
			gl_draw_pixels_external( width, height, format, type, pixels )
		end
	emgl_raster_pos2d ( x:DOUBLE; y:DOUBLE ) is
			--Wrap the OpenGL function `gl_raster_pos2d`
		do
			gl_raster_pos2d_external( x, y )
		end
	emgl_raster_pos2dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos2dv`
		do
			gl_raster_pos2dv_external( v )
		end
	emgl_raster_pos2f ( x:REAL; y:REAL ) is
			--Wrap the OpenGL function `gl_raster_pos2f`
		do
			gl_raster_pos2f_external( x, y )
		end
	emgl_raster_pos2fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos2fv`
		do
			gl_raster_pos2fv_external( v )
		end
	emgl_raster_pos2i ( x:INTEGER; y:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos2i`
		do
			gl_raster_pos2i_external( x, y )
		end
	emgl_raster_pos2iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos2iv`
		do
			gl_raster_pos2iv_external( v )
		end
	emgl_raster_pos2s ( x:INTEGER; y:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos2s`
		do
			gl_raster_pos2s_external( x, y )
		end
	emgl_raster_pos2sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos2sv`
		do
			gl_raster_pos2sv_external( v )
		end
	emgl_raster_pos3d ( x:DOUBLE; y:DOUBLE; z:DOUBLE ) is
			--Wrap the OpenGL function `gl_raster_pos3d`
		do
			gl_raster_pos3d_external( x, y, z )
		end
	emgl_raster_pos3dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos3dv`
		do
			gl_raster_pos3dv_external( v )
		end
	emgl_raster_pos3f ( x:REAL; y:REAL; z:REAL ) is
			--Wrap the OpenGL function `gl_raster_pos3f`
		do
			gl_raster_pos3f_external( x, y, z )
		end
	emgl_raster_pos3fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos3fv`
		do
			gl_raster_pos3fv_external( v )
		end
	emgl_raster_pos3i ( x:INTEGER; y:INTEGER; z:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos3i`
		do
			gl_raster_pos3i_external( x, y, z )
		end
	emgl_raster_pos3iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos3iv`
		do
			gl_raster_pos3iv_external( v )
		end
	emgl_raster_pos3s ( x:INTEGER; y:INTEGER; z:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos3s`
		do
			gl_raster_pos3s_external( x, y, z )
		end
	emgl_raster_pos3sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos3sv`
		do
			gl_raster_pos3sv_external( v )
		end
	emgl_raster_pos4d ( x:DOUBLE; y:DOUBLE; z:DOUBLE; w:DOUBLE ) is
			--Wrap the OpenGL function `gl_raster_pos4d`
		do
			gl_raster_pos4d_external( x, y, z, w )
		end
	emgl_raster_pos4dv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos4dv`
		do
			gl_raster_pos4dv_external( v )
		end
	emgl_raster_pos4f ( x:REAL; y:REAL; z:REAL; w:REAL ) is
			--Wrap the OpenGL function `gl_raster_pos4f`
		do
			gl_raster_pos4f_external( x, y, z, w )
		end
	emgl_raster_pos4fv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos4fv`
		do
			gl_raster_pos4fv_external( v )
		end
	emgl_raster_pos4i ( x:INTEGER; y:INTEGER; z:INTEGER; w:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos4i`
		do
			gl_raster_pos4i_external( x, y, z, w )
		end
	emgl_raster_pos4iv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos4iv`
		do
			gl_raster_pos4iv_external( v )
		end
	emgl_raster_pos4s ( x:INTEGER; y:INTEGER; z:INTEGER; w:INTEGER ) is
			--Wrap the OpenGL function `gl_raster_pos4s`
		do
			gl_raster_pos4s_external( x, y, z, w )
		end
	emgl_raster_pos4sv ( v:POINTER ) is
			--Wrap the OpenGL function `gl_raster_pos4sv`
		do
			gl_raster_pos4sv_external( v )
		end
	emgl_raster_pos_vector2d ( v:EM_VECTOR2D ) is
			--Wrap the OpenGL function `gl_raster_pos2dv`
		do
			gl_raster_pos2dv_external( $v )
		end
	emgl_raster_pos_vector2f ( v:EM_VECTOR2F ) is
			--Wrap the OpenGL function `gl_raster_pos2fv`
		do
			gl_raster_pos2fv_external( $v )
		end
	emgl_raster_pos_vector3d ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_raster_pos3dv`
		do
			gl_raster_pos3dv_external( $v )
		end
	emgl_raster_pos_vector3f ( v:EM_VECTOR3F ) is
			--Wrap the OpenGL function `gl_raster_pos3fv`
		do
			gl_raster_pos3fv_external( $v )
		end
	emgl_raster_pos_vector4d ( v:EM_VECTOR4D ) is
			--Wrap the OpenGL function `gl_raster_pos4dv`
		do
			gl_raster_pos4dv_external( $v )
		end
	emgl_raster_pos_vector4f ( v:EM_VECTOR4F ) is
			--Wrap the OpenGL function `gl_raster_pos4fv`
		do
			gl_raster_pos4fv_external( $v )
		end
	emgl_indexd ( c:DOUBLE ) is
			--Wrap the OpenGL function `gl_indexd`
		do
			gl_indexd_external( c )
		end
	emgl_indexdv ( c:POINTER ) is
			--Wrap the OpenGL function `gl_indexdv`
		do
			gl_indexdv_external( c )
		end
	emgl_indexf ( c:REAL ) is
			--Wrap the OpenGL function `gl_indexf`
		do
			gl_indexf_external( c )
		end
	emgl_indexfv ( c:POINTER ) is
			--Wrap the OpenGL function `gl_indexfv`
		do
			gl_indexfv_external( c )
		end
	emgl_indexi ( c:INTEGER ) is
			--Wrap the OpenGL function `gl_indexi`
		do
			gl_indexi_external( c )
		end
	emgl_indexiv ( c:POINTER ) is
			--Wrap the OpenGL function `gl_indexiv`
		do
			gl_indexiv_external( c )
		end
	emgl_indexs ( c:INTEGER ) is
			--Wrap the OpenGL function `gl_indexs`
		do
			gl_indexs_external( c )
		end
	emgl_indexsv ( c:POINTER ) is
			--Wrap the OpenGL function `gl_indexsv`
		do
			gl_indexsv_external( c )
		end
	emgl_indexub ( c:INTEGER ) is
			--Wrap the OpenGL function `gl_indexub`
		do
			gl_indexub_external( c )
		end
	emgl_indexubv ( c:POINTER ) is
			--Wrap the OpenGL function `gl_indexubv`
		do
			gl_indexubv_external( c )
		end
end -- class EMGL_BASIC_RENDERER
