indexing
	description: "OpenGL drawing funcitons"
	date: "$Date: 2006-09-29 06:40:52 +0200 (Fri, 29 Sep 2006) $"
	revision: "$Revision: 2287 $"

class
	EMGL_DRAW

inherit
	EMGL_FUNCTIONS
		export {NONE} all end

feature --general function wrapper
	emgl_accum ( op:INTEGER; value:REAL ) is
			--Wrap the OpenGL function `gl_accum`
		do
			gl_accum_external( op, value )
		end
	emgl_clear ( mask:INTEGER ) is
			--Wrap the OpenGL function `gl_clear`
		do
			gl_clear_external( mask )
		end
	emgl_clear_accum ( red:REAL; green:REAL; blue:REAL; alpha:REAL ) is
			--Wrap the OpenGL function `gl_clear_accum`
		do
			gl_clear_accum_external( red, green, blue, alpha )
		end
	emgl_clear_color ( red:REAL; green:REAL; blue:REAL; alpha:REAL ) is
			--Wrap the OpenGL function `gl_clear_color`
		do
			gl_clear_color_external( red, green, blue, alpha )
		end
	emgl_clear_depth ( depth:DOUBLE ) is
			--Wrap the OpenGL function `gl_clear_depth`
		do
			gl_clear_depth_external( depth )
		end
	emgl_clear_index ( c:REAL ) is
			--Wrap the OpenGL function `gl_clear_index`
		do
			gl_clear_index_external( c )
		end
	emgl_clear_stencil ( s:INTEGER ) is
			--Wrap the OpenGL function `gl_clear_stencil`
		do
			gl_clear_stencil_external( s )
		end
	emgl_copy_pixels ( x:INTEGER; y:INTEGER; width:INTEGER; height:INTEGER; type:INTEGER ) is
			--Wrap the OpenGL function `gl_copy_pixels`
		do
			gl_copy_pixels_external( x, y, width, height, type )
		end
	emgl_draw_buffer ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_draw_buffer`
		do
			gl_draw_buffer_external( mode )
		end
	emgl_finish is
			--Wrap the OpenGL function `gl_finish_externa`
		do
			gl_finish_external
		end
	emgl_flush is
			--Wrap the OpenGL function `gl_flush_externa`
		do
			gl_flush_external
		end
	emgl_read_pixels ( x:INTEGER; y:INTEGER; width:INTEGER; height:INTEGER; format:INTEGER; type:INTEGER; pixels:POINTER ) is
			--Wrap the OpenGL function `gl_read_pixels`
		do
			gl_read_pixels_external( x, y, width, height, format, type, pixels )
		end

feature --list handling
	emgl_gen_lists(range: INTEGER_32): INTEGER_32 is
			--Wrap the OpenGL function `gl_gen_lists`
		do
			RESULT := gl_gen_lists_external (range)
		end
	emgl_delete_lists (list, range: INTEGER_32) is
			--Wrap the OpenGL function `gl_delete_lists`
		do
			gl_delete_lists_external (list, range)
		end
	emgl_new_list (list, mode: INTEGER_32) is
			--Wrap the OpenGL function `gl_new_list`
		do
			gl_new_list_external (list, mode)
		end
	emgl_end_list is
			--Wrap the OpenGL function `gl_end_external`
		do
			gl_end_list_external
		end
	emgl_call_list (list: INTEGER_32) is
			--Wrap the OpenGL function `gl_call`
		do
			gl_call_list_external (list)
		end
end
