indexing
	description: "Description of class"
	documentation: "Documentation of class"
	date: "$Date: 2006-07-30 15:52:06 +0200 (Sun, 30 Jul 2006) $"
	revision: "$Revision: 2074 $"
	author: "thepk"

class EMGL_EVALUATOR

inherit
	ANY
	EMGL_FUNCTIONS
		export {NONE} all end

feature --general function wrapper
	emgl_eval_coord1d ( u:DOUBLE ) is
			--Wrap the OpenGL function `gl_eval_coord1d`
		do
			gl_eval_coord1d_external( u )
		end
	emgl_eval_coord1dv ( u:POINTER ) is
			--Wrap the OpenGL function `gl_eval_coord1dv`
		do
			gl_eval_coord1dv_external( u )
		end
	emgl_eval_coord1f ( u:REAL ) is
			--Wrap the OpenGL function `gl_eval_coord1f`
		do
			gl_eval_coord1f_external( u )
		end
	emgl_eval_coord1fv ( u:POINTER ) is
			--Wrap the OpenGL function `gl_eval_coord1fv`
		do
			gl_eval_coord1fv_external( u )
		end
	emgl_eval_coord2d ( u:DOUBLE; v:DOUBLE ) is
			--Wrap the OpenGL function `gl_eval_coord2d`
		do
			gl_eval_coord2d_external( u, v )
		end
	emgl_eval_coord2dv ( u:POINTER ) is
			--Wrap the OpenGL function `gl_eval_coord2dv`
		do
			gl_eval_coord2dv_external( u )
		end
	emgl_eval_coord2f ( u:REAL; v:REAL ) is
			--Wrap the OpenGL function `gl_eval_coord2f`
		do
			gl_eval_coord2f_external( u, v )
		end
	emgl_eval_coord2fv ( u:POINTER ) is
			--Wrap the OpenGL function `gl_eval_coord2fv`
		do
			gl_eval_coord2fv_external( u )
		end
	emgl_eval_mesh1 ( mode:INTEGER; i1:INTEGER; i2:INTEGER ) is
			--Wrap the OpenGL function `gl_eval_mesh1`
		do
			gl_eval_mesh1_external( mode, i1, i2 )
		end
	emgl_eval_mesh2 ( mode:INTEGER; i1:INTEGER; i2:INTEGER; j1:INTEGER; j2:INTEGER ) is
			--Wrap the OpenGL function `gl_eval_mesh2`
		do
			gl_eval_mesh2_external( mode, i1, i2, j1, j2 )
		end
	emgl_eval_point1 ( i:INTEGER ) is
			--Wrap the OpenGL function `gl_eval_point1`
		do
			gl_eval_point1_external( i )
		end
	emgl_eval_point2 ( i:INTEGER; j:INTEGER ) is
			--Wrap the OpenGL function `gl_eval_point2`
		do
			gl_eval_point2_external( i, j )
		end
	emgl_get_mapdv ( target:INTEGER; query:INTEGER; v:POINTER ) is
			--Wrap the OpenGL function `gl_get_mapdv`
		do
			gl_get_mapdv_external( target, query, v )
		end
	emgl_get_mapfv ( target:INTEGER; query:INTEGER; v:POINTER ) is
			--Wrap the OpenGL function `gl_get_mapfv`
		do
			gl_get_mapfv_external( target, query, v )
		end
	emgl_get_mapiv ( target:INTEGER; query:INTEGER; v:POINTER ) is
			--Wrap the OpenGL function `gl_get_mapiv`
		do
			gl_get_mapiv_external( target, query, v )
		end
	emgl_map1d ( target:INTEGER; u1:DOUBLE; u2:DOUBLE; stride:INTEGER; order:INTEGER; points:POINTER ) is
			--Wrap the OpenGL function `gl_map1d`
		do
			gl_map1d_external( target, u1, u2, stride, order, points )
		end
	emgl_map1f ( target:INTEGER; u1:REAL; u2:REAL; stride:INTEGER; order:INTEGER; points:POINTER ) is
			--Wrap the OpenGL function `gl_map1f`
		do
			gl_map1f_external( target, u1, u2, stride, order, points )
		end
	emgl_map2d ( target:INTEGER; u1:DOUBLE; u2:DOUBLE; ustride:INTEGER; uorder:INTEGER; v1:DOUBLE; v2:DOUBLE; vstride:INTEGER; vorder:INTEGER; points:POINTER ) is
			--Wrap the OpenGL function `gl_map2d`
		do
			gl_map2d_external( target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points )
		end
	emgl_map2f ( target:INTEGER; u1:REAL; u2:REAL; ustride:INTEGER; uorder:INTEGER; v1:REAL; v2:REAL; vstride:INTEGER; vorder:INTEGER; points:POINTER ) is
			--Wrap the OpenGL function `gl_map2f`
		do
			gl_map2f_external( target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points )
		end
	emgl_map_grid1d ( un:INTEGER; u1:DOUBLE; u2:DOUBLE ) is
			--Wrap the OpenGL function `gl_map_grid1d`
		do
			gl_map_grid1d_external( un, u1, u2 )
		end
	emgl_map_grid1f ( un:INTEGER; u1:REAL; u2:REAL ) is
			--Wrap the OpenGL function `gl_map_grid1f`
		do
			gl_map_grid1f_external( un, u1, u2 )
		end
	emgl_map_grid2d ( un:INTEGER; u1:DOUBLE; u2:DOUBLE; vn:INTEGER; v1:DOUBLE; v2:DOUBLE ) is
			--Wrap the OpenGL function `gl_map_grid2d`
		do
			gl_map_grid2d_external( un, u1, u2, vn, v1, v2 )
		end
	emgl_map_grid2f ( un:INTEGER; u1:REAL; u2:REAL; vn:INTEGER; v1:REAL; v2:REAL ) is
			--Wrap the OpenGL function `gl_map_grid2f`
		do
			gl_map_grid2f_external( un, u1, u2, vn, v1, v2 )
		end
	emgl_eval_coord_vector2d ( u:EM_VECTOR2D ) is
			--Wrap the OpenGL function `gl_eval_coord2dv`
		do
			gl_eval_coord2dv_external( $u )
		end
	emgl_eval_coord_vector2f ( u:EM_VECTOR2F ) is
			--Wrap the OpenGL function `gl_eval_coord2fv`
		do
			gl_eval_coord2fv_external( $u )
		end

end -- class EMGL_EVALUATOR
