indexing
	description: "General OpenGL settings"
	date: "$Date: 2007-01-17 10:47:31 +0100 (Wed, 17 Jan 2007) $"
	revision: "$Revision: 2414 $"

class
	EMGL_SETTINGS

inherit
	EMGL_FUNCTIONS
		export {NONE} all
			{ANY} emgl_get_boolean, emgl_get_double, emgl_get_float, emgl_get_integer
		end
	EM_CONSTANTS
		export {NONE} all end
	ANY

feature --general function wrapper
	emgl_get_tex_envfv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_get_tex_envfv`
		do
			gl_get_tex_envfv_external( em_gl_texture_env, pname, params )
		end
	emgl_get_tex_enviv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_get_tex_enviv`
		do
			gl_get_tex_enviv_external( em_gl_texture_env, pname, params )
		end
	emgl_tex_envf ( pname:INTEGER; param:REAL ) is
			--Wrap the OpenGL function `gl_tex_envf`
		do
			gl_tex_envf_external( em_gl_texture_env, pname, param )
		end
	emgl_tex_envfv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_tex_envfv`
		do
			gl_tex_envfv_external( em_gl_texture_env, pname, params )
		end
	emgl_tex_envi ( pname:INTEGER; param:INTEGER ) is
			--Wrap the OpenGL function `gl_tex_envi`
		do
			gl_tex_envi_external( em_gl_texture_env, pname, param )
		end
	emgl_tex_enviv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_tex_enviv`
		do
			gl_tex_enviv_external( em_gl_texture_env, pname, params )
		end
	emgl_get_booleanv( pname: INTEGER; params: POINTER ) is
			-- Return a single boolean Value as the current status of 'pname'
		do
			gl_get_booleanv_external( pname, params )
		end
	emgl_get_doublev( pname: INTEGER; params: POINTER ) is
			-- Return a single double Value as the current status of 'pname'
		do
			gl_get_doublev_external( pname, params )
		end
	emgl_get_floatv( pname: INTEGER; params: POINTER ) is
			-- Return a single real Value as the current status of 'pname'
		do
			gl_get_floatv_external( pname, params )
		end
	emgl_get_integerv( pname: INTEGER; params: POINTER ) is
			-- Return a single integer Value as the current status of 'pname'
		do
			gl_get_integerv_external( pname, params )
		end

	emgl_alpha_func ( func:INTEGER; ref:REAL ) is
			--Wrap the OpenGL function `gl_alpha_func`
		do
			gl_alpha_func_external( func, ref )
		end
	emgl_blend_func ( sfactor:INTEGER; dfactor:INTEGER ) is
			--Wrap the OpenGL function `gl_blend_func`
		do
			gl_blend_func_external( sfactor, dfactor )
		end
	emgl_color_mask ( red:INTEGER; green:INTEGER; blue:INTEGER; alpha:INTEGER ) is
			--Wrap the OpenGL function `gl_color_mask`
		do
			gl_color_mask_external( red, green, blue, alpha )
		end
	emgl_color_material ( face:INTEGER; mode:INTEGER ) is
			--Wrap the OpenGL function `gl_color_material`
		do
			gl_color_material_external( face, mode )
		end
	emgl_cull_face ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_cull_face`
		do
			gl_cull_face_external( mode )
		end
	emgl_depth_func ( func:INTEGER ) is
			--Wrap the OpenGL function `gl_depth_func`
		do
			gl_depth_func_external( func )
		end
	emgl_depth_mask ( flag:INTEGER ) is
			--Wrap the OpenGL function `gl_depth_mask`
		do
			gl_depth_mask_external( flag )
		end
	emgl_depth_range ( znear:DOUBLE; zfar:DOUBLE ) is
			--Wrap the OpenGL function `gl_depth_range`
		do
			gl_depth_range_external( znear, zfar )
		end
	emgl_disable ( cap:INTEGER ) is
			--Wrap the OpenGL function `gl_disable`
		do
			gl_disable_external( cap )
		end
	emgl_enable ( cap:INTEGER ) is
			--Wrap the OpenGL function `gl_enable`
		do
			gl_enable_external( cap )
		end
	emgl_fogf ( pname:INTEGER; param:REAL ) is
			--Wrap the OpenGL function `gl_fogf`
		do
			gl_fogf_external( pname, param )
		end
	emgl_fogfv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_fogfv`
		do
			gl_fogfv_external( pname, params )
		end
	emgl_fogi ( pname:INTEGER; param:INTEGER ) is
			--Wrap the OpenGL function `gl_fogi`
		do
			gl_fogi_external( pname, param )
		end
	emgl_fogiv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_fogiv`
		do
			gl_fogiv_external( pname, params )
		end
	emgl_front_face ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_front_face`
		do
			gl_front_face_external( mode )
		end
	emgl_get_clip_plane ( plane:INTEGER; equation:POINTER ) is
			--Wrap the OpenGL function `gl_get_clip_plane`
		do
			gl_get_clip_plane_external( plane, equation )
		end
	emgl_get_pixel_mapfv ( map:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_get_pixel_mapfv`
		do
			gl_get_pixel_mapfv_external( map, values )
		end
	emgl_get_pixel_mapuiv ( map:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_get_pixel_mapuiv`
		do
			gl_get_pixel_mapuiv_external( map, values )
		end
	emgl_get_pixel_mapusv ( map:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_get_pixel_mapusv`
		do
			gl_get_pixel_mapusv_external( map, values )
		end
	emgl_get_polygon_stipple ( mask:POINTER ) is
			--Wrap the OpenGL function `gl_get_polygon_stipple`
		do
			gl_get_polygon_stipple_external( mask )
		end
	emgl_light_modelf ( pname:INTEGER; param:REAL ) is
			--Wrap the OpenGL function `gl_light_modelf`
		do
			gl_light_modelf_external( pname, param )
		end
	emgl_light_modelfv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_light_modelfv`
		do
			gl_light_modelfv_external( pname, params )
		end
	emgl_light_modeli ( pname:INTEGER; param:INTEGER ) is
			--Wrap the OpenGL function `gl_light_modeli`
		do
			gl_light_modeli_external( pname, param )
		end
	emgl_light_modeliv ( pname:INTEGER; params:POINTER ) is
			--Wrap the OpenGL function `gl_light_modeliv`
		do
			gl_light_modeliv_external( pname, params )
		end
	emgl_index_mask ( mask:INTEGER ) is
			--Wrap the OpenGL function `gl_index_mask`
		do
			gl_index_mask_external( mask )
		end
	emgl_line_stipple ( factor:INTEGER; pattern:INTEGER ) is
			--Wrap the OpenGL function `gl_line_stipple`
		do
			gl_line_stipple_external( factor, pattern )
		end
	emgl_line_width ( width:REAL ) is
			--Wrap the OpenGL function `gl_line_width`
		do
			gl_line_width_external( width )
		end
	emgl_list_base ( base:INTEGER ) is
			--Wrap the OpenGL function `gl_list_base`
		do
			gl_list_base_external( base )
		end
	emgl_pixel_mapfv ( map:INTEGER; mapsize:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_pixel_mapfv`
		do
			gl_pixel_mapfv_external( map, mapsize, values )
		end
	emgl_pixel_mapuiv ( map:INTEGER; mapsize:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_pixel_mapuiv`
		do
			gl_pixel_mapuiv_external( map, mapsize, values )
		end
	emgl_pixel_mapusv ( map:INTEGER; mapsize:INTEGER; values:POINTER ) is
			--Wrap the OpenGL function `gl_pixel_mapusv`
		do
			gl_pixel_mapusv_external( map, mapsize, values )
		end
	emgl_pixel_storef ( pname:INTEGER; param:REAL ) is
			--Wrap the OpenGL function `gl_pixel_storef`
		do
			gl_pixel_storef_external( pname, param )
		end
	emgl_pixel_storei ( pname:INTEGER; param:INTEGER ) is
			--Wrap the OpenGL function `gl_pixel_storei`
		do
			gl_pixel_storei_external( pname, param )
		end
	emgl_pixel_transferf ( pname:INTEGER; param:REAL ) is
			--Wrap the OpenGL function `gl_pixel_transferf`
		do
			gl_pixel_transferf_external( pname, param )
		end
	emgl_pixel_transferi ( pname:INTEGER; param:INTEGER ) is
			--Wrap the OpenGL function `gl_pixel_transferi`
		do
			gl_pixel_transferi_external( pname, param )
		end
	emgl_pixel_zoom ( xfactor:REAL; yfactor:REAL ) is
			--Wrap the OpenGL function `gl_pixel_zoom`
		do
			gl_pixel_zoom_external( xfactor, yfactor )
		end
	emgl_point_size ( size:REAL ) is
			--Wrap the OpenGL function `gl_point_size`
		do
			gl_point_size_external( size )
		end
	emgl_polygon_mode ( face:INTEGER; mode:INTEGER ) is
			--Wrap the OpenGL function `gl_polygon_mode`
		do
			gl_polygon_mode_external( face, mode )
		end
	emgl_polygon_offset ( factor:REAL; units:REAL ) is
			--Wrap the OpenGL function `gl_polygon_offset`
		do
			gl_polygon_offset_external( factor, units )
		end
	emgl_polygon_stipple ( mask:POINTER ) is
			--Wrap the OpenGL function `gl_polygon_stipple`
		do
			gl_polygon_stipple_external( mask )
		end
	emgl_pop_attrib is
			--Wrap the OpenGL function `gl_pop_attrib_externa`
		do
			gl_pop_attrib_external
		end
	emgl_pop_client_attrib is
			--Wrap the OpenGL function `gl_pop_client_attrib_externa`
		do
			gl_pop_client_attrib_external
		end
	emgl_push_attrib ( mask:INTEGER ) is
			--Wrap the OpenGL function `gl_push_attrib`
		do
			gl_push_attrib_external( mask )
		end
	emgl_push_client_attrib ( mask:INTEGER ) is
			--Wrap the OpenGL function `gl_push_client_attrib`
		do
			gl_push_client_attrib_external( mask )
		end
	emgl_read_buffer ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_read_buffer`
		do
			gl_read_buffer_external( mode )
		end
	emgl_render_mode ( mode:INTEGER ): INTEGER is
			--Wrap the OpenGL function `gl_render_mode`
		do
			result:=gl_render_mode_external( mode )
		end
	emgl_shade_model ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_shade_model`
		do
			gl_shade_model_external( mode )
		end
	emgl_stencil_func ( func:INTEGER; ref:INTEGER; mask:INTEGER ) is
			--Wrap the OpenGL function `gl_stencil_func`
		do
			gl_stencil_func_external( func, ref, mask )
		end
	emgl_stencil_mask ( mask:INTEGER ) is
			--Wrap the OpenGL function `gl_stencil_mask`
		do
			gl_stencil_mask_external( mask )
		end
	emgl_stencil_op ( fail:INTEGER; zfail:INTEGER; zpass:INTEGER ) is
			--Wrap the OpenGL function `gl_stencil_op`
		do
			gl_stencil_op_external( fail, zfail, zpass )
		end
	emgl_logic_op ( opcode:INTEGER ) is
			--Wrap the OpenGL function `gl_logic_op`
		do
			gl_logic_op_external( opcode )
		end
	emgl_is_enabled (cap: INTEGER): BOOLEAN is
			-- Wrap OpenGL is_enalbed
		do
			result := gl_is_enabled_external ( cap ).to_boolean
		end
	emgl_hint (target, mode: INTEGER) is
			-- Wrap OpenGL hint
		do
			gl_hint_external (target, mode)
		end
feature --Attributes
	emgl_get_accum_alpha_bits:DOUBLE is
			-- returns one value, the number of alpha
			-- bitplanes in the accumulation buffer.
		do
			gl_get_doublev_external(em_gl_accum_alpha_bits, $result)
		end
	emgl_get_accum_blue_bits:DOUBLE is
			-- returns one value, the number  of  blue
			-- bitplanes in the accumulation buffer.
		do
			gl_get_doublev_external(em_gl_accum_blue_bits, $result)
		end
	emgl_get_accum_clear_value:EM_VECTOR4D is
			-- returns  four  values: the red, green,
			-- blue, and alpha values used to clear the accu-
			-- mulation    buffer.     Integer   values,   if
			-- requested, are linearly mapped from the inter-
			-- nal  floating-point  representation  such that
			-- 1.0 returns the  most  positive  representable
			-- integer value, and -1.0 returns the most nega-
			-- tive representable integer value. The  initial
			-- value is (0, 0, 0, 0).  See glClearAccum.
		do
			gl_get_doublev_external(em_gl_accum_clear_value, result)
		end
	emgl_get_accum_green_bits:DOUBLE is
			-- returns one value, the number of green
			-- bitplanes in the accumulation buffer.
		do
			gl_get_doublev_external(em_gl_accum_green_bits, $result)
		end
	emgl_get_accum_red_bits:DOUBLE is
			-- returns one value, the  number  of  red
			-- bitplanes in the accumulation buffer.
		do
			gl_get_doublev_external(em_gl_accum_red_bits, $result)
		end
	emgl_get_alpha_bias:DOUBLE is
			-- returns one value, the alpha bias fac-
			-- tor used during pixel transfers.  The  initial
			-- value is 0.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_alpha_bias, $result)
		end
	emgl_get_alpha_bits:DOUBLE is
			-- returns one value, the number of alpha
			-- bitplanes in each color buffer.
		do
			gl_get_doublev_external(em_gl_alpha_bits, $result)
		end
	emgl_get_alpha_scale:DOUBLE is
			-- returns one value, the alpha scale fac-
			-- tor  used  during pixel transfers. The initial
			-- value is 1.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_alpha_scale, $result)
		end
	emgl_is_alpha_test:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  alpha  testing  of  fragments is
			-- enabled. The initial value is  GL_FALSE.   See
			-- glAlphaFunc.
		do
			gl_get_booleanv_external(em_gl_alpha_test, $result)
		end
	emgl_get_alpha_test_func:DOUBLE is
			-- returns one value, the symbolic name of
			-- the alpha test function. The initial value  is
			-- GL_ALWAYS.  See glAlphaFunc.
		do
			gl_get_doublev_external(em_gl_alpha_test_func, $result)
		end
	emgl_get_alpha_test_ref:DOUBLE is
			-- returns one value, the reference value
			-- for the alpha test. The initial  value  is  0.
			-- See   glAlphaFunc.    An   integer  value,  if
			-- requested, is linearly mapped from the  inter-
			-- nal  floating-point  representation  such that
			-- 1.0 returns the  most  positive  representable
			-- integer value, and -1.0 returns the most nega-
			-- tive representable integer value.
		do
			gl_get_doublev_external(em_gl_alpha_test_ref, $result)
		end
	emgl_get_attrib_stack_depth:DOUBLE is
			-- returns one value,  the  depth  of  the
			-- attribute  stack.  If the stack is empty, 0 is
			-- returned.  The  initial  value  is   0.    See
			-- glPushAttrib.
		do
			gl_get_doublev_external(em_gl_attrib_stack_depth, $result)
		end
	emgl_is_auto_normal:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D  map  evaluation  automatically
			-- generates  surface  normals. The initial value
			-- is GL_FALSE.  See glMap2.
		do
			gl_get_booleanv_external(em_gl_auto_normal, $result)
		end
	emgl_get_aux_buffers:DOUBLE is
			-- returns one value, the number of auxil-
			-- iary color buffers. The initial value is 0.
		do
			gl_get_doublev_external(em_gl_aux_buffers, $result)
		end
	emgl_is_blend:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether blending is enabled.  The  initial
			-- value is GL_FALSE.  See glBlendFunc.
		do
			gl_get_booleanv_external(em_gl_blend, $result)
		end
	emgl_get_blend_color_ext:EM_VECTOR4D is
			-- returns  four  values, the red, green,
			-- blue, and alpha values which  are  the  compo-
			-- nents  of  the  blend  color.  See glBlendCol-
			-- orEXT.
		do
			gl_get_doublev_external(em_gl_blend_color_ext, result)
		end
	emgl_get_blend_dst:DOUBLE is
			-- returns one value,  the  symbolic  con-
			-- stant  identifying the destination blend func-
			-- tion.  The  initial  value  is  GL_ZERO.   See
			-- glBlendFunc.
		do
			gl_get_doublev_external(em_gl_blend_dst, $result)
		end
	emgl_get_blend_equation_ext:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating  whether  the  blend  equation   is
			-- GL_FUNC_ADD_EXT, GL_MIN_EXT or GL_MAX_EXT. See
			-- glBlendEquationEXT.
		do
			gl_get_doublev_external(em_gl_blend_equation_ext, $result)
		end
	emgl_get_blend_src:DOUBLE is
			-- returns one value,  the  symbolic  con-
			-- stant  identifying  the source blend function.
			-- The initial value is GL_ONE.  See glBlendFunc.
		do
			gl_get_doublev_external(em_gl_blend_src, $result)
		end
	emgl_get_blue_bias:DOUBLE is
			-- returns one value, the blue bias factor
			-- used during pixel transfers. The initial value
			-- is 0.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_blue_bias, $result)
		end
	emgl_get_blue_bits:DOUBLE is
			-- returns  one value, the number of blue
			-- bitplanes in each color buffer.
		do
			gl_get_doublev_external(em_gl_blue_bits, $result)
		end
	emgl_get_blue_scale:DOUBLE is
			-- returns one value, the blue scale  fac-
			-- tor  used  during pixel transfers. The initial
			-- value is 1.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_blue_scale, $result)
		end
	emgl_get_client_attrib_stack_depth:DOUBLE is
			-- returns one value indicating the  depth
			-- of  the  attribute stack. The initial value is
			-- 0.  See glPushClientAttrib.
		do
			gl_get_doublev_external(em_gl_client_attrib_stack_depth, $result)
		end
	emgl_is_clip_plane( i: INTEGER ):BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  the  specified clipping plane is
			-- enabled. The initial value is  GL_FALSE.   See
			-- glClipPlane.
		do
			gl_get_booleanv_external(em_gl_clip_plane0+i, $result)
		end
	emgl_is_color_array:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the color array  is  enabled.  The
			-- initial   value  is  GL_FALSE.   See  glColor-
			-- Pointer.
		do
			gl_get_booleanv_external(em_gl_color_array, $result)
		end
	emgl_get_color_array_size:INTEGER is
			-- returns one value, the number of compo-
			-- nents  per  color in the color array. The ini-
			-- tial value is 4. See glColorPointer.
		do
			gl_get_integerv_external(em_gl_color_array_size, $result)
		end
	emgl_get_color_array_stride:INTEGER is
			-- returns  one  value,  the  byte  offset
			-- between consecutive colors in the color array.
			-- The initial value is 0.  See glColorPointer.
		do
			gl_get_integerv_external(em_gl_color_array_stride, $result)
		end
	emgl_get_color_array_type:INTEGER is
			-- returns one value,  the  data  type  of
			-- each component in the color array. The initial
			-- value is GL_FLOAT. See glColorPointer.
		do
			gl_get_integerv_external(em_gl_color_array_type, $result)
		end
	emgl_get_color_clear_value:EM_VECTOR4D is
			-- returns four values:  the  red,  green,
			-- blue, and alpha values used to clear the color
			-- buffers.  Integer values,  if  requested,  are
			-- linearly  mapped  from  the internal floating-
			-- point representation such that 1.0 returns the
			-- most positive representable integer value, and
			-- -1.0 returns the most  negative  representable
			-- integer  value. The initial value is (0, 0, 0,
			-- 0).  See glClearColor.
		do
			gl_get_doublev_external(em_gl_color_clear_value, result)
		end
	emgl_is_color_logic_op:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether a fragment's RGBA color values are
			-- merged into the framebuffer  using  a  logical
			-- operation. The initial value is GL_FALSE.  See
			-- glLogicOp.
		do
			gl_get_booleanv_external(em_gl_color_logic_op, $result)
		end
	emgl_is_color_material:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  one  or more material parameters
			-- are tracking the current  color.  The  initial
			-- value is GL_FALSE.  See glColorMaterial.
		do
			gl_get_booleanv_external(em_gl_color_material, $result)
		end
	emgl_get_color_material_face:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating which materials  have  a  parameter
			-- that  is  tracking the current color. The ini-
			-- tial value is GL_FRONT_AND_BACK.  See glColor-
			-- Material.
		do
			gl_get_doublev_external(em_gl_color_material_face, $result)
		end
	emgl_get_color_material_parameter:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating  which  material   parameters   are
			-- tracking  the current color. The initial value
			-- is GL_AMBIENT_AND_DIFFUSE.   See  glColorMate-
			-- rial.
		do
			gl_get_doublev_external(em_gl_color_material_parameter, $result)
		end
	emgl_is_color_writemask:EM_VECTOR4D is
			-- returns  four boolean values: the red,
			-- green, blue, and alpha write enables  for  the
			-- color  buffers. The initial value is (GL_TRUE,
			-- GL_TRUE, GL_TRUE, GL_TRUE).  See  glColorMask.
		do
			gl_get_booleanv_external(em_gl_color_writemask, result)
		end
	emgl_is_cull_face:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether polygon culling  is  enabled.  The
			-- initial value is GL_FALSE.  See glCullFace.
		do
			gl_get_booleanv_external(em_gl_cull_face, $result)
		end
	emgl_get_cull_face_mode:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating  which  polygon  faces  are  to  be
			-- culled.  The  initial  value  is GL_BACK.  See
			-- glCullFace.
		do
			gl_get_doublev_external(em_gl_cull_face_mode, $result)
		end
	emgl_get_current_color:EM_VECTOR4D is
			-- returns four values:  the  red,  green,
			-- blue,  and  alpha values of the current color.
			-- Integer values,  if  requested,  are  linearly
			-- mapped from the internal floating-point repre-
			-- sentation such that 1.0 returns the most posi-
			-- tive  representable  integer  value,  and -1.0
			-- returns the most negative representable  inte-
			-- ger  value.  See glColor. The initial value is
			-- (1, 1, 1, 1).
		do
			gl_get_doublev_external(em_gl_current_color, result)
		end
	emgl_get_current_index:DOUBLE is
			-- returns one value,  the  current  color
			-- index. The initial value is 1.  See glIndex.
		do
			gl_get_doublev_external(em_gl_current_index, $result)
		end
	emgl_get_current_normal:EM_VECTOR2D is
			-- returns  three values: the x, y, and z
			-- values of the current normal.  Integer values,
			-- if  requested,  are  linearly  mapped from the
			-- internal  floating-point  representation  such
			-- that  1.0  returns  the  most  positive repre-
			-- sentable integer value, and -1.0  returns  the
			-- most  negative  representable  integer  value.
			-- The initial value is (0, 0, 1). See  glNormal.
		do
			gl_get_doublev_external(em_gl_current_normal, result)
		end
	emgl_get_current_raster_color:EM_VECTOR4D is
			-- returns  four  values: the red, green,
			-- blue, and alpha values of the  current  raster
			-- position.   Integer  values, if requested, are
			-- linearly mapped from  the  internal  floating-
			-- point representation such that 1.0 returns the
			-- most positive representable integer value, and
			-- -1.0  returns  the most negative representable
			-- integer value. The initial value is (1, 1,  1,
			-- 1).  See glRasterPos.
		do
			gl_get_doublev_external(em_gl_current_raster_color, result)
		end
	emgl_get_current_raster_distance:DOUBLE is
			-- returns  one  value, the distance from
			-- the eye to the current  raster  position.  The
			-- initial value is 0.  See glRasterPos.
		do
			gl_get_doublev_external(em_gl_current_raster_distance, $result)
		end
	emgl_get_current_raster_index:DOUBLE is
			-- returns  one value, the color index of
			-- the current raster position. The initial value
			-- is 1.  See glRasterPos.
		do
			gl_get_doublev_external(em_gl_current_raster_index, $result)
		end
	emgl_get_current_raster_position:EM_VECTOR4D is
			-- returns four values: the x, y, z, and w
			-- components of the current raster position.  x,
			-- y,  and  z are in window coordinates, and w is
			-- in clip coordinates. The initial value is  (0,
			-- 0, 0, 1).  See glRasterPos.
		do
			gl_get_doublev_external(em_gl_current_raster_position, result)
		end
	emgl_is_current_raster_position_valid:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the  current  raster  position  is
			-- valid.  The  initial  value  is  GL_TRUE.  See
			-- glRasterPos.
		do
			gl_get_booleanv_external(em_gl_current_raster_position_valid, $result)
		end
	emgl_get_current_raster_texture_coords:EM_VECTOR4D is
			-- returns four values: the s, t, r, and q
			-- current  raster  texture coordinates. The ini-
			-- tial value is (0, 0, 0, 1).   See  glRasterPos
			-- and glTexCoord.
		do
			gl_get_doublev_external(em_gl_current_raster_texture_coords, result)
		end
	emgl_get_current_texture_coords:EM_VECTOR4D is
			-- returns four values: the s, t, r, and q
			-- current texture coordinates. The initial value
			-- is (0, 0, 0, 1).  See glTexCoord.
		do
			gl_get_doublev_external(em_gl_current_texture_coords, result)
		end
	emgl_get_depth_bias:DOUBLE is
			-- returns one value, the depth bias fac-
			-- tor used during pixel transfers.  The  initial
			-- value is 0.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_depth_bias, $result)
		end
	emgl_get_depth_bits:DOUBLE is
			-- returns  one value, the number of bit-
			-- planes in the depth buffer.
		do
			gl_get_doublev_external(em_gl_depth_bits, $result)
		end
	emgl_get_depth_clear_value:DOUBLE is
			-- returns one value, the  value  that  is
			-- used  to clear the depth buffer.  Integer val-
			-- ues, if requested, are  linearly  mapped  from
			-- the   internal  floating-point  representation
			-- such that 1.0 returns the most positive repre-
			-- sentable  integer  value, and -1.0 returns the
			-- most negative representable integer value. The
			-- initial value is 1.  See glClearDepth.
		do
			gl_get_doublev_external(em_gl_depth_clear_value, $result)
		end
	emgl_get_depth_func:DOUBLE is
			-- returns  one  value, the symbolic con-
			-- stant  that  indicates  the  depth  comparison
			-- function.  The  initial value is GL_LESS.  See
			-- glDepthFunc.
		do
			gl_get_doublev_external(em_gl_depth_func, $result)
		end
	emgl_get_depth_range:EM_VECTOR2D is
			-- returns two values: the  near  and  far
			-- mapping  limits for the depth buffer.  Integer
			-- values, if requested, are linearly mapped from
			-- the   internal  floating-point  representation
			-- such that 1.0 returns the most positive repre-
			-- sentable  integer  value, and -1.0 returns the
			-- most negative representable integer value. The
			-- initial value is (0, 1).  See glDepthRange.
		do
			gl_get_doublev_external(em_gl_depth_range, result)
		end
	emgl_get_depth_scale:DOUBLE is
			-- returns one value, the depth scale fac-
			-- tor used during pixel transfers.  The  initial
			-- value is 1.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_depth_scale, $result)
		end
	emgl_is_depth_test:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether  depth  testing  of  fragments  is
			-- enabled.  The  initial value is GL_FALSE.  See
			-- glDepthFunc and glDepthRange.
		do
			gl_get_booleanv_external(em_gl_depth_test, $result)
		end
	emgl_is_depth_writemask:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  if  the depth buffer is enabled for writ-
			-- ing.  The  initial  value  is  GL_TRUE.    See
			-- glDepthMask.
		do
			gl_get_booleanv_external(em_gl_depth_writemask, $result)
		end
	emgl_is_dither:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether dithering of fragment  colors  and
			-- indices  is  enabled.  The  initial  value  is
			-- GL_TRUE.
		do
			gl_get_booleanv_external(em_gl_dither, $result)
		end
	emgl_is_doublebuffer:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether double buffering is supported.
		do
			gl_get_booleanv_external(em_gl_doublebuffer, $result)
		end
	emgl_get_draw_buffer:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating which buffers are being  drawn  to.
			-- See glDrawBuffer. The initial value is GL_BACK
			-- if there are back  buffers,  otherwise  it  is
			-- GL_FRONT.
		do
			gl_get_doublev_external(em_gl_draw_buffer, $result)
		end
	emgl_is_edge_flag:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the current edge flag  is  GL_TRUE
			-- or  GL_FALSE.  The  initial  value is GL_TRUE.
			-- See glEdgeFlag.
		do
			gl_get_booleanv_external(em_gl_edge_flag, $result)
		end
	emgl_is_edge_flag_array:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  the  edge flag array is enabled.
			-- The initial value is  GL_FALSE.   See  glEdge-
			-- FlagPointer.
		do
			gl_get_booleanv_external(em_gl_edge_flag_array, $result)
		end
	emgl_get_edge_flag_array_stride:DOUBLE is
			-- returns  one  value,  the  byte offset
			-- between consecutive edge  flags  in  the  edge
			-- flag  array.  The  initial  value  is  0.  See
			-- glEdgeFlagPointer.
		do
			gl_get_doublev_external(em_gl_edge_flag_array_stride, $result)
		end
	emgl_is_fog:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  fogging  is enabled. The initial
			-- value is GL_FALSE.  See glFog.
		do
			gl_get_booleanv_external(em_gl_fog, $result)
		end
	emgl_get_fog_color:EM_VECTOR4D is
			-- returns four values:  the  red,  green,
			-- blue,  and  alpha components of the fog color.
			-- Integer values,  if  requested,  are  linearly
			-- mapped from the internal floating-point repre-
			-- sentation such that 1.0 returns the most posi-
			-- tive  representable  integer  value,  and -1.0
			-- returns the most negative representable  inte-
			-- ger  value. The initial value is (0, 0, 0, 0).
			-- See glFog.
		do
			gl_get_doublev_external(em_gl_fog_color, result)
		end
	emgl_get_fog_density:DOUBLE is
			-- returns  one  value,  the  fog  density
			-- parameter. The initial value is 1.  See glFog.
		do
			gl_get_doublev_external(em_gl_fog_density, $result)
		end
	emgl_get_fog_end:DOUBLE is
			-- returns one value, the end  factor  for
			-- the  linear fog equation. The initial value is
			-- 1.  See glFog.
		do
			gl_get_doublev_external(em_gl_fog_end, $result)
		end
	emgl_get_fog_hint:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating  the mode of the fog hint. The ini-
			-- tial value is GL_DONT_CARE.  See glHint.
		do
			gl_get_doublev_external(em_gl_fog_hint, $result)
		end
	emgl_get_fog_index:DOUBLE is
			-- returns one value, the fog color index.
			-- The initial value is 0.  See glFog.
		do
			gl_get_doublev_external(em_gl_fog_index, $result)
		end
	emgl_get_fog_mode:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating which fog equation is selected. The
			-- initial value is GL_EXP.  See glFog.
		do
			gl_get_doublev_external(em_gl_fog_mode, $result)
		end
	emgl_get_fog_start:DOUBLE is
			-- returns one value, the start factor for
			-- the linear fog equation. The initial value  is
			-- 0.  See glFog.
		do
			gl_get_doublev_external(em_gl_fog_start, $result)
		end
	emgl_get_front_face:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating whether clockwise or  counterclock-
			-- wise  polygon winding is treated as front-fac-
			-- ing.  The  initial  value  is   GL_CCW.    See
			-- glFrontFace.
		do
			gl_get_doublev_external(em_gl_front_face, $result)
		end
	emgl_get_green_bias:DOUBLE is
			-- returns one value, the green bias fac-
			-- tor used during pixel transfers.  The  initial
			-- value is 0.
		do
			gl_get_doublev_external(em_gl_green_bias, $result)
		end
	emgl_get_green_bits:DOUBLE is
			-- returns one value, the number of green
			-- bitplanes in each color buffer.
		do
			gl_get_doublev_external(em_gl_green_bits, $result)
		end
	emgl_get_green_scale:DOUBLE is
			-- returns one value, the green scale fac-
			-- tor  used  during pixel transfers. The initial
			-- value is 1.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_green_scale, $result)
		end
	emgl_is_index_array:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether the color index array is enabled.
			-- The initial value is GL_FALSE.   See  glIndex-
			-- Pointer.
		do
			gl_get_booleanv_external(em_gl_index_array, $result)
		end
	emgl_get_index_array_stride:INTEGER is
			-- returns  one  value,  the  byte offset
			-- between consecutive color indexes in the color
			-- index  array.  The  initial  value  is 0.  See
			-- glIndexPointer.
		do
			gl_get_integerv_external(em_gl_index_array_stride, $result)
		end
	emgl_get_index_array_type:INTEGER is
			-- returns one value,  the  data  type  of
			-- indexes  in the color index array. The initial
			-- value is GL_FLOAT.  See glIndexPointer.
		do
			gl_get_integerv_external(em_gl_index_array_type, $result)
		end
	emgl_get_index_bits:INTEGER is
			-- returns one value, the number  of  bit-
			-- planes in each color index buffer.
		do
			gl_get_integerv_external(em_gl_index_bits, $result)
		end
	emgl_get_index_clear_value:DOUBLE is
			-- returns one value, the color index used
			-- to clear the color index buffers. The  initial
			-- value is 0.  See glClearIndex.
		do
			gl_get_doublev_external(em_gl_index_clear_value, $result)
		end
	emgl_is_index_logic_op:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether  a  fragment's  index  values  are
			-- merged  into  the  framebuffer using a logical
			-- operation. The initial value is GL_FALSE.  See
			-- glLogicOp.
		do
			gl_get_booleanv_external(em_gl_index_logic_op, $result)
		end
	emgl_is_index_mode:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the GL  is  in  color  index  mode
			-- (GL_TRUE) or RGBA mode (GL_FALSE).
		do
			gl_get_booleanv_external(em_gl_index_mode, $result)
		end
	emgl_get_index_offset:DOUBLE is
			-- returns one value, the offset added to
			-- color and stencil indices during pixel  trans-
			-- fers.  The  initial  value is 0.  See glPixel-
			-- Transfer.
		do
			gl_get_doublev_external(em_gl_index_offset, $result)
		end
	emgl_get_index_shift:DOUBLE is
			-- returns  one  value,  the  amount  that
			-- color  and  stencil indices are shifted during
			-- pixel transfers. The initial value is 0.   See
			-- glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_index_shift, $result)
		end
	emgl_get_index_writemask:DOUBLE is
			-- returns  one  value, a mask indicating
			-- which bitplanes of each color index buffer can
			-- be written. The initial value is all 1's.  See
			-- glIndexMask.
		do
			gl_get_doublev_external(em_gl_index_writemask, $result)
		end
	emgl_is_light( i: INTEGER ):BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  the  specified light is enabled.
			-- The initial value is  GL_FALSE.   See  glLight
			-- and glLightModel.
		do
			gl_get_booleanv_external(em_gl_light0+i, $result)
		end
	emgl_is_lighting:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether lighting is enabled.  The  initial
			-- value is GL_FALSE.  See glLightModel.
		do
			gl_get_booleanv_external(em_gl_lighting, $result)
		end
	emgl_get_light_model_ambient:EM_VECTOR4D is
			-- returns  four  values: the red, green,
			-- blue, and  alpha  components  of  the  ambient
			-- intensity  of  the entire scene.  Integer val-
			-- ues, if requested, are  linearly  mapped  from
			-- the   internal  floating-point  representation
			-- such that 1.0 returns the most positive repre-
			-- sentable  integer  value, and -1.0 returns the
			-- most negative representable integer value. The
			-- initial  value  is  (0.2, 0.2, 0.2, 1.0).  See
			-- glLightModel.
		do
			gl_get_doublev_external(em_gl_light_model_ambient, result)
		end
	emgl_is_light_model_local_viewer:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  specular reflection calculations
			-- treat the viewer as being local to the  scene.
			-- The  initial  value is GL_FALSE.  See glLight-
			-- Model.
		do
			gl_get_booleanv_external(em_gl_light_model_local_viewer, $result)
		end
	emgl_is_light_model_two_side:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  separate  materials  are used to
			-- compute lighting for  front-  and  back-facing
			-- polygons.  The initial value is GL_FALSE.  See
			-- glLightModel.
		do
			gl_get_booleanv_external(em_gl_light_model_two_side, $result)
		end
	emgl_is_line_smooth:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether antialiasing of lines is enabled.
			-- The   initial   value   is   GL_FALSE.     See
			-- glLineWidth.
		do
			gl_get_booleanv_external(em_gl_line_smooth, $result)
		end
	emgl_get_line_smooth_hint:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating the mode of the  line  antialiasing
			-- hint.  The initial value is GL_DONT_CARE.  See
			-- glHint.
		do
			gl_get_doublev_external(em_gl_line_smooth_hint, $result)
		end
	emgl_is_line_stipple:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether stippling of lines is enabled. The
			-- initial value is GL_FALSE.  See glLineStipple.
		do
			gl_get_booleanv_external(em_gl_line_stipple, $result)
		end
	emgl_get_line_stipple_pattern:DOUBLE is
			-- returns  one  value,  the  16-bit line
			-- stipple pattern. The initial value is all 1's.
			-- See glLineStipple.
		do
			gl_get_doublev_external(em_gl_line_stipple_pattern, $result)
		end
	emgl_get_line_stipple_repeat:DOUBLE is
			-- returns  one  value,  the line stipple
			-- repeat factor. The initial value  is  1.   See
			-- glLineStipple.
		do
			gl_get_doublev_external(em_gl_line_stipple_repeat, $result)
		end
	emgl_get_line_width:DOUBLE is
			-- returns  one  value, the line width as
			-- specified with glLineWidth. The initial  value
			-- is 1.
		do
			gl_get_doublev_external(em_gl_line_width, $result)
		end
	emgl_get_line_width_granularity:DOUBLE is
			-- returns one value, the width difference
			-- between   adjacent   supported   widths    for
			-- antialiased lines.  See glLineWidth.
		do
			gl_get_doublev_external(em_gl_line_width_granularity, $result)
		end
	emgl_get_line_width_range:EM_VECTOR2D is
			-- returns  two  values: the smallest and
			-- largest  supported  widths   for   antialiased
			-- lines.  See glLineWidth.
		do
			gl_get_doublev_external(em_gl_line_width_range, result)
		end
	emgl_get_list_base:DOUBLE is
			-- returns  one  value,  the  base offset
			-- added to all  names  in  arrays  presented  to
			-- glCallLists.  The  initial  value  is  0.  See
			-- glListBase.
		do
			gl_get_doublev_external(em_gl_list_base, $result)
		end
	emgl_get_list_index:DOUBLE is
			-- returns one value, the name of the dis-
			-- play  list currently under construction.  0 is
			-- returned if no display list is currently under
			-- construction.  The  initial  value  is 0.  See
			-- glNewList.
		do
			gl_get_doublev_external(em_gl_list_index, $result)
		end
	emgl_get_list_mode:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating  the  construction mode of the dis-
			-- play list currently  under  construction.  The
			-- initial value is 0.  See glNewList.
		do
			gl_get_doublev_external(em_gl_list_mode, $result)
		end
	emgl_get_logic_op_mode:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating the selected logic operation  mode.
			-- The  initial value is GL_COPY.  See glLogicOp.
		do
			gl_get_doublev_external(em_gl_logic_op_mode, $result)
		end
	emgl_is_map1_color_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  1D  evaluation generates colors.
			-- The initial value is GL_FALSE.  See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_color_4, $result)
		end
	emgl_get_map1_grid_domain:EM_VECTOR2D is
			-- returns two values:  the  endpoints  of
			-- the 1D map's grid domain. The initial value is
			-- (0, 1).  See glMapGrid.
		do
			gl_get_doublev_external(em_gl_map1_grid_domain, result)
		end
	emgl_get_map1_grid_segments:DOUBLE is
			-- returns one value, the number of parti-
			-- tions in the 1D map's grid domain. The initial
			-- value is 1.  See glMapGrid.
		do
			gl_get_doublev_external(em_gl_map1_grid_segments, $result)
		end
	emgl_is_map1_index:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  1D  evaluation  generates  color
			-- indices. The initial value is  GL_FALSE.   See
			-- glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_index, $result)
		end
	emgl_is_map1_normal:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation  generates  normals.
			-- The initial value is GL_FALSE.  See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_normal, $result)
		end
	emgl_is_map1_texture_coord_1:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation generates 1D texture
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_texture_coord_1, $result)
		end
	emgl_is_map1_texture_coord_2:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation generates 2D texture
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_texture_coord_2, $result)
		end
	emgl_is_map1_texture_coord_3:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation generates 3D texture
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_texture_coord_3, $result)
		end
	emgl_is_map1_texture_coord_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation generates 4D texture
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_texture_coord_4, $result)
		end
	emgl_is_map1_vertex_3:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D evaluation generates 3D  vertex
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_vertex_3, $result)
		end
	emgl_is_map1_vertex_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether 1D evaluation generates 4D vertex
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap1.
		do
			gl_get_booleanv_external(em_gl_map1_vertex_4, $result)
		end
	emgl_is_map2_color_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D  evaluation  generates  colors.
			-- The initial value is GL_FALSE.  See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_color_4, $result)
		end
	emgl_get_map2_grid_domain:EM_VECTOR4D is
			-- returns  four values: the endpoints of
			-- the 2D map's $i$ and  $j$  grid  domains.  The
			-- initial value is (0,1; 0,1).  See glMapGrid.
		do
			gl_get_doublev_external(em_gl_map2_grid_domain, result)
		end
	emgl_get_map2_grid_segments:EM_VECTOR2D is
			-- returns two values: the number of par-
			-- titions in the  2D  map's  $i$  and  $j$  grid
			-- domains.  The  initial  value  is  (1,1).  See
			-- glMapGrid.
		do
			gl_get_doublev_external(em_gl_map2_grid_segments, result)
		end
	emgl_is_map2_index:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  2D  evaluation  generates  color
			-- indices. The initial value is  GL_FALSE.   See
			-- glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_index, $result)
		end
	emgl_is_map2_normal:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation  generates  normals.
			-- The initial value is GL_FALSE.  See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_normal, $result)
		end
	emgl_is_map2_texture_coord_1:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation generates 1D texture
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_texture_coord_1, $result)
		end
	emgl_is_map2_texture_coord_2:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation generates 2D texture
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_texture_coord_2, $result)
		end
	emgl_is_map2_texture_coord_3:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation generates 3D texture
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_texture_coord_3, $result)
		end
	emgl_is_map2_texture_coord_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation generates 4D texture
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_texture_coord_4, $result)
		end
	emgl_is_map2_vertex_3:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D evaluation generates 3D  vertex
			-- coordinates.  The  initial  value is GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_vertex_3, $result)
		end
	emgl_is_map2_vertex_4:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether 2D evaluation generates 4D vertex
			-- coordinates. The initial  value  is  GL_FALSE.
			-- See glMap2.
		do
			gl_get_booleanv_external(em_gl_map2_vertex_4, $result)
		end
	emgl_is_map_color:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing if colors and  color  indices  are  to  be
			-- replaced  by  table lookup during pixel trans-
			-- fers. The  initial  value  is  GL_FALSE.   See
			-- glPixelTransfer.
		do
			gl_get_booleanv_external(em_gl_map_color, $result)
		end
	emgl_is_map_stencil:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing if stencil indices are to be  replaced  by
			-- table  lookup during pixel transfers. The ini-
			-- tial value is GL_FALSE.  See  glPixelTransfer.
		do
			gl_get_booleanv_external(em_gl_map_stencil, $result)
		end
	emgl_get_matrix_mode:INTEGER is
			-- returns one value, a symbolic constant
			-- indicating which matrix stack is currently the
			-- target  of  all matrix operations. The initial
			-- value is GL_MODELVIEW.  See glMatrixMode.
		do
			gl_get_integerv_external(em_gl_matrix_mode, $result)
		end
	emgl_get_max_client_attrib_stack_depth:DOUBLE is
			-- returns one value indicating the  maxi-
			-- mum  supported  depth  of the client attribute
			-- stack.  See glPushClientAttrib.
		do
			gl_get_doublev_external(em_gl_max_client_attrib_stack_depth, $result)
		end
	emgl_get_max_attrib_stack_depth:DOUBLE is
			-- returns one  value,  the  maximum  sup-
			-- ported depth of the attribute stack. The value
			-- must be at least 16.  See glPushAttrib.
		do
			gl_get_doublev_external(em_gl_max_attrib_stack_depth, $result)
		end
	emgl_get_max_clip_planes:DOUBLE is
			-- returns one value, the  maximum  number
			-- of  application-defined  clipping  planes. The
			-- value must be at least 6.  See glClipPlane.
		do
			gl_get_doublev_external(em_gl_max_clip_planes, $result)
		end
	emgl_get_max_eval_order:DOUBLE is
			-- returns one value, the maximum equation
			-- order  supported  by 1D and 2D evaluators. The
			-- value must be at  least  8.   See  glMap1  and
			-- glMap2.
		do
			gl_get_doublev_external(em_gl_max_eval_order, $result)
		end
	emgl_get_max_lights:DOUBLE is
			-- returns  one value, the maximum number
			-- of lights. The value must be at least 8.   See
			-- glLight.
		do
			gl_get_doublev_external(em_gl_max_lights, $result)
		end
	emgl_get_max_list_nesting:DOUBLE is
			-- returns  one value, the maximum recur-
			-- sion depth allowed during display-list traver-
			-- sal.  The  value  must  be  at  least 64.  See
			-- glCallList.
		do
			gl_get_doublev_external(em_gl_max_list_nesting, $result)
		end
	emgl_get_max_modelview_stack_depth:DOUBLE is
			-- returns one  value,  the  maximum  sup-
			-- ported  depth  of  the modelview matrix stack.
			-- The value must be at least 32.  See  glPushMa-
			-- trix.
		do
			gl_get_doublev_external(em_gl_max_modelview_stack_depth, $result)
		end
	emgl_get_max_name_stack_depth:DOUBLE is
			-- returns  one  value,  the maximum sup-
			-- ported depth of the selection name stack.  The
			-- value must be at least 64.  See glPushName.
		do
			gl_get_doublev_external(em_gl_max_name_stack_depth, $result)
		end
	emgl_get_max_pixel_map_table:INTEGER is
			-- returns  one  value,  the maximum sup-
			-- ported size of a glPixelMap lookup table.  The
			-- value must be at least 32.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_max_pixel_map_table, $result)
		end
	emgl_get_max_projection_stack_depth:DOUBLE is
			-- returns  one  value,  the maximum sup-
			-- ported depth of the projection  matrix  stack.
			-- The  value  must be at least 2.  See glPushMa-
			-- trix.
		do
			gl_get_doublev_external(em_gl_max_projection_stack_depth, $result)
		end
	emgl_get_max_texture_size:INTEGER is
			-- returns one value.  The value  gives  a
			-- rough estimate of the largest texture that the
			-- GL can handle.  If the GL version  is  1.1  or
			-- greater,     use     GL_PROXY_TEXTURE_1D    or
			-- GL_PROXY_TEXTURE_2D to determine if a  texture
			-- is  too  large.  See glTexImage1D and glTexIm-
			-- age2D.
		do
			gl_get_integerv_external(em_gl_max_texture_size, $result)
		end
	emgl_get_max_texture_stack_depth:DOUBLE is
			-- returns one  value,  the  maximum  sup-
			-- ported  depth of the texture matrix stack. The
			-- value must be at least 2.  See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_max_texture_stack_depth, $result)
		end
	emgl_get_max_viewport_dims:EM_VECTOR2D is
			-- returns two values:  the  maximum  sup-
			-- ported  width  and  height  of  the  viewport.
			-- These must be at least as large as the visible
			-- dimensions  of  the display being rendered to.
			-- See glViewport.
		do
			gl_get_doublev_external(em_gl_max_viewport_dims, result)
		end
	emgl_get_modelview_matrix:EM_MATRIX44 is
			-- returns sixteen values:  the  modelview
			-- matrix  on  the  top  of  the modelview matrix
			-- stack. Initially this matrix is  the  identity
			-- matrix. See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_modelview_matrix, result)
		end
	emgl_get_modelview_stack_depth:DOUBLE is
			-- returns one value, the number of matri-
			-- ces on the modelview matrix stack.   The  ini-
			-- tial value is 1.  See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_modelview_stack_depth, $result)
		end
	emgl_get_name_stack_depth:DOUBLE is
			-- returns one value, the number of names
			-- on the selection name stack. The initial value
			-- is 0.  See glPushName.
		do
			gl_get_doublev_external(em_gl_name_stack_depth, $result)
		end
	emgl_is_normal_array:BOOLEAN is
			-- returns  a single boolean value, indi-
			-- cating whether the normal  array  is  enabled.
			-- The  initial value is GL_FALSE.  See glNormal-
			-- Pointer.
		do
			gl_get_booleanv_external(em_gl_normal_array, $result)
		end
	emgl_get_normal_array_stride:INTEGER is
			-- returns  one  value,  the  byte  offset
			-- between  consecutive  normals  in  the  normal
			-- array. The initial value is 0.  See  glNormal-
			-- Pointer.
		do
			gl_get_integerv_external(em_gl_normal_array_stride, $result)
		end
	emgl_get_normal_array_type:INTEGER is
			-- returns  one  value,  the data type of
			-- each coordinate in the normal array. The  ini-
			-- tial  value is GL_FLOAT.  See glNormalPointer.
		do
			gl_get_integerv_external(em_gl_normal_array_type, $result)
		end
	emgl_is_normalize:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  normals are automatically scaled
			-- to unit length after  they  have  been  trans-
			-- formed  to  eye coordinates. The initial value
			-- is GL_FALSE.  See glNormal.
		do
			gl_get_booleanv_external(em_gl_normalize, $result)
		end
	emgl_get_pack_alignment:DOUBLE is
			-- returns one value, the  byte  alignment
			-- used  for  writing  pixel  data to memory. The
			-- initial value is 4.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_pack_alignment, $result)
		end
	emgl_is_pack_lsb_first:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether single-bit pixels being written to
			-- memory are written first to the least signifi-
			-- cant  bit  of  each unsigned byte. The initial
			-- value is GL_FALSE.  See glPixelStore.
		do
			gl_get_booleanv_external(em_gl_pack_lsb_first, $result)
		end
	emgl_get_pack_row_length:DOUBLE is
			-- returns one value, the row length  used
			-- for  writing pixel data to memory. The initial
			-- value is 0.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_pack_row_length, $result)
		end
	emgl_get_pack_skip_pixels:DOUBLE is
			-- returns one value, the number of  pixel
			-- locations  skipped  before  the first pixel is
			-- written into memory. The initial value  is  0.
			-- See glPixelStore.
		do
			gl_get_doublev_external(em_gl_pack_skip_pixels, $result)
		end
	emgl_get_pack_skip_rows:DOUBLE is
			-- returns  one value, the number of rows
			-- of pixel locations skipped  before  the  first
			-- pixel  is  written  into  memory.  The initial
			-- value is 0.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_pack_skip_rows, $result)
		end
	emgl_is_pack_swap_bytes:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  the  bytes of two-byte and four-
			-- byte pixel indices and components are  swapped
			-- before  being  written  to memory. The initial
			-- value is GL_FALSE.  See glPixelStore.
		do
			gl_get_booleanv_external(em_gl_pack_swap_bytes, $result)
		end
	emgl_get_perspective_correction_hint:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating the mode of the perspective correc-
			-- tion hint. The initial value is  GL_DONT_CARE.
			-- See glHint.
		do
			gl_get_doublev_external(em_gl_perspective_correction_hint, $result)
		end
	emgl_get_pixel_map_a_to_a_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- alpha-to-alpha pixel translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_a_to_a_size, $result)
		end
	emgl_get_pixel_map_b_to_b_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- blue-to-blue  pixel  translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_b_to_b_size, $result)
		end
	emgl_get_pixel_map_g_to_g_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- green-to-green pixel translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_g_to_g_size, $result)
		end
	emgl_get_pixel_map_i_to_a_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- index-to-alpha pixel translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_i_to_a_size, $result)
		end
	emgl_get_pixel_map_i_to_b_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- index-to-blue pixel  translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_i_to_b_size, $result)
		end
	emgl_get_pixel_map_i_to_g_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- index-to-green pixel translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_i_to_g_size, $result)
		end
	emgl_get_pixel_map_i_to_i_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- index-to-index pixel translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_i_to_i_size, $result)
		end
	emgl_get_pixel_map_i_to_r_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- index-to-red  pixel  translation  table.   The
			-- initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_i_to_r_size, $result)
		end
	emgl_get_pixel_map_r_to_r_size:INTEGER is
			-- returns one value, the size of the red-
			-- to-red pixel translation table.   The  initial
			-- value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_r_to_r_size, $result)
		end
	emgl_get_pixel_map_s_to_s_size:INTEGER is
			-- returns  one  value,  the  size of the
			-- stencil-to-stencil  pixel  translation  table.
			-- The initial value is 1.  See glPixelMap.
		do
			gl_get_integerv_external(em_gl_pixel_map_s_to_s_size, $result)
		end
	emgl_get_point_size:DOUBLE is
			-- returns  one  value, the point size as
			-- specified by glPointSize. The initial value is
			-- 1.
		do
			gl_get_doublev_external(em_gl_point_size, $result)
		end
	emgl_get_point_size_granularity:DOUBLE is
			-- returns one value, the size difference
			-- between   adjacent   supported    sizes    for
			-- antialiased points.  See glPointSize.
		do
			gl_get_doublev_external(em_gl_point_size_granularity, $result)
		end
	emgl_get_point_size_range:EM_VECTOR2D is
			-- returns  two  values: the smallest and
			-- largest  supported   sizes   for   antialiased
			-- points.  The  smallest size must be at most 1,
			-- and the largest size must be at least 1.   See
			-- glPointSize.
		do
			gl_get_doublev_external(em_gl_point_size_range, result)
		end
	emgl_is_point_smooth:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether antialiasing of points is enabled.
			-- The  initial  value is GL_FALSE.  See glPoint-
			-- Size.
		do
			gl_get_booleanv_external(em_gl_point_smooth, $result)
		end
	emgl_get_point_smooth_hint:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating  the mode of the point antialiasing
			-- hint. The initial value is GL_DONT_CARE.   See
			-- glHint.
		do
			gl_get_doublev_external(em_gl_point_smooth_hint, $result)
		end
	emgl_get_polygon_mode:EM_VECTOR2D is
			-- returns two values: symbolic constants
			-- indicating whether front-facing and  back-fac-
			-- ing  polygons are rasterized as points, lines,
			-- or  filled  polygons.  The  initial  value  is
			-- GL_FILL.  See glPolygonMode.
		do
			gl_get_doublev_external(em_gl_polygon_mode, result)
		end
	emgl_get_polygon_offset_factor:DOUBLE is
			-- returns  one value, the scaling factor
			-- used to determine the variable offset that  is
			-- added to the depth value of each fragment gen-
			-- erated when a polygon is rasterized. The  ini-
			-- tial value is 0.  See glPolygonOffset.
		do
			gl_get_doublev_external(em_gl_polygon_offset_factor, $result)
		end
	emgl_get_polygon_offset_units:DOUBLE is
			-- returns one value.  This value is mul-
			-- tiplied by  an  implementation-specific  value
			-- and  then  added  to  the  depth value of each
			-- fragment generated when a polygon  is  raster-
			-- ized.  The  initial  value  is 0.  See glPoly-
			-- gonOffset.
		do
			gl_get_doublev_external(em_gl_polygon_offset_units, $result)
		end
	emgl_is_polygon_offset_fill:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  polygon  offset  is  enabled for
			-- polygons in fill mode. The  initial  value  is
			-- GL_FALSE.  See glPolygonOffset.
		do
			gl_get_booleanv_external(em_gl_polygon_offset_fill, $result)
		end
	emgl_is_polygon_offset_line:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether  polygon  offset  is  enabled  for
			-- polygons  in  line  mode. The initial value is
			-- GL_FALSE.  See glPolygonOffset.
		do
			gl_get_booleanv_external(em_gl_polygon_offset_line, $result)
		end
	emgl_is_polygon_offset_point:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  polygon  offset  is  enabled for
			-- polygons in point mode. The initial  value  is
			-- GL_FALSE.  See glPolygonOffset.
		do
			gl_get_booleanv_external(em_gl_polygon_offset_point, $result)
		end
	emgl_is_polygon_smooth:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  antialiasing  of   polygons   is
			-- enabled.  The  initial value is GL_FALSE.  See
			-- glPolygonMode.
		do
			gl_get_booleanv_external(em_gl_polygon_smooth, $result)
		end
	emgl_get_polygon_smooth_hint:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating  the mode of the polygon antialias-
			-- ing hint. The initial value  is  GL_DONT_CARE.
			-- See glHint.
		do
			gl_get_doublev_external(em_gl_polygon_smooth_hint, $result)
		end
	emgl_is_polygon_stipple:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether polygon stippling is enabled.  The
			-- initial value is GL_FALSE.  See glPolygonStip-
			-- ple.
		do
			gl_get_booleanv_external(em_gl_polygon_stipple, $result)
		end
	emgl_get_projection_matrix:EM_MATRIX44 is
			-- returns sixteen values: the  projection
			-- matrix  on  the  top  of the projection matrix
			-- stack. Initially this matrix is  the  identity
			-- matrix.  See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_projection_matrix, result)
		end
	emgl_get_projection_stack_depth:DOUBLE is
			-- returns one value, the number of matri-
			-- ces on the projection matrix stack.  The  ini-
			-- tial value is 1.  See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_projection_stack_depth, $result)
		end
	emgl_get_read_buffer:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating which color buffer is selected  for
			-- reading. The initial value is GL_BACK if there
			-- is a back buffer, otherwise  it  is  GL_FRONT.
			-- See glReadPixels and glAccum.
		do
			gl_get_doublev_external(em_gl_read_buffer, $result)
		end
	emgl_get_red_bias:DOUBLE is
			-- returns one value, the red bias factor
			-- used during pixel transfers. The initial value
			-- is 0.
		do
			gl_get_doublev_external(em_gl_red_bias, $result)
		end
	emgl_get_red_bits:DOUBLE is
			-- returns  one  value, the number of red
			-- bitplanes in each color buffer.
		do
			gl_get_doublev_external(em_gl_red_bits, $result)
		end
	emgl_get_red_scale:DOUBLE is
			-- returns one value, the red scale factor
			-- used during pixel transfers. The initial value
			-- is 1.  See glPixelTransfer.
		do
			gl_get_doublev_external(em_gl_red_scale, $result)
		end
	emgl_get_render_mode:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating   whether  the  GL  is  in  render,
			-- select, or feedback mode. The initial value is
			-- GL_RENDER.  See glRenderMode.
		do
			gl_get_doublev_external(em_gl_render_mode, $result)
		end
	emgl_is_rgba_mode:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the GL is in RGBA mode  (true)  or
			-- color index mode (false).  See glColor.
		do
			gl_get_booleanv_external(em_gl_rgba_mode, $result)
		end
	emgl_get_scissor_box:EM_VECTOR4I is
			-- returns  four  values: the $x$ and $y$
			-- window coordinates of the  scissor  box,  fol-
			-- lowed  by its width and height.  Initially the
			-- $x$ and $y$ window coordinates are both 0  and
			-- the  width  and  height are set to the size of
			-- the window.  See glScissor.
		do
			gl_get_integerv_external(em_gl_scissor_box, result)
		end
	emgl_is_scissor_test:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether scissoring is enabled. The initial
			-- value is GL_FALSE.  See glScissor.
		do
			gl_get_booleanv_external(em_gl_scissor_test, $result)
		end
	emgl_get_shade_model:INTEGER is
			-- returns one value, a symbolic  constant
			-- indicating whether the shading mode is flat or
			-- smooth. The initial value is  GL_SMOOTH.   See
			-- glShadeModel.
		do
			gl_get_integerv_external(em_gl_shade_model, $result)
		end
	emgl_get_stencil_bits:INTEGER is
			-- returns  one value, the number of bit-
			-- planes in the stencil buffer.
		do
			gl_get_integerv_external(em_gl_stencil_bits, $result)
		end
	emgl_get_stencil_clear_value:DOUBLE is
			-- returns one value, the index  to  which
			-- the stencil bitplanes are cleared. The initial
			-- value is 0.  See glClearStencil.
		do
			gl_get_doublev_external(em_gl_stencil_clear_value, $result)
		end
	emgl_get_stencil_fail:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating what action is taken when the sten-
			-- cil test fails. The initial value is  GL_KEEP.
			-- See glStencilOp.
		do
			gl_get_doublev_external(em_gl_stencil_fail, $result)
		end
	emgl_get_stencil_func:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating what function is  used  to  compare
			-- the  stencil  reference value with the stencil
			-- buffer value. The initial value is  GL_ALWAYS.
			-- See glStencilFunc.
		do
			gl_get_doublev_external(em_gl_stencil_func, $result)
		end
	emgl_get_stencil_pass_depth_fail:DOUBLE is
			-- returns one value, a symbolic constant
			-- indicating what action is taken when the sten-
			-- cil test passes, but the depth test fails. The
			-- initial value is GL_KEEP.  See glStencilOp.
		do
			gl_get_doublev_external(em_gl_stencil_pass_depth_fail, $result)
		end
	emgl_get_stencil_pass_depth_pass:DOUBLE is
			-- returns one value, a symbolic  constant
			-- indicating what action is taken when the sten-
			-- cil test passes and the depth test passes. The
			-- initial value is GL_KEEP.  See glStencilOp.
		do
			gl_get_doublev_external(em_gl_stencil_pass_depth_pass, $result)
		end
	emgl_get_stencil_ref:DOUBLE is
			-- returns one value, the reference value
			-- that is compared  with  the  contents  of  the
			-- stencil  buffer.  The initial value is 0.  See
			-- glStencilFunc.
		do
			gl_get_doublev_external(em_gl_stencil_ref, $result)
		end
	emgl_is_stencil_test:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  stencil  testing of fragments is
			-- enabled. The initial value is  GL_FALSE.   See
			-- glStencilFunc and glStencilOp.
		do
			gl_get_booleanv_external(em_gl_stencil_test, $result)
		end
	emgl_get_stencil_value_mask:DOUBLE is
			-- returns  one  value,  the mask that is
			-- used to mask both the stencil reference  value
			-- and  the  stencil buffer value before they are
			-- compared. The initial value is all  1's.   See
			-- glStencilFunc.
		do
			gl_get_doublev_external(em_gl_stencil_value_mask, $result)
		end
	emgl_get_stencil_writemask:DOUBLE is
			-- returns  one value, the mask that con-
			-- trols writing of the  stencil  bitplanes.  The
			-- initial value is all 1's. See glStencilMask.
		do
			gl_get_doublev_external(em_gl_stencil_writemask, $result)
		end
	emgl_is_stereo:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether stereo buffers  (left  and  right)
			-- are supported.
		do
			gl_get_booleanv_external(em_gl_stereo, $result)
		end
	emgl_get_subpixel_bits:INTEGER is
			-- returns  one value, an estimate of the
			-- number of bits of subpixel resolution that are
			-- used to position rasterized geometry in window
			-- coordinates. The initial value is 4.
		do
			gl_get_integerv_external(em_gl_subpixel_bits, $result)
		end
	emgl_is_texture_1d:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 1D texture mapping is enabled. The
			-- initial value is GL_FALSE.  See  glTexImage1D.
		do
			gl_get_booleanv_external(em_gl_texture_1d, $result)
		end
	emgl_get_texture_1d_binding:INTEGER is
			-- returns a single value, the name of the
			-- texture currently bound to the target  GL_TEX-
			-- TURE_1D.  The initial value is 0.  See glBind-
			-- Texture.
		do
			gl_get_integerv_external(em_gl_texture_binding_1d, $result)
		end
	emgl_is_texture_2d:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether 2D texture mapping is enabled. The
			-- initial value is GL_FALSE.  See  glTexImage2D.
		do
			gl_get_booleanv_external(em_gl_texture_2d, $result)
		end
	emgl_get_texture_2d_binding:INTEGER is
			-- returns a single value, the name of the
			-- texture currently bound to the target  GL_TEX-
			-- TURE_2D.  The initial value is 0.  See glBind-
			-- Texture.
		do
			gl_get_integerv_external(em_gl_texture_binding_2d, $result)
		end
	emgl_is_texture_coord_array:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing  whether  the  texture coordinate array is
			-- enabled. The initial value is  GL_FALSE.   See
			-- glTexCoordPointer.
		do
			gl_get_booleanv_external(em_gl_texture_coord_array, $result)
		end
	emgl_get_texture_coord_array_size:INTEGER is
			-- returns one value, the number of coor-
			-- dinates per element in the texture  coordinate
			-- array.  The  initial value is 4.  See glTexCo-
			-- ordPointer.
		do
			gl_get_integerv_external(em_gl_texture_coord_array_size, $result)
		end
	emgl_get_texture_coord_array_stride:INTEGER is
			-- returns  one  value,  the  byte  offset
			-- between  consecutive  elements  in the texture
			-- coordinate array. The initial value is 0.  See
			-- glTexCoordPointer.
		do
			gl_get_integerv_external(em_gl_texture_coord_array_stride, $result)
		end
	emgl_get_texture_coord_array_type:INTEGER is
			-- returns one value, the data type of the
			-- coordinates in the texture  coordinate  array.
			-- The  initial  value is GL_FLOAT.  See glTexCo-
			-- ordPointer.
		do
			gl_get_integerv_external(em_gl_texture_coord_array_type, $result)
		end
	emgl_is_texture_gen_q:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether automatic generation of the q tex-
			-- ture coordinate is enabled. The initial  value
			-- is GL_FALSE.  See glTexGen.
		do
			gl_get_booleanv_external(em_gl_texture_gen_q, $result)
		end
	emgl_is_texture_gen_r:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether automatic generation of the r tex-
			-- ture  coordinate is enabled. The initial value
			-- is GL_FALSE.  See glTexGen.
		do
			gl_get_booleanv_external(em_gl_texture_gen_r, $result)
		end
	emgl_is_texture_gen_s:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether automatic generation of the S tex-
			-- ture coordinate is enabled. The initial  value
			-- is GL_FALSE.  See glTexGen.
		do
			gl_get_booleanv_external(em_gl_texture_gen_s, $result)
		end
	emgl_is_texture_gen_t:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether automatic generation of the T tex-
			-- ture  coordinate is enabled. The initial value
			-- is GL_FALSE.  See glTexGen.
		do
			gl_get_booleanv_external(em_gl_texture_gen_t, $result)
		end
	emgl_get_texture_matrix:EM_MATRIX44 is
			-- returns  sixteen  values:  the  texture
			-- matrix on the top of the texture matrix stack.
			-- Initially this matrix is the identity  matrix.
			-- See glPushMatrix.
		do
			gl_get_doublev_external(em_gl_texture_matrix, result)
		end
	emgl_get_texture_stack_depth:INTEGER is
			-- returns one value, the number of matri-
			-- ces on the texture matrix stack.  The  initial
			-- value is 1.  See glPushMatrix.
		do
			gl_get_integerv_external(em_gl_texture_stack_depth, $result)
		end
	emgl_get_unpack_alignment:DOUBLE is
			-- returns  one value, the byte alignment
			-- used for reading pixel data from  memory.  The
			-- initial value is 4.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_unpack_alignment, $result)
		end
	emgl_is_unpack_lsb_first:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether single-bit pixels being read  from
			-- memory  are read first from the least signifi-
			-- cant bit of each unsigned  byte.  The  initial
			-- value is GL_FALSE.  See glPixelStore.
		do
			gl_get_booleanv_external(em_gl_unpack_lsb_first, $result)
		end
	emgl_get_unpack_row_length:DOUBLE is
			-- returns one value, the row length used
			-- for reading pixel data from memory.  The  ini-
			-- tial value is 0.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_unpack_row_length, $result)
		end
	emgl_get_unpack_skip_pixels:DOUBLE is
			-- returns one value, the number of pixel
			-- locations skipped before the  first  pixel  is
			-- read from memory. The initial value is 0.  See
			-- glPixelStore.
		do
			gl_get_doublev_external(em_gl_unpack_skip_pixels, $result)
		end
	emgl_get_unpack_skip_rows:DOUBLE is
			-- returns one value, the number  of  rows
			-- of  pixel  locations  skipped before the first
			-- pixel is read from memory. The  initial  value
			-- is 0.  See glPixelStore.
		do
			gl_get_doublev_external(em_gl_unpack_skip_rows, $result)
		end
	emgl_is_unpack_swap_bytes:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the bytes of  two-byte  and  four-
			-- byte  pixel indices and components are swapped
			-- after being  read  from  memory.  The  initial
			-- value is GL_FALSE.  See glPixelStore.
		do
			gl_get_booleanv_external(em_gl_unpack_swap_bytes, $result)
		end
	emgl_is_vertex_array:BOOLEAN is
			-- returns a single boolean value indicat-
			-- ing whether the vertex array is  enabled.  The
			-- initial  value  is  GL_FALSE.   See  glVertex-
			-- Pointer.
		do
			gl_get_booleanv_external(em_gl_vertex_array, $result)
		end
	emgl_get_vertex_array_size:INTEGER is
			-- returns one value, the number of  coor-
			-- dinates  per  vertex  in the vertex array. The
			-- initial value is 4.  See glVertexPointer.
		do
			gl_get_integerv_external(em_gl_vertex_array_size, $result)
		end
	emgl_get_vertex_array_stride:INTEGER is
			-- returns  one  value,  the  byte  offset
			-- between  consecutive  vertexes  in  the vertex
			-- array. The initial value is 0.  See  glVertex-
			-- Pointer.
		do
			gl_get_integerv_external(em_gl_vertex_array_stride, $result)
		end
	emgl_get_vertex_array_type:INTEGER is
			-- returns  one  value,  the data type of
			-- each coordinate in the vertex array. The  ini-
			-- tial  value is GL_FLOAT.  See glVertexPointer.
		do
			gl_get_integerv_external(em_gl_vertex_array_type, $result)
		end
	emgl_get_viewport:EM_VECTOR4I is
			-- returns four values: the  $x$  and  $y$
			-- window  coordinates  of the viewport, followed
			-- by its width and height.   Initially  the  $x$
			-- and  $y$ window coordinates are both set to 0,
			-- and the width and height are set to the  width
			-- and  height  of  the  window into which the GL
			-- will do its rendering.  See glViewport.
		do
			gl_get_integerv_external(em_gl_viewport, result)
		end
	emgl_get_zoom_x:DOUBLE is
			-- returns one value, the $x$  pixel  zoom
			-- factor.  The initial value is 1.  See glPixel-
			-- Zoom.
		do
			gl_get_doublev_external(em_gl_zoom_x, $result)
		end
	emgl_get_zoom_y:DOUBLE is
			-- returns one value, the $y$  pixel  zoom
			-- factor.  The initial value is 1.  See glPixel-
			-- Zoom.
		do
			gl_get_doublev_external(em_gl_zoom_y, $result)
		end

end
