indexing
	description: "Wrapper to all camera/view specific functions"
	date: "$Date: 2007-06-01 07:44:53 +0200 (Fri, 01 Jun 2007) $"
	revision: "$Revision: 2601 $"

class
	EMGL_VIEW

inherit
	EMGL_FUNCTIONS
		export {NONE} all end

feature --general function wrapper
	emgl_viewport ( x:INTEGER; y:INTEGER; width:INTEGER; height:INTEGER ) is
			--Wrap the OpenGL function `gl_viewport`
		do
			gl_viewport_external( x, y, width, height )
		end
	emgl_scissor ( x:INTEGER; y:INTEGER; width:INTEGER; height:INTEGER ) is
			--Wrap the OpenGL function `gl_scissor`
		do
			gl_scissor_external( x, y, width, height )
		end
	emgl_clip_plane ( plane:INTEGER; equation:POINTER ) is
			--Wrap the OpenGL function `gl_clip_plane`
		do
			gl_clip_plane_external( plane, equation )
		end
	emgl_frustum ( left:DOUBLE; right:DOUBLE; bottom:DOUBLE; top:DOUBLE; znear:DOUBLE; zfar:DOUBLE ) is
			--Wrap the OpenGL function `gl_frustum`
		do
			gl_frustum_external( left, right, bottom, top, znear, zfar )
		end
	emgl_load_identity is
			--Wrap the OpenGL function `gl_load_identity`
		do
			gl_load_identity_external
		end
	emgl_load_matrix ( m:EM_MATRIX44 ) is
			--Wrap the OpenGL function `gl_load_matrixd`
		do
			gl_load_matrixd_external( m )
		end
	emgl_load_matrixd ( m:POINTER ) is
			--Wrap the OpenGL function `gl_load_matrixd`
		do
			gl_load_matrixd_external( m )
		end
	emgl_load_matrixf ( m:POINTER ) is
			--Wrap the OpenGL function `gl_load_matrixf`
		do
			gl_load_matrixf_external( m )
		end
	emgl_matrix_mode ( mode:INTEGER ) is
			--Wrap the OpenGL function `gl_matrix_mode`
		do
			gl_matrix_mode_external( mode )
		end
	emgl_mult_matrix ( m:EM_MATRIX44 ) is
			--Wrap the OpenGL function `gl_mult_matrixd`
		do
			gl_mult_matrixd_external( m )
		end
	emgl_mult_matrixd ( m:POINTER ) is
			--Wrap the OpenGL function `gl_mult_matrixd`
		do
			gl_mult_matrixd_external( m )
		end
	emgl_mult_matrixf ( m:POINTER ) is
			--Wrap the OpenGL function `gl_mult_matrixf`
		do
			gl_mult_matrixf_external( m )
		end
	emgl_ortho ( left:DOUBLE; right:DOUBLE; bottom:DOUBLE; top:DOUBLE; znear:DOUBLE; zfar:DOUBLE ) is
			--Wrap the OpenGL function `gl_ortho`
		do
			gl_ortho_external( left, right, bottom, top, znear, zfar )
		end
	emgl_pop_matrix is
			--Wrap the OpenGL function `gl_pop_matrix`
		do
			gl_pop_matrix_external
		end
	emgl_push_matrix is
			--Wrap the OpenGL function `gl_push_matrix`
		do
			gl_push_matrix_external
		end
	emgl_rotate ( q: EM_QUATERNION ) is
			--Wrap the OpenGL function `gl_rotated`
		local
			m : EM_MATRIX44
		do
			m := q
			gl_mult_matrixd_external( m )
		end
	emgl_rotated ( angle:DOUBLE; x:DOUBLE; y:DOUBLE; z:DOUBLE ) is
			--Wrap the OpenGL function `gl_rotated`
		do
			gl_rotated_external( angle, x, y, z )
		end
	emgl_rotatef ( angle:REAL; x:REAL; y:REAL; z:REAL ) is
			--Wrap the OpenGL function `gl_rotatef`
		do
			gl_rotatef_external( angle, x, y, z )
		end
	emgl_scale ( v:EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_scaled`
		do
			gl_scaled_external( v.x, v.y, v.z )
		end
	emgl_scaled ( x:DOUBLE; y:DOUBLE; z:DOUBLE ) is
			--Wrap the OpenGL function `gl_scaled`
		do
			gl_scaled_external( x, y, z )
		end
	emgl_scalef ( x:REAL; y:REAL; z:REAL ) is
			--Wrap the OpenGL function `gl_scalef`
		do
			gl_scalef_external( x, y, z )
		end
	emgl_translate ( v: EM_VECTOR3D ) is
			--Wrap the OpenGL function `gl_translated`
		do
			gl_translated_external( v.x, v.y, v.z )
		end
	emgl_translated ( x:DOUBLE; y:DOUBLE; z:DOUBLE ) is
			--Wrap the OpenGL function `gl_translated`
		do
			gl_translated_external( x, y, z )
		end
	emgl_translatef ( x:REAL; y:REAL; z:REAL ) is
			--Wrap the OpenGL function `gl_translatef`
		do
			gl_translatef_external( x, y, z )
		end

end
