indexing
	description: "All OpenGL view specific funcitons"
	date: "$Date: 2007-07-12 10:52:05 +0200 (Thu, 12 Jul 2007) $"
	revision: "$Revision: 2611 $"

class
	EMGLU_VIEW

inherit
	EMGLU_FUNCTIONS
		export {NONE} all end

feature --general function wrapper
	emglu_look_at ( eyex:DOUBLE; eyey:DOUBLE; eyez:DOUBLE; centerx:DOUBLE; centery:DOUBLE; centerz:DOUBLE; upx:DOUBLE; upy:DOUBLE; upz:DOUBLE ) is
			--Wrap the OpenGL function `glu_look_at`
		do
			glu_look_at_external( eyex, eyey, eyez, centerx, centery, centerz, upx, upy, upz )
		end
	emglu_ortho2d ( left:DOUBLE; right:DOUBLE; bottom:DOUBLE; top:DOUBLE ) is
			--Wrap the OpenGL function `glu_ortho2d`
		do
			glu_ortho2d_external( left, right, bottom, top )
		end
	emglu_perspective ( fovy:DOUBLE; aspect:DOUBLE; znear:DOUBLE; zfar:DOUBLE ) is
			--Wrap the OpenGL function `glu_perspective`
		do
			glu_perspective_external( fovy, aspect, znear, zfar )
		end
	emglu_pick_matrix ( x:DOUBLE; y:DOUBLE; delx:DOUBLE; dely:DOUBLE; viewport:EM_VECTOR4I ) is
			--Wrap the OpenGL function `glu_pick_matrix`
		do
			glu_pick_matrix_external( x, y, delx, dely, viewport )
		end
	emglu_project ( objx:DOUBLE; objy:DOUBLE; objz:DOUBLE; model:POINTER; proj:POINTER; view:POINTER; winx:POINTER; winy:POINTER; winz:POINTER ): INTEGER is
			--Wrap the OpenGL function `glu_project`
		do
			result:=glu_project_external( objx, objy, objz, model, proj, view, winx, winy, winz )
		end
	emglu_un_project ( winx:DOUBLE; winy:DOUBLE; winz:DOUBLE; model:POINTER; proj:POINTER; view:POINTER; objx:POINTER; objy:POINTER; objz:POINTER ): INTEGER is
			--Wrap the OpenGL function `glu_un_project`
		do
			result:=glu_un_project_external( winx, winy, winz, model, proj, view, objx, objy, objz )
		end

end
