indexing
	description: "CVA's are used to fast up rendering when using interleaved array's"
	date: "$Date: Oct 15, 2006 8:03:51 AM$"
	revision: "$Revision: 1.0$"

class EMGL_COMPILED_VERTEX_ARRAYS

inherit
	GL_FUNCTIONS
		export {NONE} all end

	GLEXT_FUNCTIONS
		export {NONE} all end

	GLEW_FUNCTIONS
		export {NONE} all end

feature -- Status
	emgl_is_cva_supported: BOOLEAN is
			-- Are compiled vertex array's supported?
		do
			result := is_supported( "GL_EXT_compiled_vertex_array" )
		end

feature --Commands
	emgl_lock_arrays( first_element, count: INTEGER ) is
			-- Lock array's for fast rendering
		require
			has_cva_support: emgl_is_cva_supported
		do
			-- Should we add an exception if CVA's are not supported????
			gl_lock_arrays_ext( first_element, count )
		end

	emgl_unlock_arrays is
			-- Unlock array's for fast rendering
		require
			has_cva_support: emgl_is_cva_supported
		do
			gl_unlock_arrays_ext
		end
end -- class EMGL_COMPILED_VERTEX_ARRAYS
