indexing

	description: "[

		This class uses display lists for fast drawing of an object.

	]"
	date: "$Date: 2006-05-11 15:42:09 +0200 (Thu, 11 May 2006) $"
	revision: "$Revision: 2009 $"

class EM_3D_OBJECT_DISPLAYLIST
obsolete "use em3d instead"

inherit

	EM_3D_OBJECT

	EM_CONSTANTS
		export {NONE} all end

	GL_FUNCTIONS
		export {NONE} all end

create

	make

feature -- Initialization

	make (a_list: INTEGER; a_width: DOUBLE; a_height: DOUBLE; a_depth: DOUBLE) is
			-- Create an 3d object that draws a certain displaylist
		require
			displaylist_allocated: a_list > 0
			a_width >= 0
			a_height >= 0
			a_depth >= 0
		do
			displaylist := a_list
			width := a_width
			height := a_height
			depth := a_depth
			scale.set (1, 1, 1)
		ensure
			displaylist_set: displaylist = a_list
			width_set: width = a_width
			height_set: height = a_height
			depth_set: depth = a_depth
		end

feature {NONE} -- Implementation

	draw_object is
			-- Draws the object to the framebuffer at the current position
		do
			gl_call_list (displaylist)
		end

	displaylist: INTEGER

end