indexing

	description: "[

		Video decoder constants.

	]"
	date: "$Date: 2005-10-23 13:03:49 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1131 $"

class EM_VIDEO_DECODER_CONSTANTS

feature -- smjpeg

	Em_smjpeg_header_end: STRING is "HEND"

	Em_smjpeg_comment_header: STRING is "_TXT"

	Em_smjpeg_sound_header: STRING is "_SND"

	Em_smjpeg_video_header: STRING is "_VID"

	Em_smjpeg_file_end: STRING is "DONE"

	Em_smjpeg_sound_chunk: STRING is "sndD"

	Em_smjpeg_video_chunk: STRING is "vidD"

	Em_smjpeg_audio_header_length: INTEGER is 8

	Em_smjpeg_video_header_length: INTEGER is 12

	Em_smjpeg_ending: STRING is "mjpg"

	Em_smjpeg_magic: STRING is "%U%NSMJPEG"

feature -- smjpeg audio

	Em_smjpeg_audio_none: INTEGER is 1313820229

	Em_smjpeg_audio_adpcm: INTEGER is 1095779149

feature -- smjpeg video

	Em_smjpeg_video_jpeg: INTEGER is 1246120262

feature -- adpcm

	Em_adpcm_index_table: ARRAY[INTEGER] is
			-- adpcm index table
		indexing
			once_status: global
		once
			Result := integer_tuple_to_array([-1, -1, -1, -1, 2, 4, 6, 8,-1, -1, -1, -1, 2, 4, 6, 8])
		end

	Em_adpcm_stepsize_table: ARRAY[INTEGER] is
			-- adpcm stpesize table
		indexing
			once_status: global
		once
			Result := integer_tuple_to_array ([7, 8, 9, 10, 11, 12, 13, 14, 16, 17,
					19, 21, 23, 25, 28, 31, 34, 37, 41, 45,
					50, 55, 60, 66, 73, 80, 88, 97, 107, 118,
					130, 143, 157, 173, 190, 209, 230, 253, 279, 307,
					337, 371, 408, 449, 494, 544, 598, 658, 724, 796,
					876, 963, 1060, 1166, 1282, 1411, 1552, 1707, 1878, 2066,
					2272, 2499, 2749, 3024, 3327, 3660, 4026, 4428, 4871, 5358,
					5894, 6484, 7132, 7845, 8630, 9493, 10442, 11487, 12635, 13899,
					15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794, 32767])
		end

feature {NONE} -- Implementation

	integer_tuple_to_array (tuple: TUPLE): ARRAY[INTEGER] is
			-- converts tupple to array
		require
			uniform: tuple.is_uniform_integer
		local
			i: INTEGER
		do
			create Result.make (0, tuple.count - 1)
			from
				i := 0
			until
				i >= tuple.count
			loop
				Result.force (tuple.integer_item (i+1), i)
				i := i + 1
			end
		end

end