indexing
	description: "[
	
		Objects that can be resized in all three dimensions
		It's important to note that there's no guarantee that the object
		indeed has the desired size after resizing it.
		
	]"
	author: ""
	date: "$Date: 2007-02-01 19:08:56 +0100 (Thu, 01 Feb 2007) $"
	revision: "$Revision: 2471 $"

deferred class
	EM_VIZ_RESIZEABLE

inherit
	EM_VIZ_SIZED

	EM_VIZ_UPDATEABLE

feature -- Initialization

	make_resizeable (a_size: like size) is
			-- Initialize with `a_size'
		do
			set_size (a_size)
		end

feature -- Resizing

	set_width (a_width: like width) is
			-- Set width
		do
			set_width_internal (a_width)
			expire
		ensure
			expired: needs_update
		end

	set_height (a_height: like height) is
			-- Set height
		do
			set_height_internal (a_height)
			expire
		ensure
			expired: needs_update
		end

	set_depth (a_depth: like depth) is
			-- Set depth
		do
			set_depth_internal (a_depth)
			expire
		ensure
			expired: needs_update
		end

	set_size (a_size: like size) is
			-- Set size
		do
			set_size_internal (a_size)
			expire
		ensure
			expired: needs_update
		end

feature {NONE} -- Implementation

	set_width_internal (a_width: like width) is
			-- Width resize handler
		deferred
		ensure
			set: width = a_width
		end

	set_height_internal (a_height: like height) is
			-- Height resize handler
		deferred
		ensure
			set: height = a_height
		end

	set_depth_internal (a_depth: like depth) is
			-- Depth resize handler
		deferred
		ensure
			set: depth = a_depth
		end

	set_size_internal (a_size: like size) is
			-- Resize handler
		deferred
		ensure
			set: size = a_size
		end

end
