indexing
	description: "[
	
		Objects which have some internal state that needs to be kept up-to-date.
		The state can be expired with expire and (lazily) updated with
		conditional_update.

	]"
	author: ""
	date: "$Date: 2007-02-12 01:01:02 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2501 $"

deferred class
	EM_VIZ_UPDATEABLE

feature -- Status report

	needs_update: BOOLEAN is
			-- Internal state expired?
		deferred
		end

feature -- Basic operations

	expire is
			-- Expire object
		deferred
		ensure
			expired: needs_update
		end

	deep_expire is
			-- Expire object and propagate to children
		deferred
		end

	update is
			-- Force update
		deferred
		ensure
			updated: not needs_update
		end

	conditional_update is
			-- Lazy update
		do
			if needs_update then
				update
			end
		ensure
			up_to_date: not needs_update
		end

end
