indexing
	description: "[

		A colored, resizeable box that will be rendered as a colored cube.

	]"
	author: ""
	date: "$Date: 2007-02-12 01:01:02 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2501 $"

class
	EM_VIZ_COLOR_BOX

inherit

	EM_VIZ_BOX

	EM_VIZ_RESIZEABLE

	EM_VIZ_COLORED

create

	make

feature -- Initialization

	make (a_size: like size; a_color: like color) is
			-- Initialize with `a_size' and `a_color'
		require
			color_exists: a_color /= Void
		do
			make_box
			make_resizeable (a_size)
			make_colored (a_color)
		end

feature {NONE} -- Implementation

	vz_render (viewing_direction: EM_VECTOR3D) is
			-- Render colored cube (with backface culling)
		do
			vz_push_attributes (Vz_polygon_bit)
			vz_set_culling (True, Vz_back)
			render_colored_cube (bounds.min, bounds.max, color)
			vz_pop_attributes
		end

end
