indexing
	description: "[

		A list box that contains other boxes from top to bottom.
		The size of the box is such that it tightly encloses all its children.
		Chlild boxes can be aligned in horizontal and depth direction.
		Do not use Align_user_specified as it might give unexpected results.
		Children are rendered back-to-front.

	]"

	author: ""
	date: "$Date: 2007-02-12 05:27:06 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2503 $"

class
	EM_VIZ_VERTICAL_BOX [B -> EM_VIZ_BOX]

inherit
	EM_VIZ_LIST_BOX [B]

	EM_VIZ_ALIGNABLE
		export
			{NONE} vertical_alignment, set_vertical_alignment
		end

create

	make

feature -- Initialization

	make is
			--
		do
			make_list
			make_alignable
		end

feature {NONE} -- Implementation

	vz_render (viewing_direction: EM_VECTOR3D) is
			-- Render back-to-front
		do
			setup_local_coordinate_frame
			render_contents (viewing_direction, viewing_direction.y > 0.0)
			revert_local_coordinate_frame
		end

	resize_container is
			-- Resize container to fit contents
		local
			l: DS_LINEAR [B]
			b: B
			w, h, d: DOUBLE
		do
			from
				w := 0.0
				h := 0.0
				d := 0.0
				l := as_linear
				l.start
			until
				l.off
			loop
				b := l.item_for_iteration
				if b /= Void then
					w := b.width.max (w)
					h := h + b.height
					d := b.depth.max (d)
				end
				l.forth
			end
			set_size_internal ([w, h, d])
		end

	realign_contents is
			-- Realign contents after resize
		local
			l: DS_LINEAR [B]
			b: B
			bwin: like bounds
			ymin, ymax: DOUBLE
		do
			from
				l := as_linear
				l.start
				ymin := 0.0
			until
				l.off
			loop
				b := l.item_for_iteration
				if b /= Void then
					ymax := ymin + b.height
					bwin.set ([0.0, ymin, 0.0], [width, ymax, depth])
					b.realign (bwin, alignment)
					ymin := ymax
				end
				l.forth
			end
		end

end
