indexing
	description: "[

		A plotter that plots a flat, colored bar for each 2d-point in a sequence.

	]"
	author: ""
	date: "$Date: 2007-02-12 08:14:24 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2505 $"

class
	EM_VIZ_BAR_PLOTTER

inherit
	EM_VIZ_PLOTTER [EM_VECTOR2D]

create

	make

feature -- Initialization

	make (a_width: like bar_width; a_color: like bar_color) is
			-- Make plotter that plots bars with `a_width' and `a_color'
		require
			color_exists: a_color /= Void
		do
			set_bar_width (a_width)
			set_bar_color (a_color)
		end

feature -- Access

	bar_width: DOUBLE
			-- Width of each bar

	bar_color: EM_COLOR
			-- Color of bars

feature -- Element change

	set_bar_width (a_width: like bar_width) is
			-- Set width
		do
			bar_width := a_width
		ensure
			set: bar_width = a_width
		end

	set_bar_color (a_color: like bar_color) is
			-- Set color
		require
			color_exists: a_color /= Void
		do
			bar_color := a_color
		ensure
			set: bar_color = a_color
		end

feature -- Rendering

	plot (values: DS_LINEAR [EM_VECTOR2D]) is
			-- Render each bar as a quad
		do
			vz_color (bar_color)
			vz_normal3d (0, 0, 1)

			vz_begin_quads
			from
				values.start
			until
				values.off
			loop
				plot_value (values.item_for_iteration)
				values.forth
			end
			vz_end
		end

feature {NONE} -- Rendering (Implementation)

	plot_value (v: EM_VECTOR2D) is
			-- Plot a single bar
		local
			x1, x2, y1, y2: DOUBLE
		do
			x1 := v.x - 0.5 * bar_width
			x2 := x1 + bar_width
			y1 := 0.0
			y2 := v.y

			vz_vertex2d (x1, 0.0)
			vz_vertex2d (x2, 0.0)
			vz_vertex2d (x2, y2)
			vz_vertex2d (x1, y2)
		end

end
