indexing
	description: "[

		A 2D-plot box that plots user-specified 2D-values using a user-specified plotter.
		Values are copied from data_source as neccessary. Values will be plotted inside
		the box iff they are coincident with the specified intervals.

	]"
	author: ""
	date: "$Date: 2007-02-12 08:14:24 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2505 $"

class
	EM_VIZ_DATA_PLOT_2D

inherit
	EM_VIZ_PLOT_2D
		redefine
			data
		end

create

	make

feature

	make (a_size: like size; a_x_interval, a_y_interval: EM_INTERVAL) is
			-- Make new plot-box of `a_size', with domain `a_x_interval' and
			-- range `a_y_interval'.
		do
			make_plot_2d (a_size, a_x_interval, a_y_interval)
			set_data_source (Void)
		end

feature -- Access

	data_source: DS_LINEAR [EM_VECTOR2D]
			-- Linear representation of user-specified data that should be plotted

feature -- Element change

	set_data_source (a_source: like data_source) is
			-- Set data source to be copied from
		do
			data_source := a_source
			expire
		ensure
			set: data_source = a_source
			expired: needs_update
		end

feature {NONE} -- Implementation

	data: DS_ARRAYED_LIST [EM_VECTOR2D]
			-- The actual data

	create_data is
			-- Create storage for data
		do
			create data.make (1)
		end

	update_data is
			-- Copy values from data_source
		do
			data.wipe_out

			if data_source /= Void then
				data.resize (data_source.count)

				from
					data_source.start
				until
					data_source.off
				loop
					data.force_last (data_source.item_for_iteration)
					data_source.forth
				end
			end
		end

end
