indexing
	description: "[

		A plotter that renders a sequence of 2d-values as colored points.

	]"
	author: ""
	date: "$Date: 2007-02-12 08:14:24 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2505 $"

class
	EM_VIZ_POINT_PLOTTER

inherit
	EM_VIZ_PLOTTER [EM_VECTOR2D]

create

	make

feature -- Initialization

	make (a_size: like point_size; a_color: like point_color) is
			-- Make new plotter for points of `a_size' and `a_color'
		require
			color_exists: a_color /= Void
		do
			set_point_size (a_size)
			set_point_color (a_color)
		end

feature -- Access

	point_size: DOUBLE
			-- Point size

	point_color: EM_COLOR
			-- Point color

feature -- Element change

	set_point_size (a_size: like point_size) is
			-- Set point size
		do
			point_size := a_size
		ensure
			set: point_size = a_size
		end

	set_point_color (a_color: like point_color) is
			-- Set point color
		require
			color_exists: a_color /= Void
		do
			point_color := a_color
		ensure
			set: point_color = a_color
		end

feature -- Rendering

	plot (values: DS_LINEAR [EM_VECTOR2D]) is
			-- Plot values
		do
			vz_push_attributes (Vz_point_bit)
			vz_set_point_size (point_size)
			vz_color (point_color)
			vz_normal3d (0, 0, 1)

			vz_begin_points
			from
				values.start
			until
				values.off
			loop
				vz_vertex (values.item_for_iteration)
				values.forth
			end
			vz_end

			vz_pop_attributes
		end

end
