indexing
	description: "[

		A simple labeler that labels values by pre- and appending a prefix- and postfix-string
		to a string representation of the value. Used by {EM_VIZ_LINEAR_AXIS_BOX}

	]"
	author: ""
	date: "$Date: 2007-02-18 01:09:05 +0100 (Sun, 18 Feb 2007) $"
	revision: "$Revision: 2532 $"

class
	EM_VIZ_SIMPLE_LABELER

inherit

	EM_VIZ_LABELER

create

	make

feature -- Initialization

	make (a_prefix: like label_prefix; a_postfix: like label_postfix) is
			-- Initialization
		require
			prefix_exists: a_prefix /= Void
			postfix_exists: a_postfix /= Void
		do
			set_label_prefix (a_prefix)
			set_label_postfix (a_postfix)
		end

feature -- Access

	label_prefix: STRING
			-- Prefix string

	label_postfix: STRING
			-- Postfix string

feature -- Element change

	set_label_prefix (a_prefix: STRING) is
			-- Set prefix string
		require
			prefix_exists: a_prefix /= Void
		do
			label_prefix := a_prefix
		ensure
			set: label_prefix = a_prefix
		end

	set_label_postfix (a_postfix: STRING) is
			-- Set postfix string
		require
			postfix_exists: a_postfix /= Void
		do
			label_postfix := a_postfix
		ensure
			set: label_postfix = a_postfix
		end

feature -- Basic operations

	label (an_index: INTEGER; a_value: DOUBLE): STRING is
			-- Label `a_value' at `an_index' in a sequence of values
		do
			Result := label_prefix + a_value.out + label_postfix
		end

end
