indexing

	description: "[

		A transparent background.
		When OpenGL is enabled the transparency will not work on widgets
		which are placed directly on an EM_COMPONENT_SCENE.

	]"
	date: "$Date: 2005-10-23 13:21:01 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1136 $"

class EM_TRANSPARENT_BACKGROUND

inherit

	EM_BACKGROUND

	EM_SHARED_WIDGET_OPTIONS
		export {NONE} all end

	EM_SHARED_SUBSYSTEMS
		export {NONE} all end

create

	make

feature {NONE} -- Initialisation

	make is
			-- Initialise default values.
		do
		end

feature -- Drawing

	draw_on (a_widget: EM_WIDGET) is
			-- Draw background on `a_widget'.
		do
			if a_widget.parent_widget /= Void then
				a_widget.surface.blit_surface_part (a_widget.parent_widget.surface, a_widget.x, a_widget.y, a_widget.width, a_widget.height, 0, 0)
				if widget_options.is_transparency_refresh_enabled then
					a_widget.set_changed
				end
			elseif not Video_subsystem.opengl_enabled then
				a_widget.surface.blit_surface_part (Video_subsystem.video_surface, a_widget.x, a_widget.y, a_widget.width, a_widget.height, 0, 0)
				if widget_options.is_transparency_refresh_enabled then
					a_widget.set_changed
				end
			end
		end

end