indexing

	description: "[

		Basic delegate of an EM_DRAWABLE_PANEL.

	]"
	date: "$Date$"
	revision: "$Revision$"

class EM_BASIC_DRAWABLE_PANEL_DELEGATE

inherit

	EM_WIDGET_DELEGATE
		redefine
			install,
			optimal_width,
			optimal_height,
			draw_body
		end

feature -- Initialisation

	install (panel: EM_DRAWABLE_PANEL) is
			-- Install style on `panel'.
			-- Set up all default values for background, border, font and colors.
		do
			Precursor {EM_WIDGET_DELEGATE} (panel)
			panel.set_border (Void)
		end

feature -- Measurement

	optimal_width (panel: EM_DRAWABLE_PANEL): INTEGER is
			-- Optimal width of `panel'
		do
			Result := panel.container.width
		end

	optimal_height (panel: EM_DRAWABLE_PANEL): INTEGER is
			-- Optimal height of `panel'
		do
			Result := panel.container.height
		end

feature -- Drawing

	draw_body (panel: EM_DRAWABLE_PANEL) is
			-- Draw body of `panel'.
		do
			panel.container.draw (panel.surface)
		end

end