indexing

	description: "[

		Delegate of an EM_PROGRESS_BAR.

	]"
	date: "$Date: 2005-10-23 13:24:49 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1138 $"

class EM_ECLIPSE_PROGRESS_BAR_DELEGATE

inherit

	EM_WIDGET_DELEGATE
		redefine
			install,
			optimal_width,
			optimal_height,
			draw_body
		end

	EM_WIDGET_DRAWING
		export {NONE} all end

feature -- Initialisation

	install (progress_bar: EM_PROGRESS_BAR) is
			-- Install style on `progress_bar'.
			-- Set up all default values for background, border, font and colors.
		do
			Precursor {EM_WIDGET_DELEGATE} (progress_bar)
			progress_bar.set_border (create {EM_BEVEL_BORDER}.make_down)
			progress_bar.set_foreground_color (theme_colors.progress_bar_color)
		end

feature -- Layout

	optimal_width (progress_bar: EM_PROGRESS_BAR): INTEGER is
			-- Optimal width of `progress_bar'
		do
			Result := progress_bar.steps * 10 + progress_bar.border.left + progress_bar.border.right
		end

	optimal_height (progressbar: EM_PROGRESS_BAR): INTEGER is
			-- Optimal height of `progress_bar'
		do
			Result := 14
		end

feature -- Drawing

	draw_body (progress_bar: EM_PROGRESS_BAR) is
			-- Draw body of `progress_bar'.
		local
			x: INTEGER
		do
			if progress_bar.current_step > 0 then
				x := progress_bar.border.left + (progress_bar.current_step / progress_bar.steps * (progress_bar.width-progress_bar.border.left-progress_bar.border.right)).floor
				progress_bar.surface.put_rectangle_filled (progress_bar.border.left, progress_bar.border.top, x, progress_bar.height-progress_bar.border.bottom, progress_bar.foreground_color)
			end
		end

end