indexing

	description: "[

		Fonts of a theme.
		All default delegates rely solely on these fonts.
		
		Use EM_SHARED_THEME to access the instance used by default delegates.

	]"
	date: "$Date: 2005-10-23 13:21:01 +0200 (Sun, 23 Oct 2005) $"
	revision: "$Revision: 1136 $"

class EM_THEME_FONTS

inherit

	EM_SHARED_STANDARD_FONTS
		export {NONE} all end

create

	make

feature {NONE} -- Initialisation

	make is
			-- Initialise default values.
		do
			load_default_fonts
		end

feature -- Access

	default_text_font: EM_FONT
			-- Default text font

	button_text_font: EM_FONT
			-- Button text font

	window_title_font: EM_FONT
			-- Window title font

feature -- Element change

	set_default_text_font (font: like default_text_font) is
			-- Set default text font.
		require
			font_not_void: font /= Void
		do
			default_text_font := font
		ensure
			default_text_font_set: default_text_font = font
		end

	set_button_text_font (font: like button_text_font) is
			-- Set button text font.
		require
			font_not_void: font /= Void
		do
			button_text_font := font
		ensure
			button_text_font_set: button_text_font = font
		end

	set_window_title_font (font: like window_title_font) is
			-- Set window title font.
		require
			font_not_void: font /= Void
		do
			window_title_font := font
		ensure
			window_title_font_set: window_title_font = font
		end

feature -- Themes

	load_default_fonts is
			-- Load default fonts.
		do
			default_text_font := Standard_ttf_fonts.bitstream_vera_sans (12)
			button_text_font := Standard_ttf_fonts.bitstream_vera_sans (12)
			window_title_font := Standard_ttf_fonts.bitstream_vera_sans_bold (12)
		end

invariant

	default_text_font_not_void: default_text_font /= Void
	button_text_font_not_void: button_text_font /= Void
	window_title_font_not_void: window_title_font /= Void

end