indexing

	description: "[

		Joystick sensitive objects which dispatches joystick events.
		
		Subscribe on an event-type you want to be notified.

	]"
	date: "$Date: 2006-02-09 10:33:59 +0100 (Thu, 09 Feb 2006) $"
	revision: "$Revision: 1706 $"

deferred class EM_JOYSTICK_SENSITIVE

feature {NONE} -- Initialisation

	make_joystick_sensitive is
			-- Initialise default values.
		do
			create joystick_axis_event
			create joystick_ball_event
			create joystick_button_down_event
			create joystick_button_up_event
			create joystick_hat_event
		end

feature -- Events

	joystick_axis_event: EM_EVENT_CHANNEL [TUPLE [EM_JOYSTICK_AXIS_EVENT]]
			-- Joystick axis event

	joystick_ball_event: EM_EVENT_CHANNEL [TUPLE [EM_JOYSTICK_BALL_EVENT]]
			-- Joystick ball event

	joystick_button_down_event: EM_EVENT_CHANNEL [TUPLE [EM_JOYSTICK_BUTTON_EVENT]]
			-- Joystick button down event

	joystick_button_up_event: EM_EVENT_CHANNEL [TUPLE [EM_JOYSTICK_BUTTON_EVENT]]
			-- Joystick button up event

	joystick_hat_event: EM_EVENT_CHANNEL [TUPLE [EM_JOYSTICK_HAT_EVENT]]
			-- Joystick hat event

invariant

	joystick_axis_event_not_void: joystick_axis_event /= Void
	joystick_ball_event_not_void: joystick_ball_event /= Void
	joystick_button_down_event_not_void: joystick_button_down_event /= Void
	joystick_button_up_event_not_void: joystick_button_up_event /= Void
	joystick_hat_event_not_void: joystick_hat_event /= Void

end