[Code]
var
  Exists_in_machine: Boolean;
  Temp_String: String;
  ResultCode: Integer;

function GetIseEiffelPath(): String;
var
  Subkeys: TArrayOfString;
  P: String;
  S: String;
  I: Integer;
begin
  P := 'SOFTWARE\ISE';

  if (RegGetSubkeyNames (HKLM, P, Subkeys)) then
    begin
      //use latest EiffelStudioVersion if more Versions Installed
      I := GetArrayLength(Subkeys)-1;
      S := Subkeys[I];
      P := P + '\' + S + '\build';

      RegQueryStringValue (HKLM, P, 'ISE_EIFFEL', Result);
  end else
    begin
      Result := '';
    end;
end;

function SetGOBOVar(): String;
var
  IseEiffel: String;
  EiffelSpecDir: String;
begin
  Exists_in_machine := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO', Result);

  if (Exists_in_machine = False) then
    begin
      Temp_String := ExpandConstant('{app}\dependency\gobo')
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO', Temp_String);
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_C_COMPILER', 'msc');
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_CC', 'msc');
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_EIFFEL', 'ise');
      Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-a:"{app}\dependency\gobo\bin" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);

      IseEiffel := GetIseEiffelPath();
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_EIFFEL', IseEiffel);
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_LIBRARY', IseEiffel);
      EiffelSpecDir := '-a:"' + IseEiffel + '\studio\spec\windows\bin" -silent';
      Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), EiffelSpecDir, '', SW_SHOW, ewWaitUntilTerminated, ResultCode);

      RegWriteStringValue (HKLM, 'SOFTWARE', 'eiffelmedia', 'gobo_env_var_added');
    end
  if Exists_in_machine then
    begin
      Result := '';
      MsgBox('The environment variable GOBO is defined for this system and this installation will not overwrite its value. This might affect the functioning of the installation! Please see "developer.txt" to find out how to set this environment variable manually.', mbError, MB_OK);
    end
end;

function SetEWGVar(): String;
begin
  Exists_in_machine := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'EWG', Result);

  if (Exists_in_machine = False) then
    begin
      Temp_String := ExpandConstant('{app}\dependency\ewg')
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'EWG', Temp_String);
      Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-a:"{app}\dependency\ewg\bin" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
      RegWriteStringValue (HKLM, 'SOFTWARE', 'eiffelmedia', 'ewg_env_var_added');
    end
  if Exists_in_machine then
    begin
      Result := '';
      MsgBox('The environment variable EWG is defined for this system and this installation will not overwrite its value. This might affect the functioning of the installation! Please see "developer.txt" to find out how to set this environment variable manually.', mbError, MB_OK);
    end
end;

function SetSDLVar(): String;
begin
  Exists_in_machine := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL', Result);

  if (Exists_in_machine = False) then
    begin
      Temp_String := ExpandConstant('{app}\dependency\sdl')
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL', Temp_String);
      RegWriteStringValue (HKLM, 'SOFTWARE', 'eiffelmedia', 'sdl_env_var_added');
    end
  if Exists_in_machine then
    begin
      Result := '';
      MsgBox('The environment variable SDL is defined for this system and this installation will not overwrite its value. This might affect the functioning of the installation! Please see "developer.txt" to find out how to set this environment variable manually.', mbError, MB_OK);
    end
end;

function SetSDL_HEADERVar(): String;
begin
  Exists_in_machine := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL_HEADER', Result);

  if (Exists_in_machine = False) then
    begin
      Temp_String := ExpandConstant('{app}\dependency\sdl\include')
      RegWriteStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL_HEADER', Temp_String);
      RegWriteStringValue (HKLM, 'SOFTWARE', 'eiffelmedia', 'sdl_header_env_var_added');
      Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-a:"{app}\dependency\sdl\lib" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
    end
  if Exists_in_machine then
    begin
      Result := '';
      MsgBox('The environment variable SDL_HEADER is defined for this system and this installation will not overwrite its value. This might affect the functioning of the installation! Please see "developer.txt" to find out how to set this environment variable manually.', mbError, MB_OK);
    end
end;

function RemoveGOBOVar(): String;
var
  Has_GOBO_Entry: Boolean;
  Has_ISE_C_COMPILER_Entry: Boolean;
  Has_GOBO_CC_Entry: Boolean;
  Has_GOBO_EIFFEL_Entry: Boolean;
  Has_ISE_EIFFEL_Entry: Boolean;
  Deleted_GOBO_Entry: Boolean;
  Deleted_ISE_C_COMPILER_Entry: Boolean;
  Deleted_GOBO_CC_Entry: Boolean;
  Deleted_GOBO_EIFFEL_Entry: Boolean;
  Deleted_ISE_EIFFEL_Entry: Boolean;
begin
  Has_GOBO_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO', Result);
  Has_ISE_C_COMPILER_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_C_COMPILER', Result);
  Has_GOBO_CC_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_CC', Result);
  Has_GOBO_EIFFEL_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_EIFFEL', Result);
  Has_ISE_EIFFEL_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_EIFFEL', Result);

  if (Has_GOBO_Entry = True) then
    begin
      Deleted_GOBO_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO');
    end;

  if (Has_ISE_C_COMPILER_Entry = True) then
    begin
      Deleted_ISE_C_COMPILER_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_C_COMPILER');
    end;

  if (Has_GOBO_CC_Entry = True) then
    begin
      Deleted_GOBO_CC_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_CC');
    end;

  if (Has_GOBO_EIFFEL_Entry = True) then
    begin
      Deleted_GOBO_EIFFEL_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GOBO_EIFFEL');
    end;

  if (Has_ISE_EIFFEL_Entry = True) then
    begin
      Deleted_ISE_EIFFEL_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'ISE_EIFFEL');
    end;


  if (Deleted_GOBO_Entry = False) or (Deleted_ISE_C_COMPILER_Entry = False) or (Deleted_GOBO_CC_Entry = False) or
     (Deleted_GOBO_EIFFEL_Entry = False) or (Deleted_ISE_EIFFEL_Entry = False) then
    begin
      MsgBox('Unable to remove GOBO Environment Variables', mbError, MB_OK);
    end;
end;

function RemoveEWGVar(): String;
var
  Has_EWG_Entry: Boolean;
  Deleted_EWG_Entry: Boolean;
begin
  Has_EWG_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'EWG', Result);

  if (Has_EWG_Entry = True) then
    begin
      Deleted_EWG_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'EWG');
    end;

  if (Deleted_EWG_Entry = False) then
    begin
      MsgBox('Unable to remove EWG Environment Variables', mbError, MB_OK);
    end;
end;

function RemoveSDLVar(): String;
var
  Has_SDL_Entry: Boolean;
  Deleted_SDL_Entry: Boolean;
begin
  Has_SDL_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL', Result);

  if (Has_SDL_Entry = True) then
    begin
      Deleted_SDL_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL');
    end;

  if (Deleted_SDL_Entry = False) then
    begin
      MsgBox('Unable to remove SDL Environment Variables', mbError, MB_OK);
    end;
end;

function RemoveSDL_HEADERVar(): String;
var
  Has_SDL_HEADER_Entry: Boolean;
  Has_eiffelmedia_Entry: Boolean;
  Deleted_SDL_HEADER_Entry: Boolean;
  Deleted_eiffelmedia_Entry: Boolean;
begin
  Has_SDL_HEADER_Entry := RegQueryStringValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL_HEADER', Result);
  Has_eiffelmedia_Entry := RegQueryStringValue (HKLM, 'SOFTWARE', 'eiffelmedia', Result);

  if (Has_SDL_HEADER_Entry = True) then
    begin
      Deleted_SDL_HEADER_Entry := RegDeleteValue (HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'SDL_HEADER');
    end;
  if (Has_eiffelmedia_Entry = True) then
    begin
      Deleted_eiffelmedia_Entry := RegDeleteValue (HKLM, 'SOFTWARE', 'eiffelmedia');
    end;

  if (Deleted_SDL_HEADER_Entry = False) or (Deleted_eiffelmedia_Entry = False) then
    begin
      MsgBox('Unable to remove SDL_HEADER Environment Variables', mbError, MB_OK);
    end;
end;

procedure RemoveEnvironmentVariables();
begin
  RemoveGOBOVar;
  RemoveEWGVar;
  RemoveSDLVar;
  RemoveSDL_HEADERVar;
end;

function RemovePathSettings(): String;
var
  EiffelSpecDir: String;
  IseEiffelPath: String;
begin
  IseEiffelPath := GetIseEiffelPath();
  EiffelSpecDir := '-r:"' + IseEiffelPath + '\studio\spec\windows\bin" -silent';
  Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), EiffelSpecDir, '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
  Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-r:"{app}\dependency\gobo\bin" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
  Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-r:"{app}\dependency\ewg\bin" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
  Exec(ExpandConstant('{app}\uninst_lib\PathTool.exe'), ExpandConstant('-r:"{app}\dependency\sdl\lib" -silent'), '', SW_SHOW, ewWaitUntilTerminated, ResultCode);
end;

procedure AfterMyProgInstall;
begin
  SetGOBOVar;
  SetEWGVar;
  SetSDLVar;
  SetSDL_HEADERVar;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
var
  UserRemoveEnvironmentVariables: Boolean;
  UserRemovePathVariables: Boolean;
begin
  if (CurUninstallStep = usUninstall) then //usPostUninstall
    begin
      RemovePathSettings();
      RemoveEnvironmentVariables();
    end;
end;
