[Setup]

; APP INFORMATION:
;-------- ADAPTATION --------
MOD: app_name_stud
MOD: app_ver_name_stud
MOD: app_ver
;----------------------------
AppPublisher=Chair of Software Engineering ETH Zurich
AppPublisherURL=http://se.inf.ethz.ch/people/bay
AppCopyright=Copyright (c) 2003-2006 ETH Zurich, Till G. Bay
AppSupportURL=http://eiffelmedia.origo.ethz.ch
AppUpdatesURL=http://eiffelmedia.origo.ethz.ch
LicenseFile=forum.txt

; DEFAULT PATH SETTINGS:
DefaultDirName={pf}\eiffelmedia
DefaultGroupName=EiffelMedia
;-------- ADAPTATION --------
MOD: src_dir
MOD: out_dir
MOD: out_name_stud
;----------------------------

; INSTALLER SETTINGS
Compression=bzip/9
PrivilegesRequired=poweruser
AlwaysRestart=yes

; SETTINGS FOR UNINSTALLER
;UninstallDisplayIcon={app}\MyProg.exe <-- specific icon file to use
;UninstallDisplayName=My Program <-- name showed in add/remove software
;UninstallFilesDir={app}\uninst <-- specifiy path of the uninst.* - files
UninstallFilesDir={app}\uninst
UninstallRestartComputer=yes

; INSTALLER COSMETIC SETTINGS
BackColor=clBlue
BackColor2=clBlack
;SetupIconFile=
;WizardImageFile=D:\workspace\em\release\tools\em_logo.bmp
;WizardSmallImageFile=mysmallimage.bmp
WizardImageStretch=no
WizardImageBackColor=clWhite



[Registry]
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"; ValueType: string; ValueName: "EM"; ValueData: "{app}"; Flags: uninsdeletevalue



[Types]
Name: "full"; Description: "Full installation"
Name: "compact"; Description: "Compact installation (no examples)"



[Components]
Name: "libraries"; Description: "Libraries"; Types: full compact; Flags: fixed
Name: "program"; Description: "Program Files"; Types: full compact
Name: "examples"; Description: "Code Examples"; Types: full
Name: "documentation"; Description: "Documentation"; Types: full


[Files]

; LIBRARIES
Components: libraries; Source: "glew32.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "glut32.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "glu32.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "glu32.dll"; DestDir: "{app}\resource"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "jpeg.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "libpng13.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "libpng12.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "ogg.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "SDL.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "SDL_image.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "SDL_mixer.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "SDL_net.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "SDL_ttf.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "sdlgfx.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "smpeg.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "vorbis.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "vorbisfile.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite
Components: libraries; Source: "zlib1.dll"; DestDir: "{sys}"; Flags: uninsrestartdelete confirmoverwrite

; EXAMPLES
Components: examples; Source: "example\*"; DestDir: "{app}\example"; CopyMode: normal; Flags: recursesubdirs

; DOC
Components: documentation; Source: "doc\*"; DestDir: "{app}\doc"; CopyMode: normal; Flags: recursesubdirs

; APPLICATION
Components: program; Source: "PathTool.exe"; DestDir: "{app}"; Flags: uninsrestartdelete
Components: program; Source: "*"; Excludes: "*.dll, example\*, doc\*"; DestDir: "{app}"; CopyMode: normal; Flags: recursesubdirs
Components: program; Source: "website.url"; DestDir: "{app}"; AfterInstall: AfterMyProgInstall



[Icons]
; NET EXAMPLES
Components: examples; Name: "{group}\example\net\echo server"; Filename: "{app}\example\net\echo_server\echo_server.exe"; IconFilename: "{app}\example\net\echo_server\icon.ico"; WorkingDir: "{app}\example\net\echo_server\"
Components: examples; Name: "{group}\example\net\message client"; Filename: "{app}\example\net\message_client\message_client.exe"; IconFilename: "{app}\example\net\message_client\icon.ico"; WorkingDir: "{app}\example\net\message_client\"
Components: examples; Name: "{group}\example\net\multiplayer client"; Filename: "{app}\example\net\multiplayer\client\em_mp_client.exe"; IconFilename: "{app}\example\net\multiplayer\client\icon.ico"; WorkingDir: "{app}\example\net\multiplayer\client\"
Components: examples; Name: "{group}\example\net\multiplayer server"; Filename: "{app}\example\net\multiplayer\server\em_mp_server.exe"; IconFilename: "{app}\example\net\multiplayer\server\icon.ico"; WorkingDir: "{app}\example\net\multiplayer\server\"
Components: examples; Name: "{group}\example\net\udp classic"; Filename: "{app}\example\net\udp_classic\udp_classic.exe"; IconFilename: "{app}\example\net\udp_classic\icon.ico"; WorkingDir: "{app}\example\net\udp_classic\"

; AUDIO EXAMPLES
Components: examples; Name: "{group}\example\audio\audio mixer"; Filename: "{app}\example\audio_mixer\audio_mixer.exe"; IconFilename: "{app}\example\audio_mixer\icon.ico"; WorkingDir: "{app}\example\audio_mixer\"
Components: examples; Name: "{group}\example\audio\sound"; Filename: "{app}\example\sound\sound.exe"; IconFilename: "{app}\example\sound\icon.ico"; WorkingDir: "{app}\example\sound\"
Components: examples; Name: "{group}\example\audio\effects"; Filename: "{app}\example\effects\effects.exe"; IconFilename: "{app}\example\effects\icon.ico"; WorkingDir: "{app}\example\effects\"

; INPUT DEVICES EXAMPLES
Components: examples; Name: "{group}\example\input device\joystick"; Filename: "{app}\example\joystick\joystick.exe"; IconFilename: "{app}\example\joystick\icon.ico"; WorkingDir: "{app}\example\joystick\"
Components: examples; Name: "{group}\example\input device\cdplayer"; Filename: "{app}\example\cdplayer\cdplayer.exe"; IconFilename: "{app}\example\cdplayer\icon.ico"; WorkingDir: "{app}\example\cdplayer\"

; COLLISION EXAMPLES
Components: examples; Name: "{group}\example\collision\collision"; Filename: "{app}\example\collision\collision.exe"; IconFilename: "{app}\example\collision\icon.ico"; WorkingDir: "{app}\example\collision\"
Components: examples; Name: "{group}\example\collision\collision testsuite"; Filename: "{app}\example\collision_testsuite\collision_testsuite.exe"; IconFilename: "{app}\example\collision_testsuite\icon.ico"; WorkingDir: "{app}\example\collision_testsuite\"
Components: examples; Name: "{group}\example\collision\simple goof"; Filename: "{app}\example\goof\simple_goof\simple_goof.exe"; IconFilename: "{app}\example\goof\simple_goof\icon.ico"; WorkingDir: "{app}\example\goof\simple_goof\"
Components: examples; Name: "{group}\example\collision\number hunt"; Filename: "{app}\example\goof\number_hunt\number_hunt.exe"; IconFilename: "{app}\example\goof\number_hunt\icon.ico"; WorkingDir: "{app}\example\goof\number_hunt\"

; VIDEO EXAMPLES
Components: examples; Name: "{group}\example\video\video player"; Filename: "{app}\example\video_player\video_player.exe"; IconFilename: "{app}\example\video_player\icon.ico"; WorkingDir: "{app}\example\video_player\"

; WIDGET EXAMPLES
Components: examples; Name: "{group}\example\widget\widget browser"; Filename: "{app}\example\widget_browser\widget_browser.exe"; IconFilename: "{app}\example\widget_browser\icon.ico"; WorkingDir: "{app}\example\widget_browser\"

; EXTENSION EXAMPLES
Components: examples; Name: "{group}\example\extension\error handler"; Filename: "{app}\example\error_handler\error_handler.exe"; IconFilename: "{app}\example\error_handler\icon.ico"; WorkingDir: "{app}\example\error_handler\"
Components: examples; Name: "{group}\example\extension\settings simple"; Filename: "{app}\example\settings\settings_simple\settings_simple.exe"; IconFilename: "{app}\example\settings\settings_simple\icon.ico"; WorkingDir: "{app}\example\settings\settings_simple\"
Components: examples; Name: "{group}\example\extension\settings widgets"; Filename: "{app}\example\settings\settings_with_widgets\settings_with_widgets.exe"; IconFilename: "{app}\example\settings\settings_with_widgets\icon.ico"; WorkingDir: "{app}\example\settings\settings_with_widgets\"
Components: examples; Name: "{group}\example\extension\highscore"; Filename: "{app}\example\highscore\highscore.exe"; IconFilename: "{app}\example\highscore\icon.ico"; WorkingDir: "{app}\example\highscore\"
Components: examples; Name: "{group}\example\extension\resource loading"; Filename: "{app}\example\resource_loading\resource_loading.exe"; IconFilename: "{app}\example\resource_loading\icon.ico"; WorkingDir: "{app}\example\resource_loading\"
Components: examples; Name: "{group}\example\extension\template"; Filename: "{app}\example\template\my_project_name.exe"; IconFilename: "{app}\example\template\icon.ico"; WorkingDir: "{app}\example\template\"

; GRAPHIC EXAMPLES
Components: examples; Name: "{group}\example\graphic\animation"; Filename: "{app}\example\animation\animation.exe"; IconFilename: "{app}\example\animation\icon.ico"; WorkingDir: "{app}\example\animation\"
Components: examples; Name: "{group}\example\graphic\bitmap font"; Filename: "{app}\example\bitmap_font\bitmap_font.exe"; IconFilename: "{app}\example\bitmap_font\icon.ico"; WorkingDir: "{app}\example\bitmap_font\"
Components: examples; Name: "{group}\example\graphic\drawable"; Filename: "{app}\example\drawable\drawable.exe"; IconFilename: "{app}\example\drawable\icon.ico"; WorkingDir: "{app}\example\drawable\"
Components: examples; Name: "{group}\example\graphic\3D texture"; Filename: "{app}\example\em3d_texture\em3d_texture.exe"; IconFilename: "{app}\example\em3d_texture\icon.ico"; WorkingDir: "{app}\example\em3d_texture\"
Components: examples; Name: "{group}\example\graphic\figure zoom"; Filename: "{app}\example\figure_zoom\figure_zoom.exe"; IconFilename: "{app}\example\figure_zoom\icon.ico"; WorkingDir: "{app}\example\figure_zoom\"
Components: examples; Name: "{group}\example\graphic\hello 3d world"; Filename: "{app}\example\hello_3d_world\hello_3d_world.exe"; IconFilename: "{app}\example\hello_3d_world\icon.ico"; WorkingDir: "{app}\example\hello_3d_world\"
Components: examples; Name: "{group}\example\graphic\hello glsl world"; Filename: "{app}\example\hello_glsl_world\hello_glsl_world.exe"; IconFilename: "{app}\example\hello_glsl_world\icon.ico"; WorkingDir: "{app}\example\hello_glsl_world\"
Components: examples; Name: "{group}\example\graphic\hello world"; Filename: "{app}\example\hello_world\hello_world.exe"; IconFilename: "{app}\example\hello_world\icon.ico"; WorkingDir: "{app}\example\hello_world\"
Components: examples; Name: "{group}\example\graphic\lovely"; Filename: "{app}\example\lovely\lovely.exe"; IconFilename: "{app}\example\lovely\icon.ico"; WorkingDir: "{app}\example\lovely\"
Components: examples; Name: "{group}\example\graphic\never ending background"; Filename: "{app}\example\never_ending_background\never_ending_background.exe"; IconFilename: "{app}\example\never_ending_background\icon.ico"; WorkingDir: "{app}\example\never_ending_background\"
Components: examples; Name: "{group}\example\graphic\normalized"; Filename: "{app}\example\normalized\normalized.exe"; IconFilename: "{app}\example\normalized\icon.ico"; WorkingDir: "{app}\example\normalized\"
Components: examples; Name: "{group}\example\graphic\objects 3d"; Filename: "{app}\example\objects_3d\objects_3d.exe"; IconFilename: "{app}\example\objects_3d\icon.ico"; WorkingDir: "{app}\example\objects_3d\"
Components: examples; Name: "{group}\example\graphic\procedures"; Filename: "{app}\example\procedures\procedures.exe"; IconFilename: "{app}\example\procedures\icon.ico"; WorkingDir: "{app}\example\procedures\"
Components: examples; Name: "{group}\example\graphic\racing 3d"; Filename: "{app}\example\racing_3d\racing_3d.exe"; IconFilename: "{app}\example\racing_3d\icon.ico"; WorkingDir: "{app}\example\racing_3d\"
Components: examples; Name: "{group}\example\graphic\tunnel"; Filename: "{app}\example\tunnel\tunnel.exe"; IconFilename: "{app}\example\tunnel\icon.ico"; WorkingDir: "{app}\example\tunnel\"
Components: examples; Name: "{group}\example\graphic\vision2"; Filename: "{app}\example\vision2\vision.exe"; IconFilename: "{app}\example\vision2\icon.ico"; WorkingDir: "{app}\example\vision2\"

; GAMES EXAMPLES
Components: examples; Name: "{group}\example\games\brick breaker"; Filename: "{app}\example\brick_breaker\brick_breaker.exe"; IconFilename: "{app}\example\brick_breaker\icon.ico"; WorkingDir: "{app}\example\brick_breaker\"

; HELP
Components: program;  Name: "{group}\help\eiffelmedia homepage"; Filename: "{app}\website.url"
Components: program;  Name: "{group}\help\eiffelmedia documentation"; Filename: "{app}\doc\index.html"
Components: program;  Name: "{group}\help\eiffelmedia folder"; Filename: "{app}"; Flags: foldershortcut

; TOOLS
Components: program;  Name: "{group}\tools\polygon editor"; Filename: "{app}\tools\polygon_editor\polygon_editor.exe"; IconFilename: "{app}\tools\polygon_editor\icon.ico"; WorkingDir: "{app}\tools\polygon_editor\"

; UNINSTALL
Components: program;  Name: "{group}\uninstall eiffelmedia"; Filename: "{uninstallexe}"




