indexing

	description: "[

		EiffelMedia POLYGON_EDITOR application.

	]"
	date: "$Date: 2005-10-28 09:59:20 +0200 (Fri, 28 Oct 2005) $"
	revision: "$Revision: 1365 $"

class POLYGON_EDITOR

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

	EM_SHARED_ERROR_HANDLER
		export {NONE} all end
create

	make

feature {NONE} -- Initialisation

	make (arguments: ARRAY [STRING]) is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (Window_width)
			Video_subsystem.set_video_surface_height (Window_height)
			Video_subsystem.set_video_bpp (Screen_resolution)
			Video_subsystem.set_fullscreen (Fullscreen)
			Video_subsystem.enable

			initialize_screen

			-- Check subsystem initialisation
			if Video_subsystem.is_enabled then

				-- Set global options
				set_window_title ("EiffelMedia: Polygon Editor")
				set_window_icon ("icon.png")

				create keyboard.make_snapshot
				keyboard.enable_unicode_characters
				keyboard.enable_repeating_key_down_events (200, 80)

				Error_handler.set_verbose (False)
				video_subsystem.set_cursor_visibility (True)
				load_eclipse_theme

				-- Set first scene and launch it
				set_scene (create {POLYGON_EDITOR_SCENE}.make)

				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				io.error.put_string ("Failed to initialise video subsystem.%N")
			end
		end

feature {NONE} -- Implementation

	Window_width: INTEGER is 1024
			-- Window width

	Window_height: INTEGER is 768
			-- Window height

	Screen_resolution: INTEGER is 32
			-- Screen resolution

	Fullscreen: BOOLEAN is false
			-- Fullscreen?

end