indexing
	description: "[

		Base class for 2D-Plots (like line-charts or bar-charts)
		
		Z-interval is implicitly set from -1.0 to 0.0, which can
		be exploited by plotters that want to utilize the depth of the
		box also, e.g. a ribbon-plotter.

	]"
	author: ""
	date: "$Date: 2007-02-12 08:14:24 +0100 (Mon, 12 Feb 2007) $"
	revision: "$Revision: 2505 $"

deferred class
	EM_VIZ_PLOT_2D

inherit
	EM_VIZ_PLOT [EM_VECTOR2D, EM_VIZ_PLOTTER [EM_VECTOR2D]]

feature -- Initialization

	make_plot_2d (a_size: like size; a_x_interval, a_y_interval: EM_INTERVAL) is
			-- Make new 2d-plot
		local
			a_z_interval: EM_INTERVAL
		do
			a_z_interval := [-1.0, 0.0]
			make_plot (a_size, [a_x_interval, a_y_interval, a_z_interval])
		end

end
